Package: SEERaBomb
Title: SEER and Atomic Bomb Survivor Data Analysis Tools
Version: 2019.2
Date: 2019-12-12
Description: Creates SEER (Surveillance, Epidemiology and End Results) and 
    A-bomb data binaries from ASCII sources and provides tools for estimating
    SEER second cancer risks. Methods are described in <doi:10.1038/leu.2015.258>.
Authors@R: c(person("Tomas", "Radivoyevitch", role = c("aut", "cre"),
                     email = "radivot@ccf.org"),
              person("R.", "Molenaar", role = "ctb",
                     email = "r.j.molenaar@amc.uva.nl"))
Depends: dplyr, ggplot2, rgl, demography
Suggests: bbmle
License: GPL (>= 2)
Imports: Rcpp (>= 0.11.3), reshape2, mgcv, tibble, LaF, DBI, RSQLite,
        openxlsx, WriteXLS, labelled, scales, forcats, purrr,readr,
        tidyr, stringr, plyr, survival
LinkingTo: Rcpp
LazyData: yes
URL: http://epbi-radivot.cwru.edu/SEERaBomb/SEERaBomb.html
NeedsCompilation: yes
Packaged: 2019-12-12 18:25:36 UTC; radivot
Author: Tomas Radivoyevitch [aut, cre],
  R. Molenaar [ctb]
Maintainer: Tomas Radivoyevitch <radivot@ccf.org>
Repository: CRAN
Date/Publication: 2019-12-12 18:50:03 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 14:02:27 UTC; unix
Archs: SEERaBomb.so.dSYM

useDynLib(SEERaBomb, .registration = TRUE)
#import(dbplyr)  ## too many warnings, so let user of mkSEER figure out to install this
import(dplyr)  ## depends
import(ggplot2)  ## depends
#import(tibble)  ## depends
import(demography)  ## depends
#import(LaF,RSQLite,rgl,XLConnect) ## needed less critically but for too many functions to list
import(LaF,RSQLite,rgl,openxlsx,labelled) ## needed less critically but for too many functions to list
importFrom(Rcpp, evalCpp)
importFrom(survival, survfit,Surv)
importFrom(DBI, dbDriver)
importFrom(mgcv, gam,s,ti)
importFrom(plyr, ldply)
importFrom(WriteXLS, WriteXLS)
importFrom(reshape2, melt, acast,dcast)
importFrom(scales, comma_format)
importFrom(forcats, as_factor)
importFrom(purrr, map,pmap)
importFrom(readr, read_table)
importFrom(tidyr, separate,gather,spread,unnest)
importFrom(tibble, as_tibble)
importFrom(stringr, str_replace_all,str_to_title,str_detect)
importFrom("stats","quantile", "qpois", "D", "median", "qchisq", "qt", "rexp", "rpois", "runif", "var", "weighted.mean","lm","predict")
importFrom("utils", "data", "head", "read.csv", "tail")
exportPattern("^[[:alpha:]]+")
##S3method(autoplot,seerSet)
S3method(summary,seerSet)
S3method(print,seerSet.summary)

# results here were too noisy to include in the paper
rm(list=ls()); library(tidyverse); library(SEERaBomb)
load("~/data/SEER/mrgd/popsae.RData") #get popsae
(p=popsae%>%count(race,sex,age,year,wt=py)%>%rename(py=n))
load("~/data/SEER/mrgd/cancDef.RData") #get canc 
canc$cancer=fct_collapse(canc$cancer,AML=c("AML","AMLti","APL"))
secs=c("CML","AML","ALL") #second cancers of interest
(d=canc%>%filter(cancer%in%c("brain",secs)))
d%>%count(cancer,trt)%>%print(n=30)
pf=seerSet(d,p,Sex="Female") #pooled (races) females 
pm=seerSet(d,p,Sex="Male") 
pf=mk2D(pf,secondS=secs)# adds secs background rates to pf
pm=mk2D(pm,secondS=secs)
trts=c("rad.chemo", "rad.noChemo", "noRad.chemo", "noRad.noChemo")
pf=csd(pf, brkst=c(0,1,2,3,5,10), brksa=c(0,60), trts=trts, firstS="brain")
pm=csd(pm, brkst=c(0,1,2,3,5,10), brksa=c(0,60), trts=trts, firstS="brain")
DF=bind_rows(pf$DF,pm$DF)
DF=DF%>%mutate(cancer2=fct_relevel(cancer2,"AML")) #make AML 1st factor level
DF$t=DF$t+c(0,0.075,0.15) #shift times to see overlaid error bars in plots
D=DF%>%group_by(int,rad,chemo,cancer2)%>%summarize(O=sum(O),E=sum(E),t=mean(t))
D=D%>%mutate(RR=O/E,rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E))
graphics.off();quartz(width=4,height=2.5)
myt=theme(legend.position=c(.25, .95),legend.title=element_blank(),
          legend.direction="horizontal",legend.margin=margin(0,0,0,0),
          legend.key.height = unit(.25, 'lines'))
g=ggplot(aes(x=t,y=RR,col=cancer2),data=D)+geom_point()+geom_line()+myt+
  labs(x="Years Since Brain Cancer Diagnosis",y="Relative Risk of Leukemia")
g=g+facet_grid(rad~chemo)+geom_abline(intercept=1, slope=0) 
g+geom_errorbar(aes(ymin=rrL,ymax=rrU),width=0.1) +coord_cartesian(ylim=c(0,30))
ggsave("~/Results/tutorial/brain2leu.pdf") 

rm(list=ls())  
library(SEERaBomb);library(tidyverse);library(ggsci)
load("~/data/SEER/mrgd/cancDef.RData") 
canc$cancer=fct_collapse(canc$cancer,AML=c("AML","AMLti","APL"))
load("~/data/SEER/mrgd/popsae.RData") 
leus=c("AML","ALL","CML")
d=incidSEER(canc,popsae,leus)
d=d%>%filter(age<=85,year>=2000)
d=d%>%mutate(ageG=cut(age,seq(0,85,5)))
d=d%>%group_by(cancer,ageG)%>%
  summarize(age=mean(age),py=sum(py),n=sum(n))%>%
  mutate(incid=n/py,grp="Background")
d=d%>%select(cancer,grp,everything(),-ageG)#reorder columns
NHM=c("breast","thyroid","brain","renal")#NHM=non-heme malignancy
brksa=c(0,40,50,60,70,80)#broad 1st interval avoids 0 CML groups
system.time(ra<-riskVsAge(canc,firstS=NHM,secondS=leus,brksa=brksa))#~15s
raCML=riskVsAge(canc,firstS=c("AML","ALL"),secondS="CML",brksa=brksa)
D=bind_rows(ra,raCML)
D=D%>%filter(rad!="Unk",chemo!="Unk")
D=D%>%group_by(cancer2,rad,chemo,age)%>%
  summarize(py=sum(py),n=sum(o),incid=n/py)
D=D%>%rename(cancer=cancer2)%>%unite(grp,rad,chemo,sep=", ")
dd=bind_rows(D,d)
ord=c("Rad, Chemo","No Rad, Chemo","Rad, No Chemo",
      "No Rad, No Chemo","Background")
dd$grp=factor(dd$grp,levels=ord)
dd$cancer=factor(dd$cancer,levels=c("AML","ALL","CML"))
myt=theme(legend.position=c(.25,.22),legend.title=element_blank(),
          legend.direction="vertical",legend.margin=margin(0,0,0,0),
          legend.key.height=unit(.65,'lines'),strip.background=element_blank())
ggplot(dd,aes(x=age,y=incid,col=grp))+geom_line()+facet_grid(~cancer)+
  xlab("Attained Age (Years)")+scale_x_continuous(breaks=c(0,25,50,75))+
  ylab(quote(paste("Cases per ",10^5," Person-Years")))+scale_color_jco()+
  scale_y_log10()+coord_cartesian(ylim=c(0.01,40))+theme_classic()+myt
ggsave("~/Results/tutorial/seerLeu.pdf",width=3.5,height=2.5)#Fig.5

# dd=dd%>%mutate(LL=qpois(0.025,n)/py,UL=qpois(0.975,n)/py) #look at some CI
# dd%>%filter(cancer=="CML",grp%in%c("Rad, Chemo","Rad, No Chemo"))%>%arrange(age)
# dd%>%filter(cancer=="AML",grp%in%c("Rad, Chemo","No Rad, Chemo"))%>%arrange(age)
# dd%>%filter(cancer=="ALL",grp%in%c("Rad, Chemo","No Rad, Chemo"))%>%arrange(age)

# incidAllFirsts.R (Figure 2)
rm(list=ls()) 
library(SEERaBomb)
library(ggplot2)
library(dplyr)
load("~/data/SEER/mrgd/cancDef.RData")
load("~/data/SEER/mrgd/popsae.RData") 
HM=c("AML","MDS","CMML","CML","MPN","ALL","CLL","SLL","HCL","OL","NHL","MM","HL","LGL")

graphics.off()
quartz(height=4.5,width=7) 
# theme_set(theme_bw())
theme_update(legend.position = c(.85, .21),
             axis.text = element_text(size = rel(1.5)),
             plot.title = element_text(size = rel(1.7),hjust = 0.5),
             axis.title = element_text(size = rel(1.5)),
             legend.text = element_text(size = rel(1.5)),
             legend.title = element_text(size = rel(1.5))      )

for (HSC in c(FALSE,TRUE)) {
  if (HSC)
    m=canc%>%filter(cancer%in%HM)%>%mutate(age=agedx+0.5)%>%
      group_by(sex,age)%>%summarise(cases=n()) else
        m=canc%>%filter(!cancer%in%HM)%>%mutate(age=agedx+0.5)%>%
          group_by(sex,age)%>%summarise(cases=n()) 
      
      pops=popsae%>%group_by(sex,age)%>%summarise(py=sum(py))
      head(m)
      s=data.frame(sex=sort(unique(m$sex)))
      pL=left_join(s,pops)
      head(pL)
      d=left_join(pL,m)
      d=d%>%mutate(py=py/1e5,incid=cases/py)
      head(d)
      names(d)[1]="Sex"
      levels(d$Sex)=c("Male","Female")
      g=qplot(age,incid,col=Sex,data=d,
              main=ifelse(HSC,"All Hematologic Cancers Combined","All Non-Hematologic Cancers Combined"),
              ylab="Cases/100,000 Person-Years",
              xlab="Age",log="y")+geom_line() 
      # g=g+ggtitle(ifelse(HSC,"Hematological Cancers","Non-Hematological Cancers"))
      # g = g + scale_color_grey(start = 0, end = 0.6)
      if (HSC) {brks=c(0,25,50,75,100)} else{
        g=g+ geom_vline(xintercept = c(40,50,65),col="gray")
        brks=c(0,25,40,50,65,75,100)
      }
      g=g+scale_x_continuous(breaks=brks,labels=brks)
      print(g)
      if (HSC) ggsave("~/Results/amlMDS/allCancersCombVsAgeHSC.pdf") else
        ggsave("~/Results/amlMDS/allCancersCombVsAge.pdf")
      if (HSC) ggsave("~/Results/amlMDS/allCancersCombVsAgeHSC.png") else
        ggsave("~/Results/amlMDS/allCancersCombVsAge.png")
}
d=d%>%group_by(age)%>%mutate(r=incid[1]/incid[2])
head(d)
d$r
mean(d$r)

# amlAbombTsx.R (time since exposure plot)
# Uses data of Hsu et al. The Incidence of Leukemia ... among Atomic Bomb
# Survivors: 1950-2001. Radiat. Res. 179, 361-382 (2013).
(3.5/9)^0.5 # 0.623 Gy is the average whole body risk equivalent of a typical radiation therapy
rm(list=ls()) 
library(dplyr)
# library(SEERaBomb)
# mkAbomb() # if you haven't made abomb.db yet
db <- src_sqlite("~/data/abomb/abomb.db")
src_tbls(db)    #see what tables are in it
collect(tbl(db, sql("SELECT * from hemeDesc"))) 
d=collect(tbl(db, sql("SELECT * from heme"))) 
head(d)
sapply(d,class)
# (d=d%>%select(city:un4gy,agexG:calG,py,agex:year,AML:AMLtot,D))
# d=round(d,2)
negs=d%>%filter(D<0) 
sum(negs$AMLtot) # 16 AMLs with unknown doses
sum(negs$py) # 200k py
d=d%>%filter(D>=0) 
sum(d$AMLtot) # 176 AMLs (= eligible AML cases in Table 1 of Hsu et al)
sum(d$py) #3,613,406 is pretty close to 3,613,404 in Table 2 of Hsu et al  

d$Dc=cut(d$D,breaks=c(0,0.005,0.1,0.2,0.5,1,2,10),include.lowest=TRUE,right=F)
head(d,2)
d%>%group_by(Dc)%>%summarize(PY=sum(py),AML=sum(AMLtot)) # reproduces PY in Hsu Table 2
d%>%group_by(calg)%>%summarize(PY=sum(py),AML=sum(AMLtot)) 
# merge calg=14 with 13
d$calg[d$calg==14]=13
d%>%group_by(calg)%>%summarize(PY=sum(py),AML=sum(AMLtot))#last group has more PY now
(years=d%>%group_by(calg)%>%summarize(aveY=weighted.mean(year,py))) 
(Year=round(years$aveY,1)) #time points in years
(Tsx=round(years$aveY,1)-1945.7) #time since exposure in years, for plotting
head(d)
d=d%>%mutate(aml=AMLtot,sv=D,tsx=age-agex,city=city-1,sex=sex-1)%>%select(-(AML:AMLtot),-year,-Dc,-D)
d=d%>%mutate(svc=cut(sv,c(-1,.01,.4,10),labels=c("low","med","high")),agec=cut(age,seq(0,110,10)))
head(d,3)
agem=seq(5,110,10) # midpoints of age intervals

# pool across city and sex to get background expected values
(BKPY=with(d,tapply(py,list(sv=svc,age=agec),sum,na.rm=TRUE)))  
sum(BKPY)
bkCounts=with(d,tapply(aml,list(sv=svc,age=agec),sum,na.rm=TRUE)) 
(X=data.frame(age=agem,cnts=bkCounts[1,],py=BKPY[1,]))
library(mgcv)
bkg=gam(cnts ~ s(age)+offset(log(py)),family=poisson(),data=X,method="REML") 
X$Ecases=exp(predict(bkg))
X$Eincid=X$Ecases/X$py
X$incid=X$cnts/X$py
with(X,plot(age,Eincid,type="l"))
with(X,points(age,incid))

d$bk=as.numeric(exp(predict(bkg,newdata=d))/d$py) # numerator is expected cases
with(d,plot(age,bk))
X0=c(rep(-10,13))
flin<-function(L)  {
  d$mn = d$bk*(1+d$sv^2*exp(L[d$calg]))*d$py # relative risk quad in dose
  -sum(d$aml*log(d$mn) - d$mn,na.rm=T)
}
range(d$calg)
head(d)
sol=optim(X0,flin,method="L-BFGS-B",control=list(maxit=400));sol  # the idea here is to let the data speak through L, a bit like a one way anova
wait=exp(sol$par)+1
plot(Year,wait,pch=5,col="red",type="b",ylab="w(t)",main="IR-to-AML waiting time pdf shape")

# repeat with bbmle
library(bbmle)
d=transform(d,calg=as.factor(calg)) 
(s=summary(m<-mle2(aml~dpois(lambda=py*bk*(1+sv^2*exp(f))),
                   parameters=list(f~-1 + calg),
                   start=list(f=-5),data=d) )  )
ci=confint(m)
wait=exp(coef(s)[,1])
waitL=exp(coef(s)[,1]-1.96*coef(s)[,2])
waitU=exp(coef(s)[,1]+1.96*coef(s)[,2])
waitLp=exp(ci[,1])
waitUp=exp(ci[,2]) # profile versions
(dfc=data.frame(Tsx,data.frame(wait,waitL,waitU,waitLp,waitUp)+1 ))
dfc[is.na(dfc)]=0 # minus infinity maps to zero, so set them there

library(ggplot2)
quartz(width=6.5,height=4)
theme_update(plot.title = element_text(size = rel(2.3)),
             axis.title = element_text(size = rel(2.3)),
             axis.text = element_text(size = rel(2.3))) 
p=ggplot(dfc, aes(x=Tsx, y=wait)) +  geom_point(size=6) 
p=p+labs(x="Years since exposure",y="AML RR (1 Sv)") + 
  scale_x_continuous(breaks=seq(0,50,by=10),limits=c(0,55))
p=p+geom_errorbar(aes(ymin=waitLp, ymax=waitUp),width=.01)
p+geom_abline(intercept=1, slope=0)
ggsave("~/Results/amlMDS/RRtsxAMLabomb.png")

# specificFirstRRR.R  (Radiation Relative Risk variant of specificFirst.R)
rm(list=ls())
library(SEERaBomb)
library(reshape2)
system.time(load("~/Results/amlMDS/pm.RData")) # 4 secs to load. 
system.time(load("~/Results/amlMDS/pf.RData")) # 4 secs to load.
.simpleCap <- function(s) paste(toupper(substring(s, 1, 1)), substring(s, 2),sep = "", collapse = " ")

names(pm$L)
hires=TRUE
hires=FALSE
if (hires) {
  brks=c(0,0.25,0.5,0.75,1,1.5,2,2.5,3,4,5,6,8,10,12)
  FirstS=c("prostate","breast") # first cancers to be plotted 
}   else {  # intermediate level resolution
  FirstS=c("NHL","lung")
  brks=c(0,1,2,3,6,9,12)  
}
dm=mkDF(pm,brks)
df=mkDF(pf,brks)
d=rbind(cbind(df,Sex="Female"),cbind(dm,Sex="Male"))
d=d%>%filter(cancer1%in%FirstS)%>%select(Sex,cancer1,cancer2,trt,O,E,t,int)
d=d%>%filter(!((cancer1=="breast")&(Sex=="Male"))) # remove male breast cancer cases
head(d)
tail(d)



mkRRR=function(d,first,Ncol=5000) {
#   first="prostate"
  d0=d%>%filter(cancer1==first,trt=="noRad")
  di=d%>%filter(cancer1==first,trt=="rad")
  O=d0$O
  E=d0$E
  Oi=di$O
  Ei=di$E
  Xi=matrix(0,ncol=Ncol,nrow=length(Oi))
  X=matrix(0,ncol=Ncol,nrow=length(O))
  for (i in 1:Ncol) Xi[,i]=rpois(n=length(Oi),lambda=Oi)
  for (i in 1:Ncol) X[,i]=rpois(n=length(O),lambda=O)
  X=(Xi/X)*(E/Ei)%*%t(rep(1,Ncol))
  T=t(apply(X,1,function(x) quantile(x,probs=c(0.025,0.5,0.975),na.rm=TRUE)))
  data.frame(Sex=d0$Sex,cancer1=d0$cancer1,cancer2=d0$cancer2,RR=T[,2],L=T[,1],U=T[,3],t=d0$t)
}

graphics.off()
quartz(width=7,height=4)
theme_set(theme_bw())
theme_update(legend.position = "none")
theme_update(axis.text=element_text(size=rel(1.2)),
             axis.title=element_text(size=rel(1.3)),
             legend.title=element_text(size=rel(0.9)),
             legend.text=element_text(size=rel(0.9)),
             strip.text = element_text(size = rel(1.5)))

for (First in FirstS) {
  (D=mkRRR(d,First))
  g=qplot(x=t,y=RR,data=D,geom=c("line","point"),#xlim=c(-.1,24),
          xlab=paste("Years Since",.simpleCap(First),"First Cancer"),ylab="Radiation Relative Risk Ratio")
  if (First=="breast"|First=="prostate") g=g+facet_grid(cancer2~.,scales="free")+geom_abline(intercept=1, slope=0) else
    g=g+facet_grid(Sex~cancer2,scales="free")+geom_abline(intercept=1, slope=0) #g=g+scale_y_continuous(breaks=1:10)
  g=g+geom_errorbar(aes(ymin=L,ymax=U,width=.15))
  print(g)
  ggsave(paste0("~/Results/amlMDS/",First,ifelse(hires,"hires",""),"RRR.png"))
  ggsave(paste0("~/Results/amlMDS/",First,ifelse(hires,"hires",""),"RRR.eps"))
} # for loop on first types

#NOTE: this script is outdated now that "CUSTOM".zip data files are available
d=read.csv("~/data/SEER/crt.csv")
names(d)=c("casenum","seqnum","RT","CT")
crt=d%>%select(casenum,seqnum,CT,RT)
save(crt,file="~/data/SEER/crt.RData")
head(crt)
load("~/data/SEER/crt.RData")
load("~/data/SEER/mrgd/cancDef.RData")
levels(crt$seqnum)
head(crt$seqnum)
x=strsplit(as.character(crt$seqnum), "[^0-9]+")
crt$seq=sapply(x,function(y) y[[1]])
crt$seq[crt$seqnum=="One primary only"]=0
crt$seq[crt$seqnum=="Only one state registry-defined neoplasm"]=60
crt$seq[crt$seqnum=="Unknown seq num - federally required in situ or malig tumors"]=99
crt$seq[crt$seqnum=="Unknown seq num - state registry-defined neoplasms"]=88
(S=paste0(1:27,"th of ",1:27," or more state registry-defined neoplasms"))
for (i in 1:27)  crt$seq[crt$seqnum==S[i]] = 60+i
crt$seq=as.integer(crt$seq)
crt$seq[1:800]
crt$ct=as.integer(crt$CT)-1
levels(crt$RT)
crt$radiatn=9  # 9 is gone, so shouldn't be any left after below
crt$radiatn[crt$RT=="None/Unknown"]=0
crt$radiatn[crt$RT=="Beam radiation"]=1
crt$radiatn[crt$RT=="Radioactive implants"]=2
crt$radiatn[crt$RT=="Radioisotopes"]=3
crt$radiatn[crt$RT=="Combination of beam with implants or isotopes"]=4
crt$radiatn[crt$RT=="Radiation, NOS  method or source not specified"]=5
crt$radiatn[crt$RT=="Other radiation (1973-1987 cases only)"]=6
crt$radiatn[crt$RT=="Refused"]=7
crt$radiatn[crt$RT=="Recommended, unknown if administered"]=8
head(crt,20)
cr=crt%>%select(casenum,seqnum=seq,ct,radiatn)
d=left_join(canc,cr)
canc=d
canc$trt="noRad"
canc$trt[canc$radiatn==8]="unk"
canc$trt[canc$radiatn%in%c(1:6)]="rad"
save(canc,file="~/data/SEER/cancCRT.RData")

###ageTherapyEx4.R
d=incidSEER(canc,popsae,secs)
d=d%>%filter(age<=85,year>=2000)
d=d%>%mutate(ageG=cut(age,seq(0,85,5)))
d=d%>%group_by(cancer,ageG)%>%
  summarize(age=mean(age),py=sum(py),n=sum(n))%>%
  mutate(incid=n/py,grp="Background")
d=d%>%select(cancer,grp,everything(),-ageG)#reorder columns
#the next 3 lines defines a set of non-heme-malignacies
HM=c(secs,"MDS","CMML","MPN","CLL","HCL","OL","NHL","MM","HL","LGL")
sc=canc%>%filter(agedx<50,yrdx<2000)#based on frequency at younger ages
(NHM=setdiff(names(sort(table(sc$cancer),decr=T)[1:8]),HM))#non-hemes
brksa=c(0,40,50,60,70,80)#broad 1st interval avoids 0 CML groups
system.time(D<-riskVsAge(canc,firstS=NHM,secondS=secs,brksa=brksa))#~36s
D=D%>%filter(rad!="Unk",chemo!="Unk")
D=D%>%group_by(cancer2,rad,chemo,age)%>%
  summarize(py=sum(py),n=sum(o),incid=n/py)
D=D%>%rename(cancer=cancer2)%>%unite(grp,rad,chemo,sep=", ")
dd=bind_rows(D,d)%>%filter(age>=20)
ord=c("Rad, Chemo","No Rad, Chemo","Rad, No Chemo",
      "No Rad, No Chemo","Background")
dd$grp=factor(dd$grp,levels=ord)
dd$cancer=factor(dd$cancer,levels=secs)
myt=theme(legend.position=c(.7,.83),legend.key.height=unit(.65,'lines'))
dd=dd%>%mutate(LL=qpois(0.025,n)/py,UL=qpois(0.975,n)/py)#make CI
dd=dd%>%mutate(ages=age+(as.numeric(grp)-3))#shift ages to see CI
dd%>%ggplot(aes(x=ages,y=incid,col=grp))+gl+facet_grid(~cancer)+gxi+
  agts+gyi+jco+sy+tc(11)+ltb+sbb+myt+ge
ggsave("~/Results/tutorial/ageTherapyEx4.pdf",width=3.5,height=2.5)

rm(list=ls()) 
library(SEERaBomb)
load("~/data/SEER/mrgd/cancDef.RData")
load("~/data/SEER/mrgd/popsae.RData")
pm=seerSet(canc,popsae,Sex="Male")
pm=mk2D(pm,secondS=c("CML","CMML","MDS","AML","CLL","ALL")) # pooled race male leukemias 
plot2D(pm)
pm

t(canc%>%filter(cancer=="MDS")%>%group_by(yrdx)%>%summarise(count=n()))
t(canc%>%filter(cancer=="CMML")%>%group_by(yrdx)%>%summarise(count=n()))
t(canc%>%filter(cancer=="CML")%>%group_by(yrdx)%>%summarise(count=n()))

# france2019.R
graphics.off();rm(list=ls())#clear plots and environment
library(tidyverse);library(SEERaBomb);library(ggsci);library(bbmle)
load("~/data/SEER/mrgd/cancDef.RData")#load SEER cancer data
load("~/data/usMort/mrt.RData")#loads US mortality data
gp=geom_point();gl=geom_line()
geRR=geom_errorbar(aes(ymin=rrL,ymax=rrU),width=.2)
ge=geom_errorbar(aes(ymin=LL,ymax=UL),width=0.2)#for absolute risks
gh=geom_hline(yintercept=1)
gh2=geom_hline(yintercept=2,col="gray")
svts=scale_x_continuous(breaks=c(0,5,10))#surv times
agts=scale_x_continuous(breaks=c(25,50,75))#age times
sbb=theme(strip.background=element_blank())
ltb=theme(legend.margin=margin(0,0,0,0),legend.title=element_blank())
ltp=theme(legend.position="top")
lh=theme(legend.direction="horizontal")
sy=scale_y_log10()
cc=coord_cartesian(ylim=c(0,10))#clips high errorbars
jco=scale_color_jco()
tc=function(sz) theme_classic(base_size=sz);
gxi=xlab("Age (Years)")
gyi=ylab(quote(paste("Cases per ",10^5," Person Years")))

d=canc%>%filter(cancer=="CML")%>%print(n=13)
d%>%summarize(n=n(),na=sum(is.na(surv)),prct=100*na/n)#<2% missing
d=d%>%filter(!is.na(surv))
d=d%>%mutate(status=as.numeric(COD>0),surv=(surv+0.5)/12)
d=d%>%select(yrdx,agedx,sex,surv,status)%>%print(n=13)
(D=msd(d,mrt,brkst=c(0,0.5,1,2,3,4,5,6,8),brksy=c(1975,2001,2017)))
D=D%>%filter(Years!=levels(D$Years)[1]) 
D=D%>%group_by(int,Years)%>%summarize(O=sum(O),E=sum(E),t=mean(t,na.rm=T))
D=D%>%mutate(RR=O/E,rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E))
gx=xlab("Years Since CML Diagnosis")
gy=ylab("Relative Risk of Mortality")
myt=theme(legend.text=element_text(size=12),strip.text=element_text(size=12))
D%>%ggplot(aes(x=t,y=RR))+gp+gx+gy+gh+gh2+
  jco+tc(14)+ltb+ltp+sbb+ylim(c(0,NA))+geRR+myt+scale_y_continuous(breaks=c(1,2,5,10,15))

summary(m1<-mle2(O~dpois(lambda=(1+k1*exp(c1-k1*t)+k2*exp(c2-k2*t)+c3)*E),
                 # parameters=list(c3~sex),
                 method="Nelder-Mead",start=list(c1=0,c2=0,k1=1,k2=1,c3=1),data=D,
                 control=list(maxit=10000)))  #-2 log L: 187.3446 
pd=data.frame(t=seq(0,15,0.1),E=100)
(ds=data.frame(sex=c("Male","Female")))
pd=merge(ds,pd)
pd$Err=predict(m1,pd)/pd$E
head(pd)

D%>%ggplot(aes(x=t,y=RR))+gp+gx+gy+gh+gh2+ #facet_wrap(~sex)+
  geom_line(aes(y=Err),size=.5,alpha=.4,data=pd)+coord_cartesian(ylim=c(0,10))+
  svts+jco+tc(14)+ltb+ltp+sbb+ylim(c(0,10))+geRR+myt+scale_y_continuous(breaks=c(1,2,5,10))
ggsave("~/Results/CML/france19A.pdf",width=4,height=3)

sm1=summary(m1)
(cf=coef(sm1))
(m1=round(cbind(point=cf[,1],LL=cf[,1]-1.96*cf[,2],UL=cf[,1]+1.96*cf[,2]),2))
(P=signif(cf[,4],2))
parms=row.names(cf)
(str=str_c(parms," = ",m1[,1]," (",m1[,2],", ",m1[,3],"), P = ",P,collapse="; "))


library(survminer);library(survival)
ds=d%>%filter(yrdx>2001)
Ds=simSurv(ds,mrt)
fit=survfit(Surv(surv,status)~type,data=Ds)
gy=ylab("Survival Probability")
labs=c("Observed","Expected")
ggsurvplot(fit,Ds,legend.title="",legend.labs=labs,break.time.by=5,xlim=c(0,12),xlab="Years Since Diagnosis") 
ggsave("~/Results/CML/france19B.pdf",width=4,height=3)
Ds
S=summary(fit)
I=which((S$time>9.999)&(S$time<10.001))
S$time[I]
S$surv[I]
S$surv[I]^2/S$surv[I]
S$upper[I]
S$lower[I]
head(S)

# prosBreastTimeCrs.R   (RR time courses after Prostate and Breast first cancers)
rm(list=ls())
library(dplyr)
library(ggplot2)
library(reshape2)
library(SEERaBomb)
system.time(load("~/Results/CLL/pm.RData")) # 4 secs to load. 
system.time(load("~/Results/CLL/pf.RData")) # 4 secs to load. 
Dm=mkDF(pm)
Df=mkDF(pf)
Dm=Dm%>%filter(cancer1=="prostate")
Df=Df%>%filter(cancer1=="breast")
Dm$cancer="Prostate"
Df$cancer="Breast"
D=rbind(Dm,Df)
D$Radiation="No"
D$Radiation[D$trt=="rad"]="Yes"
D$Period="Early"
D$Period[D$t>5]="Late"
D=D%>%select(int,t,RR,L=rrL,U=rrU,Radiation,Period,cancer)
head(D)

graphics.off()
quartz(width=7,height=3.7)

theme_set(theme_bw())
theme_update(legend.position = c(.65, .45),
             axis.text=element_text(size=rel(1.2)),
             axis.title=element_text(size=rel(1.3)),
             legend.title=element_text(size=rel(0.9)),
             legend.text=element_text(size=rel(0.9)),
             strip.text = element_text(size = rel(1.5)))
g=qplot(x=t,y=RR,data=D,col=Radiation,geom=c("line","point"),#xlim=c(-.1,24),
        xlab="Years Since Diagnosis of First Cancer",ylab="CLL Relative Risk")
g=g+scale_y_log10(breaks=c(0.3,1,10),labels=c("0.3","1","10"),limits=c(0.15,30))
g=g+facet_grid(cancer~Period,scales="free")+geom_abline(intercept=0, slope=0)
g=g+  geom_errorbar(aes(ymin=L,ymax=U,width=.05))
g = g + scale_color_grey(start = 0, end = 0.6)
g
ggsave("~/Results/CLL/prosBrsTimCrs.eps")  

# Figure 4 of current MS. CML incidence by race for 2000-2010
require(bbmle) 
load("/data/SEER/00/pops.RData") # this loads in pops
pyf=pym=vector(3,mode="list"); 
for (i in 0:18) { for (r in 1:2) {
		pym[[r]][i+1]=with(pops,sum(population[(popsex==1)&(popage==i)&(poprace==r)]))
		pyf[[r]][i+1]=with(pops,sum(population[(popsex==2)&(popage==i)&(poprace==r)]))}
	pym[[3]][i+1]=with(pops,sum(population[(popsex==1)&(popage==i)&(poprace>2)]))
	pyf[[3]][i+1]=with(pops,sum(population[(popsex==2)&(popage==i)&(poprace>2)])) }
p0=c(c0=-10,k=.04)
fexp<-function(p,dat){	c0=p[1];k=p[2]; 
	with(dat,{mn=exp(c0+k*(age[6:19]-55))*py[6:19]
				-sum(cases[6:19]*log(mn) - mn)})  }
nLL<-function(c0,k,x) with(x,{mn=exp(c0+k*(age-55))*py
				-sum(stats::dpois(cases, mn, log=TRUE))})

if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
graphics.off();windows(width=12,height=5,xpos=-150)
par(mfrow=c(1,3),mar=c(4.7,0,0,0),oma=c(0,7.1,4,0.2),lwd=3,cex.lab=2.8,cex.axis=2.5,cex.main=2.8)
load("/data/SEER/00/lymyleuk.RData") # this loads in DF
for (i in 1:3) {
	if (i==3) d=DF[(DF$histo2==9863)&(DF$numprims==1)&(DF$race>2)&(DF$race<98),] else 
		d=DF[(DF$histo2==9863)&(DF$numprims==1)&(DF$race==i),] 
	N=sum(table(d$race))
	m=hist(d$agerec[d$sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
	f=hist(d$agerec[d$sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
	age=c(0.5,3,seq(7.5,87.5,5))
	plot(age,m/pym[[i]],log="y",xlab="Age",type='p',col='blue',pch=1,ylab="",cex=2,yaxt="n",ylim=c(2e-7,1.5e-4)  )
	lines(age,f/pyf[[i]],type='p',col='red',cex=2,pch=2)  
	ssolm=optim(p0,fexp,method="L-BFGS-B",dat=dm<-data.frame(age,cases=m,py=pym[[i]]))
	ssolf=optim(p0,fexp,method="L-BFGS-B",dat=df<-data.frame(age,cases=f,py=pyf[[i]]))
	ym=exp(ssolm$par["c0"]+ssolm$par["k"]*(age[6:19]-55))
	yf=exp(ssolf$par["c0"]+ssolf$par["k"]*(age[6:19]-55))
	if (i==1) axis(side=2,las=1, at=c(1e-6,1e-5,1e-4),labels=expression(1,10,10^2))
	lines(age[6:19],ym,col="blue"); lines(age[6:19],yf,col="red")
	MF=mean(ym/yf);       Tau=log(MF)/((ssolm$par["k"]+ssolf$par["k"])/2)  
	if (i==1) mtext(expression(paste("Cases per ",10^6," Person-Years")),side=2,line=3.8,cex=2)
	if (i==1) mtext(paste(N,"whites\nM/F =",format(MF,dig=2),"\nT =",format(Tau,dig=2),"Yrs"),side=1,line=-5.5,cex=1.5,adj=0.95)
	if (i==2) mtext(paste(N,"blacks\nM/F =",format(MF,dig=2),"\nT =",format(Tau,dig=2),"Yrs"),side=1,line=-5.5,cex=1.5,adj=0.95)
	if (i==3) mtext(paste(N,"others\nM/F =",format(MF,dig=2),"\nT =",format(Tau,dig=2),"Yrs"),side=1,line=-5.5,cex=1.5,adj=0.95)
	legend(-5,2.4e-4,c(paste("Males      k =",format(ssolm$par["k"],dig=2)),paste("Females  k =",format(ssolf$par["k"],dig=2))),
			col=c("blue","red"),pch=1:2,text.col=c("blue","red"),bty="n",cex=2) 
	fit0m <- mle2(nLL,start=list(c0=-10,k=.04),data=list(x=dm[6:19,]))
	fit0f <- mle2(nLL,start=list(c0=-10,k=.04),data=list(x=df[6:19,]))
	(CIF=cbind(coef(fit0f),confint(fit0f)))
	(CIM=cbind(coef(fit0m),confint(fit0m)))
	legend(43,2.4e-4,c(sprintf("(%s, %s)",format(CIM[2,2], digits=2),format(CIM[2,3], digits=2)),
					sprintf("(%s, %s)",format(CIF[2,2], digits=2),format(CIF[2,3], digits=2))),
			text.col=c("blue","red"),bty="n",cex=2)
}
title("CML Incidence in SEER 2000-2010",cex=3,outer=T)

###common.R
graphics.off();rm(list=ls())#clear plots and environment
library(tidyverse);library(SEERaBomb);library(ggsci)#load packages          
library(survival);library(survminer);library(bbmle)
load("~/data/SEER/mrgd/cancDef.RData")#load SEER cancer data
load("~/data/SEER/mrgd/popsae.RData")#load SEER population data
load("~/data/abomb/abomb.RData")#load A-bomb data
load("~/data/usMort/mrt.RData")#loads US mortality data
canc$cancer=fct_collapse(canc$cancer,AML=c("AML","AMLti","APL"))
secs=c("AML","ALL","CML")#second cancers of interest
gp=geom_point();gl=geom_line()
geRR=geom_errorbar(aes(ymin=rrL,ymax=rrU),width=.2)
ge=geom_errorbar(aes(ymin=LL,ymax=UL),width=0.2)#for absolute risks
gh=geom_hline(yintercept=1)
svts=scale_x_continuous(breaks=c(0,5,10))#surv times
agts=scale_x_continuous(breaks=c(25,50,75))#age times
sbb=theme(strip.background=element_blank())
ltb=theme(legend.margin=margin(0,0,0,0),legend.title=element_blank())
ltp=theme(legend.position="top")
lh=theme(legend.direction="horizontal")
sy=scale_y_log10()
jco=scale_color_jco()
tc=function(sz) theme_classic(base_size=sz);
gxi=xlab("Age (Years)")
gyi=ylab(quote(paste("Cases per ",10^5," Person Years")))

# This reproduces Fig S4 in  Radivoyevitch et al Blood 119, 4363-4371 (2012)
rm(list=ls(all=TRUE))
load("~/data/seer/73/pops.RData") # this loads in pops
pym=NULL;pyf=NULL
for (i in 0:18) 
{   pym[i+1]=with(pops,sum(population[(popsex==1)&(popage==i)&(popyear<2009)]))
	pyf[i+1]=with(pops,sum(population[(popsex==2)&(popage==i)&(popyear<2009)])) }

mylog<-function(x,fitEXP) if (fitEXP) x else log(x) 
fexp<-function(p,dat,fitEXP)	{	c0=p[1];k=p[2]; 
	with(dat,{mn=exp(c0+k*mylog(age,fitEXP))*py 
				-sum(cases*log(mn) - mn)})	}

load("~/data/SEER/73/lymyleuk.RData") # this loads in DF
# morphCodes=c(CML=9863,APL=9866)
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
graphics.off();
windows(width=8,height=8)
par(mfrow=c(2,2),mar=c(4.7,0,2.3,0),oma=c(4.4,6,0.4,0.4),lwd=3,cex.lab=1.8,cex.axis=1.7,cex.main=1.8)
for (fitEXP in c(TRUE,FALSE))
# 	for (i in names(morphCodes)) {
	for (i in c("CML","APL")) {
		d=DF[(DF$cancer==i)&(DF$seqnum<2)&(DF$yrdx<2009),]
		d$agerec=as.numeric(cut(d$agedx,breaks=c(0,1,seq(5,85,5),130)))
		m=hist(d$agerec[d$sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
		f=hist(d$agerec[d$sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
		age=c(0.5,3,seq(7.5,87.5,5))
		plot(age,m/pym,log="y",xlab="Age",col='blue',ylim=c(5e-7,1e-4),yaxt="n",ylab="",main=i)
		points(age,f/pyf,col='red'); 
		if (i=="CML") {
			mtext(expression(paste("Cases per ",10^6," Person-Years")),side=2,line=3.6,cex=1.5)
			axis(side=2,las=1,at=c(5e-7,1e-6,5e-6,1e-5,5e-5),labels=c(0.5,1,5,10,50))}
		datam=data.frame(age,cases=m,py=pym,incid=m/pym)[6:19,] 
		dataf=data.frame(age,cases=f,py=pyf,incid=f/pyf)[6:19,]
		p0=c(c0=-10,k=ifelse(fitEXP,.04,1))
# 		ssolm=optim(p0,fexp,method="L-BFGS-B",dat=datam,fitEXP=fitEXP)
# 		ssolf=optim(p0,fexp,method="L-BFGS-B",dat=dataf,fitEXP=fitEXP)
		ssolm=optim(p0,fexp,dat=datam,fitEXP=fitEXP)
		ssolf=optim(p0,fexp,dat=dataf,fitEXP=fitEXP)
		ym=exp(ssolm$par["c0"]+ssolm$par["k"]*mylog(age[6:19],fitEXP))
		yf=exp(ssolf$par["c0"]+ssolf$par["k"]*mylog(age[6:19],fitEXP))
		lines(age[6:19],ym,col="blue"); lines(age[6:19],yf,col="red")
		km<-format(ssolm$par["k"], digits=2);kf<-format(ssolf$par["k"], digits=2)
		mtext(ifelse(fitEXP,expression(y==Ae^{k%.%age}),expression(y==A%.%age^k)),side=3,line=-2.5,cex=1.3,adj=.05)
		mtext(bquote(k[m] == .(km)),side=3,line=-4,cex=1.3,adj=.05,col="blue")
		mtext(bquote(k[f] == .(kf)),side=3,line=-5.7,cex=1.3,adj=.05,col="red")
	} # the i loop
legend("bottomright",c("Males","Females"),col=c("blue","red"),cex=1.2,pch=1,bty="n")

###csdEx3.R
(d=canc%>%filter(sex=="Female",cancer%in%c("breast",secs)))
pf=seerSet(d,popsae,Sex="Female")#pooled (races) females 
pf=mk2D(pf,secondS=secs)#adds secs background rates to pf
trts=c("rad.chemo","rad.noChemo","noRad.chemo","noRad.noChemo")
pf=csd(pf,brkst=c(0,1,2,3,5,10),brksa=c(0,60),trts=trts,firstS="breast")
(dA=pf$DF%>%filter(ageG=="(0,60]")) 
gy=ylab("Relative Risk of Leukemia")
myt=theme(legend.key.height=unit(.25,'lines'),legend.position=c(.5,.95))
cc=coord_cartesian(ylim=c(0,25))#clips high errorbars
gx=xlab("Years Since Breast Cancer Diagnosis")
dA%>%ggplot(aes(x=t,y=RR,col=cancer2))+facet_grid(rad~chemo)+ 
  gp+gl+gx+gy+gh+geRR+tc(14)+ltp+cc+jco+sbb+ltb+myt+lh
ggsave("~/Results/tutorial/breastEx3A.pdf",width=4,height=4) 

(d=canc%>%filter(cancer%in%c("thyroid",secs)))
pf=seerSet(d,popsae,Sex="Female");pm=seerSet(d,popsae,Sex="Male") 
pf=mk2D(pf,secondS=secs);pm=mk2D(pm,secondS=secs)
trts=c("rad.noChemo","noRad.noChemo")
pf=csd(pf,brkst=c(0,1,2,3,5,10),brksa=c(0,60),trts=trts,firstS="thyroid")
pm=csd(pm,brkst=c(0,1,2,3,5,10),brksa=c(0,60),trts=trts,firstS="thyroid")
DF=bind_rows(pf$DF,pm$DF)
D=DF%>%group_by(int,rad,cancer2)%>%summarize(O=sum(O),E=sum(E),t=mean(t))
D=D%>%mutate(RR=O/E,rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E))
Dtop=D%>%mutate(grp=str_c(rad,": All Ages"))
D=DF%>%filter(rad=="Rad")
D=D%>%group_by(int,ageG,cancer2)%>%summarize(O=sum(O),E=sum(E),t=mean(t))
D=D%>%mutate(RR=O/E,rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E))
D$ageG=c("Age 0-60","Age >60")[D$ageG]
Dbot=D%>%mutate(grp=str_c("Rad: ",ageG))
dB=bind_rows(Dtop,Dbot)
dB$grp=as_factor(dB$grp)#orders by occurrence, as wanted
gx=xlab("Years Since Thyroid Cancer Diagnosis")
dB%>%ggplot(aes(x=t,y=RR,col=cancer2))+facet_wrap(~grp)+ 
          gp+gl+gx+gy+gh+geRR+tc(14)+myt+cc+jco+sbb+ltb+ltp+myt+lh
ggsave("~/Results/tutorial/thyroidEx3B.pdf",width=4,height=4)

graphics.off();rm(list=ls())
library(SEERaBomb)#version 2018.1 or higher is needed for this tutorial
load("~/data/SEER/mrgd/cancDef.RData")
d=canc%>%filter(cancer=="CML")%>%print(n=13)
d%>%summarize(n=n(),na=sum(is.na(surv)),prct=100*na/n)#<2% missing
d=d%>%mutate(status=as.numeric(COD>0),surv=(surv+0.5)/12)#move into mkSEER?
d=d%>%select(yrdx,agedx,sex,surv,status)%>%print(n=13)
load("~/data/usMort/mrt.RData")#loads mrt
(D=msd(d,mrt,brkst=c(0,0.5,1,2,3,4,5,6,8),brksy=c(1973,1990,2005,2015)))
(g=qplot(x=t,y=RR,data=D,col=Years,geom=c("line","point"),facets=.~sex,
        xlab="Years Since CML Diagnosis",ylab="Relative Risk of Mortality"))
(g=g+scale_x_continuous(breaks=seq(0,15,5)))
library(ggsci);jco=scale_color_jco();tc=theme_classic(base_size=14)
(g=g+jco+tc+theme(legend.position="top",legend.title=element_blank(),
           strip.background=element_blank(),
           legend.text=element_text(size=12),
          strip.text=element_text(size=12)))
(g=g+geom_abline(intercept=1,slope=0)+ylim(c(0,NA)))
g+geom_errorbar(aes(ymin=rrL,ymax=rrU),width=.2)
ggsave("~/Results/tutorial/CMLmortRR.pdf",width=4.5,height=3)

labs=c("1973-1990","1991-2005","2006-2015")
d=d%>%mutate(yrg=cut(yrdx,c(1972,1990,2005,2015),labels=labs))%>%print(n=13)
library(survival);library(survminer)
fit=survfit(Surv(surv,status)~yrg+sex,data=d) 
ggsurvplot_facet(fit,d,facet.by=c("sex"),ylab="Survival Probability",
          xlab="Years Since CML Diagnosis",legend.title="",
          xlim=c(0,12),short.panel.labs=T)+
  scale_x_continuous(breaks=seq(0,15,5))+
  jco+theme(strip.background=element_blank(),strip.text=element_text(size=12),
            legend.text=element_text(size=12))
ggsave("~/Results/tutorial/CMLsurvTrends.pdf",width=4.5,height=3)

# timeCoursePlots.R  (for Figure 2 and S5)
# first run amlMDScomputing.R, then this
rm(list=ls())
library(dplyr)
library(reshape2)
library(ggplot2)
library(SEERaBomb)
graphics.off()
system.time(load("~/Results/amlMDS/pm.RData")) 
system.time(load("~/Results/amlMDS/pf.RData")) 
brks=c(0,0.25,0.5,0.75,1,1.5,2,2.5,3,4,5,6,8,10,12)
# heme malignancies (HM) excluded are
HM=c("AML","MDS","CMML","CML","MPN","ALL","CLL","SLL","HCL","OL","NHL","MM","hodgkin")
dm=mkDF(pm,brks)
df=mkDF(pf,brks)
sapply(df,class)
d=rbind(cbind(df,Sex="Female"),cbind(dm,Sex="Male"))
d=d%>%filter(!cancer1%in%HM)%>%group_by(Sex,trt,cancer2,int)%>%summarize(O=sum(O),E=sum(E),t=weighted.mean(t,py,na.rm=T))
d=d%>%mutate(RR=O/E, rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E))
head(d)


############# First Fig 2, then Fig S5, since calcs for Fig 2 are also used for Fig S5
# theme_set(theme_bw())
theme_update(legend.position = c(.92, .825),
             axis.text=element_text(size=rel(1.2)),
             axis.title=element_text(size=rel(1.3)),
             axis.title.x=element_text(size=rel(1.0)),
             legend.title=element_text(size=rel(1)),
             legend.text=element_text(size=rel(1)),
             strip.text = element_text(size = rel(1.5)))
xlabNR="Years Since Dx of Non-Hematologic 1st Cancer Not Treated With Radiation"
xlabR="Years Since Dx of Non-Hematologic 1st Cancer Treated With Radiation"
# for Figure 2 (NR (no radiation) = FALSE => radiation)
for (NR in c(TRUE,FALSE)) { 
  # NR=TRUE
  # NR=FALSE
  quartz(width=7,height=4)
  if (NR) D=d%>%filter(trt=="noRad") else D=d%>%filter(trt=="rad")
  D[D$cancer2=="MDS","t"]=D[D$cancer2=="MDS","t"]+0.05 # shift for CI visibility
  g=qplot(x=t,y=RR,data=D,col=cancer2,geom=c("line","point"),#ylim=c(.45,2.9),
          xlab=ifelse(NR,xlabNR,xlabR),ylab="Relative Risk")
  g=g+facet_grid(Sex~.,scales="free")+geom_abline(intercept=1, slope=0)
  # g = g + scale_color_grey(start = 0, end = 0.6)
  g1 <- guide_legend("Second\nCancer")
  g=g + guides(color=g1) 
  g=g+  geom_errorbar(aes(ymin=rrL,ymax=rrU,width=.15))+scale_y_continuous(breaks=1:6)
  print(g)
  if (NR) ggsave("~/Results/amlMDS/fig2ANR.eps")  else
    ggsave("~/Results/amlMDS/fig2A.eps")  
#   if (NR) ggsave("~/Results/amlMDS/fig2ANR.png")  else
#     ggsave("~/Results/amlMDS/fig2A.png")  
} # loop on NR

############ START Figure S5
system.time(load("~/Results/amlMDS/pm9.RData")) # 4 secs to load. 
system.time(load("~/Results/amlMDS/pf9.RData")) # 4 secs to load.
dm9=mkDF(pm9,"b0_0.25_0.5_0.75_1_1.5_2_2.5_3")
df9=mkDF(pf9,"b0_0.25_0.5_0.75_1_1.5_2_2.5_3")
d9=rbind(cbind(df9,Sex="Female"),cbind(dm9,Sex="Male"))
d9=d9%>%filter(!cancer1%in%HM)%>%group_by(Sex,trt,cancer2,int)%>%summarize(O=sum(O),E=sum(E),t=weighted.mean(t,py,na.rm=T))
d9=d9%>%mutate(RR=O/E, rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E))
head(d9)
d9$DB="SEER-9"
d$DB="SEER-18"
D=bind_rows(d9,d)
sapply(D,class)
D=D%>%filter(t<3,cancer2=="MDS",trt=="rad")
head(D)
quartz(width=7,height=3.3)
theme_update(legend.position = c(.65, .81),
             axis.text=element_text(size=rel(1.2)),
             axis.title=element_text(size=rel(1.3)),
             legend.title=element_text(size=rel(1.1)),
             legend.text=element_text(size=rel(1.1)),
             strip.text = element_text(size = rel(1.5)))
g=qplot(x=t,y=RR,data=D,col=Sex,geom=c("line","point"),xlim=c(-.1,3),ylim=c(0,5),
        xlab=xlabR,ylab="MDS Relative Risk")
g=g+facet_grid(.~DB)+geom_abline(intercept=1, slope=0)
g+  geom_errorbar(aes(ymin=rrL,ymax=rrU,width=.15))
ggsave("~/Results/amlMDS/mds9vs18.eps")  
ggsave("~/Results/amlMDS/mds9vs18.png")  

# using dplyr with SEER data
rm(list=ls()) 
library(dplyr)
db <- src_sqlite("~/data/SEER/mrgd/cancDef.db")
src_tbls(db)    #see what tables are in it
tbl(db, sql("SELECT * from canc")) # see field names of canc
tbl(db, sql("SELECT * from popsa")) # and popga

# If you want all the rows and columns, it's faster to just load() the data.frame binary
# system.time(d<-collect(tbl(db, sql("SELECT * from canc")))) #17 secs

# db2 <- src_sqlite("~/data/SEER/mrgd/cancAll.db")
# system.time(d<-collect(tbl(db2, sql("SELECT * from canc")))) #123 secs, 123/17= 7.2
system.time(load("~/data/SEER/mrgd/cancDef.RData")) #3 secs Here Def stands for default picks in pickFields
# system.time(load("~/data/SEER/mrgd/cancAll.RData")) #30 secs
# The latter also has the advantage of keeping factor level orders. The DBs store them as strings. 

# for smaller tables and subsets of large tables, the times are negligible
collect(tbl(db, sql("SELECT * from popsa")))
# (2011-1973)*18*3*2*19 # =77976 > 54009 rows ... conditions have no person years. py=0 => no row
(mds1<-collect(tbl(db, sql("SELECT db,reg,race,sex,agedx,yrdx,COD,surv from canc where yrdx>2000 and histo3>9979 and histo3<9990"))))
# 40k MDS cases   DB was indexed on histO3 so it is fast (0.1 secs) to find the MDS cases
# Meanwhile, while
canc  # is slow to print (because it is so big)

# getting MDS cases from it  is also  fast
mds2=canc%>%
#   mutate(age=age19)%>%
  filter(yrdx>2000,histo3>9979,histo3<9990)%>%
  select(db,reg:agedx,yrdx,COD,surv,age86)
mds2
# and it has the advantage of using my original factor level orderings
table(mds2$race)
table(mds1$race)


# 1) Plot MDS incidence versus year, sex, race, and reg

# a) make a table of interest

# first group cases into 86, mostly 1-year, age buckets
mds=mds2%>%
  mutate(year=yrdx)%>%  #let year=yrdx to match population column below
  group_by(reg,db,race,sex,age86,year) %>%                                     
  summarise(cases=n())
mds
sum(mds$cases)

# now get person years
load("~/data/SEER/mrgd/popsa.RData") 
(p=popsa%>%filter(year>2000))
(d=left_join(p,mds)) 
d[is.na(d$cases),"cases"]=0 #join left missings where zero's should be, so fix this
sum(d$cases) # 40k mds cases, check.
(d1=d%>%group_by(year)%>%summarise(cases=sum(cases),py=sum(py),Incid=cases/py))
library(ggplot2)
graphics.off() # kill any left over windows
qplot(year,Incid,data=d1,ylim=c(0,6e-5),ylab="MDS Incidence") 

d=d%>%filter(year>=2006) #use only stable portion of the data. 

# look at variation across registries
(d1=d%>%group_by(db,reg)%>%
   summarise(cases=sum(cases),py=sum(py),Incid=cases/py,
             lo=Incid-1.96*sqrt(cases)/py,hi=Incid+1.96*sqrt(cases)/py ))

theme_set(theme_gray(base_size = 12)) 
qplot(reg,Incid,data=d1,ylim=c(0,8e-5),col=db,ylab="MDS Incidence (Cases/Person-Year)",xlab="SEER Registry") + 
  geom_errorbar(aes(ymin=lo,ymax=hi)) 
library(SEERaBomb)
mapRegs()

sort(table(canc$reg),decr=T)

# look at incidence vs. age for sexes and races
(d1=d%>%group_by(sex,race,age86)%>%summarise(Incid=sum(cases)/sum(py) ))
theme_set(theme_gray(base_size = 22)) 
qplot(age86,Incid,col=sex,shape=race,data=d1,log="y",ylab="MDS Incidence (Cases/Person-Year)",xlab="Age (years)")+geom_line()
# too much confusion
# trying fewer bins below doesn't help
(d1=d%>%mutate(agec=cut(age86,c(0,50,70,80,100)))%>%group_by(sex,race,agec)%>%summarise(Incid=sum(cases)/sum(py) ))
d1$agem=c(25,60,75,85)[d1$agec]
theme_set(theme_gray(base_size = 22)) 
qplot(agem,Incid,col=sex,shape=race,data=d1,log="y",ylab="MDS Incidence (Cases/Person-Year)",xlab="Age (years)")+geom_line()

with(canc,table(sex,race))

# look at survival vs. sex, age and race
library(survival)
(mds=mds2%>%filter(surv<1000)) # 1000=83 yrs. This is to get rid of some entries of 9999=survival unknown
mds=mds%>%filter(yrdx>=2006)%>%mutate(agec=cut(age86,c(0,50,70,80,100)))
coxph(Surv(surv,COD>0)~sex,data = mds) 
coxph(Surv(surv,COD>0)~sex+agec,data = mds) 
coxph(Surv(surv,COD>0)~sex+agec+race,data = mds) 
(cm=coxph(Surv(surv,COD>0)~sex+agec+race+reg,data = mds))  #best off being treated in the bay area

mkPYM <- function(PY,nyears) {
    PYM=.Call('mkPYM', PACKAGE = 'SEERaBomb', PY[,1], PY[,2], PY[,3],nyears)
#     print(nyears)
    dim(PYM)=c(126,nyears)
    colnames(PYM)=1973:(1973+nyears-1)
    rownames(PYM)=0.5:125.5
    PYM
}

# Figure 1 of current MS. Differs from Blood Fig 5a in using 2000-2010, not 1973-2008
seerHome="/data/SEER"
load(file.path(seerHome,"00/pops.RData")) # this loads in pops
pym=NULL;pyf=NULL
for (i in 0:18) 
{   pym[i+1]=with(pops,sum(population[(popsex==1)&(popage==i)]))
	pyf[i+1]=with(pops,sum(population[(popsex==2)&(popage==i)])) }

load(file.path(seerHome,"00/lymyleuk.RData")) # this loads in DF
d=DF[(DF$histo3==9945)&(DF$numprims==1),] 
m=hist(d$agerec[d$sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
f=hist(d$agerec[d$sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
age=c(0.5,3,seq(7.5,87.5,5))
datam=data.frame(age,cases=m,py=pym,incid=m/pym)[6:19,] 
dataf=data.frame(age,cases=f,py=pyf,incid=f/pyf)[6:19,]

if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
windows(width=6,height=6,xpos=-150)
par(mfrow=c(1,1),mar=c(4.7,6,3.3,1),oma=c(0,0,0,0),lwd=3,cex.lab=1.8,cex.axis=1.7,cex.main=1.8)
with(datam,plot(age,incid,log="y",xlab="Age",col='blue',pch=1,
				ylab="",cex=2,yaxt="n",ylim=c(0.5e-7,1.5e-4),xlim=c(22,87)))
with(dataf,points(age,incid,col='red',cex=2,pch=2))

fexp<-function(p,dat)	{	c0=p[1];k=p[2]; 
	with(dat,{mn=exp(c0+k*age)*py
				-sum(cases*log(mn) - mn)})	}
ssolm=optim(c(c0=-10,k=.04),fexp,method="L-BFGS-B",dat=datam)
ssolf=optim(c(c0=-10,k=.04),fexp,method="L-BFGS-B",dat=dataf)
ym=exp(ssolm$par["c0"]+ssolm$par["k"]*age[6:19])
yf=exp(ssolf$par["c0"]+ssolf$par["k"]*age[6:19])
axis(side=2,las=1, at=c(1e-7,1e-6,1e-5,1e-4),labels=expression(.1,1,10,10^2))
lines(age[6:19],ym,col="blue")
lines(age[6:19],yf,col="red")
mtext(expression(paste("Cases per ",10^6," Person-Years")),side=2,line=3.5,cex=2)
title("CMML Incidence: SEER 2000-2010")
legend(19,2.8e-4,c(paste("Males      k =",format(ssolm$par["k"], digits=4)),
				paste( "Females  k =",format(ssolf$par["k"],digits=4))),
		col=c("blue","red"),pch=1:2,text.col=c("blue","red"),bty="n",cex=1.4)

# double check with mle2 and get k CI
require(bbmle) 
nLL<-function(c0,k,x) with(x,{mn=exp(c0+k*age)*py
				-sum(stats::dpois(cases, mn, log=TRUE))})
fit0m <- mle2(nLL,start=list(c0=-10,k=.04),data=list(x=datam))
fit0f <- mle2(nLL,start=list(c0=-10,k=.04),data=list(x=dataf))
(CIF=cbind(coef(fit0f),confint(fit0f)))
(CIM=cbind(coef(fit0m),confint(fit0m)))

legend(55,2.8e-4,c(sprintf("(%s, %s)",format(CIM[2,2], digits=3),format(CIM[2,3], digits=3)),
				sprintf("(%s, %s)",format(CIF[2,2], digits=3),format(CIF[2,3], digits=3))),
		col=c("blue","red"),text.col=c("blue","red"),bty="n",cex=1.4)

aBombHome="~/data/abomb"
load(file.path(aBombHome,"Hema87.RData"));
names(d)
d=d[d$py>0,] #remove two recs with zero py
d=d[d$kerma==1,] # take only kerma < 4 Gy
d$py=10^4*d$py
d$calg=as.integer(cut(d$calg,c(0,2,4,6,8,10)))
head(d)
m=d[d$sex==1,]; f=d[d$sex==2,] 

flin<-function(x,df) {
  c1=x[1];k=x[2];L=x[3:7];   		
  with(df,{mn = exp(c1+k*age)*py + sv*exp(L[calg])*py;
           -sum(CML*log(mn) - mn)})	}

# the idea here is to let the data speak through L, a bit like a one way anova
X0=c(c1=-13,k=0.05,rep(-10,5))
sol=optim(X0,flin,df=m,method="L-BFGS-B",hessian=TRUE,control=list(maxit=400))  
waitm=exp(sol$par[3:7])
sol=optim(X0,flin,df=f,method="L-BFGS-B",hessian=TRUE,control=list(maxit=400))  
waitf=exp(sol$par[3:7])
# if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
# windows(width=5,height=5)
# dev.new(width=5,height=5)

par(mfrow=c(1,1),mar=c(4.7,0,2.3,0.2),lwd=3,cex.lab=1.8,cex.axis=1.7,cex.main=1.7,oma=c(0,4.5,1,0.7))
years=c(1952,1958,1966,1976,1985)-1945
plot(years,waitm,cex=2,pch=1,xlab="Years Since Exposure",ylab="",yaxt="n",col="blue",ylim=c(0,8.2e-4))
points(years,waitf,pch=2,cex=2,col="red")
legend(25,8.6e-4,c("Males","Females"),pch=1:2,col=c("blue","red"),cex=1.8,bty="n")
mtext(expression(paste("Cases per ",10^4," Person-Year-Sv")),side=2,line=2.4,cex=1.8,outer=T)
axis(side=2,las=1, at=c(0,2e-4,4e-4,6e-4,8e-4),labels=c(0,2,4,6,8),outer=T)
title("IR-to-CML Latency",outer=T,line=-1)
par(mar=c(5.1,4.1,4.1,2.1),oma=c(0,0,0,0)) # reset to standards

rm(list=ls()) 
library(SEERaBomb)
library(ggplot2)
library(dplyr)
load("~/data/SEER/mrgd/cancDef.RData")
load("~/data/SEER/mrgd/popsae.RData") 

(tb=sort(table(canc$cancer),dec=T))
CANCS=c("AML","CML","MDS")
CANCS=names(tb)  
CANCS=c("stomach","lung","melanoma","prostate")
CANCS=names(tb)[1:9]  
CANCS=c("AML","MDS","CMML","AMLti","APL","MPN","CML") # second cancers of interest
D=canc
mds="clean"
mds="all"
cutyr=2001
if (mds=="clean") D=canc%>%filter(yrdx>=cutyr,cancer%in%CANCS,histo3!=9989) else
  D=canc%>%filter(yrdx>=cutyr,cancer%in%CANCS)

D=D%>%mutate(year=yrdx,age=agedx+0.5) #let year=yrdx to match population column below
P=popsae%>%filter(year>=cutyr)

# make them all end at 98.5
D=D%>%filter(age<99)
stdUS=stdUS%>%filter(age<99)
P=P%>%filter(age<99)


r=data.frame(reg=levels(D$reg))
c=data.frame(cancer=CANCS)
cr=merge(c,r)
head(D)
head(P)
range(P$age)
m=D%>%group_by(cancer,db,reg,age)%>%summarize(cases=n())

p=P%>%group_by(db,reg,age)%>%summarise(py=sum(py))
p=left_join(cr,p)
d=left_join(p,m)
d[is.na(d$cases),"cases"]=0 #join left missings where zero's should be, so fix this

head(d)
head(stdUS)
tail(stdUS)
tail(d)

d1=d%>%  
  group_by(cancer,db,reg,age,add=F)%>%
  summarize(cases=sum(cases),py=sum(py)/1e5)%>%
  left_join(stdUS)%>%
  mutate(ai=cases/py)%>%
  summarize(vr=sum(cases*prop^2/py^2),stdIncid=weighted.mean(ai,w=prop),
            stdLo=stdIncid-1.96*sqrt(vr),stdHi=stdIncid+1.96*sqrt(vr))

# head(d1)
graphics.off()
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
windows(width=12,height=7)


theme_set(theme_gray(base_size = 12))
# theme_get()
theme_update(
#   axis.title = element_text(size = rel(3)),
  legend.direction = "horizontal" #, # c(.96, .56),  
#       plot.margin = unit(c(.5,1,.5,.5),"lines")
)
# theme_get()
  
head(d1)

ggplot(aes(x=reg,y=stdIncid,col=db),data=d1)+ 
  ylab("Age-adjusted Incidence (Cases/100,000 PY) US2000 Std")+
  xlab("SEER Registry") + 
  ggtitle(paste0("Cancers in ",cutyr,"-2015")) + 
  geom_errorbar(aes(ymin=stdLo,ymax=stdHi))+
  scale_colour_hue("Dataset", breaks = c("73", "92", "00"), labels = c("1973", "1992", "2000"))+
  theme(axis.title = element_text(size = rel(1.2)),
        legend.position = c(.87, .15),  
        axis.text.y = element_text(size = rel(1.5)),
        plot.title = element_text(size = rel(2)),
        axis.title.x = element_text(size = rel(1.7)),
        axis.title.y = element_text(size = rel(1.3)),
        strip.text = element_text(size = rel(2))
        ) +
  facet_wrap(~cancer)

if (length(CANCS)>3) ggsave("~/Results/SEERaBomb/cancersVsregs.eps") else
    ggsave(paste0("~/Results/SEERaBomb/mlVsregsMDS",mds,".eps"))

seerHome="~/data/SEER"
pops=DF=NULL # to get rid of NOTES on package check about "no visible binding" 
load(file.path(seerHome,"73/pops.RData")) # this loads in pops
pym=NULL;pyf=NULL
for (i in 0:18) 
{   pym[i+1]=with(pops,sum(population[(popsex==1)&(popage==i)&(popyear<2009)]))
    pyf[i+1]=with(pops,sum(population[(popsex==2)&(popage==i)&(popyear<2009)])) }

load(file.path(seerHome,"73/lymyleuk.RData")) # this loads in DF
head(DF,2)
levels(DF$cancer)
table(DF$cancer)["CML"]
table(DF$ICD9)["2051"] # 100 extra not accounted for
table(DF$histo3)["9863"]+table(DF$histo3)["9875"]+table(DF$histo3)["9876"]+table(DF$histo3)["9945"]
table(DF$histo3)["9863"]+table(DF$histo3)["9875"]+table(DF$histo3)["9876"]
# d=DF[(DF$histo2==9863)&(DF$numprims==1)&(DF$yrdx<2009),] # paper used SEER 1973-2008
d=DF[(DF$cancer=="CML")&(DF$seqnum<2)&(DF$yrdx<2009),] # paper used SEER 1973-2008
d$agerec=as.numeric(cut(d$agedx,breaks=c(0,1,seq(5,85,5),130)))

m=hist(d$agerec[d$sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
f=hist(d$agerec[d$sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
age=c(0.5,3,seq(7.5,87.5,5))
datam=data.frame(age,cases=m,py=pym,incid=m/pym)[6:19,] 
dataf=data.frame(age,cases=f,py=pyf,incid=f/pyf)[6:19,]

if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
windows(height=6,width=6)
par(mfrow=c(1,1),mar=c(4.7,6,3.3,1),oma=c(0,0,0,0),lwd=3,cex.lab=1.8,cex.axis=1.7,cex.main=1.8)
with(datam,plot(age,incid,log="y",xlab="Age",col='blue',pch=1,
                ylab="",cex=2,yaxt="n",ylim=c(1e-6,1e-4),xlim=c(22,87)))
with(dataf,points(age,incid,col='red',cex=2,pch=2))

fexp<-function(p,dat)	{	c0=p[1];k=p[2]; 
                        with(dat,{mn=exp(c0+k*age)*py
                                  -sum(cases*log(mn) - mn)})	}
ssolm=optim(c(c0=-10,k=.04),fexp,method="L-BFGS-B",dat=datam)
ssolf=optim(c(c0=-10,k=.04),fexp,method="L-BFGS-B",dat=dataf)
ym=exp(ssolm$par["c0"]+ssolm$par["k"]*age[6:19])
yf=exp(ssolf$par["c0"]+ssolf$par["k"]*age[6:19])
axis(side=2,las=1, at=c(1e-6,1e-5,1e-4),labels=expression(1,10,10^2))
lines(age[6:19],ym,col="blue")
lines(age[6:19],yf,col="red")
mtext(expression(paste("Cases per ",10^6," Person-Years")),side=2,line=3.5,cex=2)
title("U.S. CML Incidence 1973-2008")
legend(20,1.3e-4,c(paste("Males      k =",format(ssolm$par["k"], digits=2)),
                   paste( "Females  k =",format(ssolf$par["k"],digits=2))),
       col=c("blue","red"),pch=1:2,text.col=c("blue","red"),bty="n",cex=1.7)

# specificFirst.R (makes plots in Figure 4)
# first run amlMDScomputing.R, then start here to make time course plots 
rm(list=ls())
.simpleCap <- function(s) paste(toupper(substring(s, 1, 1)), substring(s, 2),sep = "", collapse = " ")
library(dplyr)
library(reshape2)
library(SEERaBomb)
library(grid)
graphics.off()
quartz(width=7,height=4)
theme_set(theme_bw())
theme_update(legend.position = c(.40, .75))
theme_update(axis.text=element_text(size=rel(1.2)),
             axis.title=element_text(size=rel(1.3)),
             legend.title=element_text(size=rel(0.9)),
             legend.text=element_text(size=rel(0.9)),
             strip.text = element_text(size = rel(1.5)))

system.time(load("~/Results/amlMDS/pm.RData")) 
system.time(load("~/Results/amlMDS/pf.RData")) 
names(pm$L)
hires=TRUE
hires=FALSE
if (hires) {
  FirstS=c("prostate","breast") # first cancers to be plotted 
  brks=c(0,0.25,0.5,0.75,1,1.5,2,2.5,3,4,5,6,8,10,12) 
} else {
  FirstS=c("MM","HL","NHL","lung") # first cancers to be plotted 
  brks=c(0,1,2,3,6,9,12)  # intermediate level resolution
}

dm=mkDF(pm,brks)
df=mkDF(pf,brks)
d=rbind(cbind(df,Sex="Female"),cbind(dm,Sex="Male"))
d=d%>%filter(cancer1%in%FirstS)%>%select(Sex,cancer1,cancer2,trt,RR,rrL,rrU,t,int)
d=d%>%filter(!((cancer1=="breast")&(Sex=="Male"))) # remove male breast cancer cases
d$Radiation=factor(as.numeric(d$trt),labels=c("Yes","No"))
d$trt=NULL
d$int=NULL
head(d)

for (First in FirstS) {
  D=d%>%filter(cancer1==First)
  if (First=="prostate")   theme_update(legend.position = c(.87, .87)) else 
    if (First=="breast")  theme_update(legend.position = c(.87, .87)) else 
      if (First%in%c("lung","MM"))    theme_update(legend.position = c(.58, .87)) else  
        theme_update(legend.position = c(.4, .87))
  g=qplot(x=t,y=RR,data=D,col=Radiation,geom=c("line","point"),#xlim=c(-.1,24),
          xlab=paste("Years Since",.simpleCap(First),"First Cancer"),ylab="Relative Risk")
  if (First=="breast"|First=="prostate") g=g+facet_grid(cancer2~.,scales="free")+geom_abline(intercept=1, slope=0) else
    g=g+facet_grid(Sex~cancer2,scales="free")+geom_abline(intercept=1, slope=0) #g=g+scale_y_continuous(breaks=1:10)
  # g = g + scale_color_grey(start = 0, end = 0.6)
    g=g+geom_errorbar(aes(ymin=rrL,ymax=rrU,width=.15))+ theme(legend.key.height=unit(.45, "cm"))
  print(g)
  ggsave(paste0("~/Results/amlMDS/",First,ifelse(hires,"hires",""),".eps"))
  # ggsave(paste0("~/Results/amlMDS/",First,ifelse(hires,"hires",""),".png"))
} # for loop on firsts

# Figure 3 of current MS. Differs from Fig 6 in Blood in that gender is separated and city can be too
rm(list=ls(all=TRUE))
cols=c("city","sex","doseg","agexg","calg","kerma","PY","adjPY","num.entering",
"age","agex","tsx","cal","sv","gam","neut","lymphoma","NHL","leukemia","AML","ALL","CML","ATL","MML")      
d<-read.table("/data/abomb/HEMA87.DAT", header=F,col.names=cols);
d=d[d$adjPY>0,] #remove any recs with zero py
d$adjPY=d$adjPY*1e4 # convert to real person years
d=d[d$kerma==1,] # take only kerma < 4 Gy
CITY=1  # if 0 pool both cites, else 1 = H only and 2 = N only
if (CITY>0) d=d[d$city==CITY,]#hiroshima = 1
m=d[d$sex==1,]; f=d[d$sex==2,] 
getMats<-function(m) {
	svc<-with(m,cut(sv,c(-1,.02,1,10)))
	PYT<-with(m,tapply(adjPY,list(svc,agexg),sum,na.rm=TRUE))
	AGET<-with(m,tapply(agex,list(svc,agexg),mean,na.rm=TRUE))
	CMLT<-with(m,tapply(CML,list(svc,agexg),sum,na.rm=TRUE)) 
	(CMLt=cbind(apply(CMLT[,1:4],1,sum),apply(CMLT[,5:8],1,sum),apply(CMLT[,9:13],1,sum)))
	(PYt=cbind(apply(PYT[,1:4],1,sum),apply(PYT[,5:8],1,sum),apply(PYT[,9:13],1,sum)))
	(AGEt=cbind(apply(AGET[,1:4],1,mean),apply(AGET[,5:8],1,mean),apply(AGET[,9:13],1,mean)))
	(AGEw=cbind(apply(AGET[,1:4]*PYT[,1:4],1,sum),apply(AGET[,5:8]*PYT[,5:8],1,sum),apply(AGET[,9:13]*PYT[,9:13],1,sum)))
	list(AGEtw=AGEw/PYt,incid=CMLt/PYt)}
M=getMats(m)
F=getMats(f)
brb=c("blue","red","black");pchs=c(2,1,22)
graphics.off()
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
windows(width=10,height=5)
par(mfrow=c(1,2),mar=c(4.7,0,0.5,0.9),lwd=3,cex.lab=1.8,cex.axis=2,cex.main=1.7,oma=c(0,5.5,1.4,0.7))
matplot(t(M$AGEtw),t(M$incid),log="y",type='b',ylab="",	xlab="age at exposure",
    ylim=c(1e-6,15e-4),lty=1,col=brb,cex=2.5,pch=pchs,lwd=3,cex.lab=2,yaxt="n")
axis(2,at=c(1e-6,1e-5,1e-4,1e-3),labels=c(0.1,1,10,100),las=1,cex.axis=1.7,outer=T)
mtext(expression(paste("Cases per ",10^5," Person-Year-Sv")),side=2,line=3.3,cex=1.8,outer=T)
mtext("Males",side=3,line=-2,cex=1.8,adj=0.05); text(30,25e-5,"mostly radiogenic",cex=1.5)
legend(20,1.3e-5,c("High Dose","Medium Dose","Low Dose"),pch=pchs[3:1],col=brb[3:1],cex=1.5,pt.cex=2,pt.lwd=2,bty="n")
title("Japanese A-bomb Survivors",outer=T)
par(mar=c(4.7,1,0.5,0))
matplot(t(F$AGEtw),t(F$incid),log="y",type='b',ylab="",	xlab="age at exposure",
		ylim=c(1e-6,15e-4),lty=1,col=brb,cex=2.5,pch=pchs,lwd=3,cex.lab=2,yaxt="n")
text(30,25e-5,"mostly radiogenic",cex=1.5); mtext("Females",side=3,line=-2,cex=1.8,adj=0.05)

# NOTE: This script assumes that the SEER data is in ~/data/SEER 
.seerHome="~/data/SEER" 
rm(list=ls()) # note: dot variables defined above persist through such cleanings
# install.packages("RSQLite")
# install.packages("bbmle")
# install.packages("ggplot2")
library(RSQLite)
m=dbDriver("SQLite")
library(plyr)
library(bbmle)
library(ggplot2)

con=dbConnect(m,dbname=file.path(.seerHome,"00/all.db"))
dbListTables(con)
dbListFields(con,"pops")
dbListFields(con,"respir")
# pop=dbGetQuery(con,"SELECT * from pops where popage>6 and popage<19 and poprace=1")
#Note: whites only looked the same
pop=dbGetQuery(con,"SELECT * from pops where popage>6") 
head(pop)
(pop<-ddply(pop, .(popage,popsex), summarise,py=sum(population)))
head(pop,20)
pop$popage
d=dbGetQuery(con,"SELECT * from respir where ICD9>=1620 and ICD9<=1629 
and histO3=8140 and seqnum<2") # adenos
head(d)
d$agerec=as.numeric(cut(d$agedx,breaks=c(0,1,seq(5,85,5),130)))
d=d[d$agerec>6&d$agerec<19,]
d=d[!is.na(d$agerec),]

(d<-ddply(d, .(agerec,sex), summarise,cases=length(agerec))) 
head(cbind(d,pop)) # just to see that they match up
d=cbind(d,py=pop[,"py"]) # only take the non-redundant py column
head(d)

d9=dbGetQuery(con,"SELECT * from respir where ICD9>=1620 and ICD9<=1629 
and histO3>=8070 and histO3<=8079 and seqnum<2") # squames
# and race=1 and  histO3>=8070 and histO3<=8079 and seqnum<2 and agerec>6 and agerec<19")
head(d9)
d9$agerec=as.numeric(cut(d9$agedx,breaks=c(0,1,seq(5,85,5),130)))
d9=d9[d9$agerec>6&d9$agerec<19,]
d9=d9[!is.na(d9$agerec),]


d9<-ddply(d9, .(agerec,sex), summarise,cases=length(agerec))
d9=cbind(d9,py=pop[,"py"])
head(d9)
head(d)

(d=cbind(rbind(d,d9),code=gl(2,dim(d9)[1],labels=c("adenocarcinoma","squamous cell"))) ) 
head(d)
d=transform(d,incid=1e6*cases/py)
d$sex=factor(d$sex,labels=c("Male","Female"))
age=c(0.5,3,seq(7.5,87.5,5))
d$age=age[d$agerec+1]
head(d,15)
names(d)[5]="Histology" # make legend start with capital

if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
windows(height=4,width=8) 

(p <- ggplot(d,aes(x=age,y=incid,col=Histology))+geom_point(size=5)
 + labs(title="SEER Lung Cancer Incidence",x="Age (years)",
        y=expression(paste("Cases per ",10^6," Person-Years")))    
 + scale_y_log10(limits=c(1,1500)) )
(p=p + facet_grid(~ sex))
  mythem=theme( 
  plot.title = element_text(size = rel(1.5)),
  axis.title = element_text(size = rel(1.2)),
  axis.text = element_text(size = rel(1.2)),
  strip.text = element_text(size = rel(1.2))  )
p=p+mythem
(p=p+theme(legend.position = c(.33, .2),  #           legend.direction = 'vertical',
           legend.title = element_text(size = rel(1.1)) ,
           legend.text = element_text(size = rel(1.1))  ) )  

library(SEERaBomb)
load("~/data/SEER/mrgd/cancDef.RData") #loads in canc
d=canc%>%filter(cancer=="CML")
d=d%>%mutate(status=as.numeric(COD>0),surv=(surv+0.5)/12)
d=d%>%select(yrdx,agedx,sex,surv,status)  #SEER CML survival times
# mkMrt("username", "password") #use your Human Mortality Database account info
load("~/data/usMort/mrt.RData")
brkst=c(0,0.5,1,2,3,4,5,6,8) 
brksy=c(1972,1990,2002,2015)
D=msd(d,mrt,brkst,brksy)           #msd()  = Mortality Since Diagnosis
head(D,2)
quartz(width=6,height=5)
# quartz(width=6,height=5)
theme_update(legend.position = c(.85, .37),axis.text=element_text(size=rel(1.4)),
             axis.title=element_text(size=rel(1.4)),strip.text = element_text(size = rel(1.5)))
# theme_update(legend.position=c(.48,.43),axis.text=element_text(size=rel(1.4)),
#              axis.title=element_text(size=rel(1.4)),strip.text=element_text(size=rel(1.5)))
g=qplot(x=t,y=RR,data=D,col=Years,geom=c("line","point"), ylim=c(0,18),
        xlab="Years Since CML Diagnosis",ylab="Relative Risk of Mortality")
g=g+geom_line(size=1)+facet_grid(sex~.)+geom_abline(intercept=1, slope=0) 
g+geom_errorbar(aes(ymin=rrL,ymax=rrU,width=.15))
 

rm(list=ls())
require(dplyr)
library(SEERaBomb)
# (df=getFields("~/data/SEER")) # this doesn't fly in windows since ~ maps to /users/radivot/documents
(df=getFields("/Users/radivot/data/SEER")) # so use absolute path. Here df holds the full set of data field (df) options
(rdf=pickFields(df)) # this is a reduced data field (rdf) dataframe (note fewer rows AND one extra integer/string column)
#if you get "Error in pickFields(df) : The following picks are not allowed: radiatn, chemo" you probably downloaded
# the regular SEER data. You must get the Custom data that includes radiation and chemo information in it. 
#You MUST get the data from  https://seer.cancer.gov/data/treatment.html
#DO NOT get the data from https://seer.cancer.gov/data/options.html
mkSEER(rdf,seerHome="/Users/radivot/data/SEER") #merges all cancer binaries into ~/data/SEER/mrgd/cancDef.RData (Def for default picks)

# these are the default picks for pickFields (see its help page)
defPicks=c("casenum","reg","race","sex","agedx",
        "yrbrth","seqnum","modx","yrdx","histo3",
        "ICD9","COD","surv","radiatn","chemo")

## STAGES: if you want to explore different stage fields, you may want something like this
stageFields=c("eod10sz","eod10nd","cstumsiz","dajcct","dajccn","dajccm",
        "siterwho","hststga","ajccstg","aj3seer","dajcc7t","dajcc7n","dajcc7m","dajcc7stg")
picks=c(defPicks,stageFields)
(rdf=pickFields(df,picks))
mkSEER(rdf,outFile="cancStgs",writePops=F) #80 secs + 120 secs


## ALL COLUMNS ######## make one with all columns just to see how big things 
#get. The following defeats one of the main points of this package, which is to 
#gain speed by focusing only on fields of interest. The resulting binaries are 
#thus not likely to be useful on a regular basis, but may be useful from a
#computer programming perspective for checking out speed in the limit of using all fields.
rdf=pickFields(df,picks=df$names)
#2016+ fields are crashing because they are not integers, this fixes it
rdf=pickFields(df,picks=setdiff(df$names,c("tumsizs","dsrpsg","dasrct","dasrcn","dasrcm","dasrcts","dasrcns","dasrcms","tnmednum","metsdxln","metsdxo")))
mkSEER(rdf,outFile="cancAll",writePops=F) #149 secs # runs out of memory now
# making the SQL db was an additional  ~4 minutes. 

# If you want to check to see what fields you have in a binary right now, you can do this
system.time(load("~/data/SEER/mrgd/cancDef.RData")) # 3 secs to load 10M cases is fast relative to having all fields
head(canc,2)
system.time(load("~/data/SEER/mrgd/cancALL.RData")) # which almost takes 30 secs
head(canc,2)

# #The following can be ignored. It is a note from TR to TR on how to recreate an
# #old structure of SEER binaries still needed to run certain old scripts of his.
# (df=getFields("/Users/radivot/data/SEER")) 
# (rdf=pickFields(df))
# for (i in c("73","92","00")) mkSEERold(rdf,dataset=i,mkDFs=T) #(old way) populates binaries into these folders

rm(list=ls()) 
library(SEERaBomb)
load("~/data/SEER/mrgd/cancDef.RData")
load("~/data/SEER/mrgd/popsa.RData")

p=popsa%>%group_by(sex,age86)%>%summarise(py=sum(py)/1e5)
d=canc%>%select(cancer,sex,age86)%>%group_by(cancer,sex,age86)%>%summarise(cases=n())
(D=left_join(d,p))
d=D%>%mutate(incidence=cases/py)

graphics.off()
theme_set(theme_gray(base_size = 16)) 
# theme_update(legend.position = "top")
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
windows(width=12,height=7)
ggplot(aes(x=age86,y=incidence,col=sex),data=d)+ #log="y",
      ylab("Incidence (Cases/100,000 Person-Years)")+
      xlab("Age")+geom_line(size=1)+facet_wrap(~cancer) +
  scale_y_log10(breaks=c(.01,1,100),labels=c(".01","1","100")) + theme( legend.position = c(.87, .0))  
ggsave("~/Results/SEERaBomb/incidMat.eps")
d%>%filter(cancer%in%c("breast","lung","prostate"))%>%summarise(max(incidence))

(tb=sort(table(canc$cancer),dec=T)) #liver is top 5 world-wide, pancreas and ovary deadly, MDS since 2001
ggplot(aes(x=age86,y=incidence,col=sex),data=d%>%filter(cancer%in%names(tb)[1:9]))+ 
  ylab("Incidence (Cases/100,000 Person-Years)")+
  xlab("Age")+geom_line(size=1)+facet_wrap(~cancer) +
  scale_y_log10(breaks=c(.01,1,100),labels=c(".01","1","100"))+theme(legend.position="top",strip.text=element_text(size=rel(1.4)))  
ggsave("~/Results/SEERaBomb/incidMat3x3.eps")

HM=c("AML","AMLti","APL","MDS","CMML","CML","MPN","ALL","CLL","SLL","HCL","OL","NHL","MM","HL")
ggplot(aes(x=age86,y=incidence,col=sex),data=d%>%filter(cancer%in%HM))+ 
  ylab("Incidence (Cases/100,000 Person-Years)")+
  xlab("Age")+geom_line(size=1)+facet_wrap(~cancer) +
  scale_y_log10(breaks=c(.01,1,100),labels=c(".01","1","100"))+theme(legend.position="top",strip.text=element_text(size=rel(1.4)))  
ggsave("~/Results/SEERaBomb/incidHM.eps")



(p=popsa%>%group_by(sex,age86)%>%summarise(py=sum(py)/1e5))
(d=canc%>%select(cancer,sex,age86)%>%group_by(cancer,sex,age86)%>%summarise(cases=n()))
(D=left_join(d,p))
d=D%>%mutate(incidence=cases/py)
graphics.off()
theme_set(theme_gray(base_size = 16)) 
quartz(width=12,height=7)
ggplot(aes(x=age86,y=incidence,col=sex),data=d%>%filter(cancer%in%names(tb)[1:9]))+ 
  ylab("Incidence (Cases/100,000 Person-Years)")+
  xlab("Age")+geom_line(size=1)+facet_wrap(~cancer) +
  scale_y_log10(breaks=c(.01,1,100),labels=c(".01","1","100"))+theme(legend.position="top",strip.text=element_text(size=rel(1.4)))  



#now compare male and female incidences summed over all cancers
windows(width=7,height=7)
theme_set(theme_gray(base_size = 22)) 
d=canc%>%
  select(sex,age86)%>%
  group_by(sex,age86,add=F) %>%
  summarise(cases=n())
(D=left_join(d,p))
d=D%>%mutate(incidence=cases/py)
ggplot(aes(x=age86,y=incidence,col=sex),data=d)+ #log="y",
  ylab("Incidence (Cases/100,000 Person-Years)")+
  xlab("Age")+geom_line(size=1)+geom_vline(xintercept = c(40,50,65),col="dark gray")+
  scale_y_log10(breaks=c(.01,1,100,1000),labels=c(".01","1","100","1000")) + theme( legend.position = c(.87, .075))  
 ggsave("~/Results/SEERaBomb/sumMvsF.eps")


# now zoom in on screened cancers and note discontinuities at screening ages of 40, 50 and 65
windows(width=12,height=7)
theme_set(theme_gray(base_size = 22)) 
d=canc%>%
  filter(cancer%in%c("colon","rectal","prostate","breast","CIS"))%>%
  select(cancer,sex,age86)%>%
  group_by(cancer,sex,age86) %>%
  summarise(cases=n())
(D=left_join(d,p))
d=D%>%mutate(incidence=cases/py)
qplot(age86,incidence,col=sex,data=d,xlim=c(32,73),#log="y", #ylim=c(1,1e3),
      ylab="Incidence (Cases/100,000 Person-Years)",
      xlab="Age")+geom_line()+geom_vline(xintercept = c(40,50,65),col="dark gray")+
  facet_wrap(~cancer)  +theme(strip.text = element_text(size = rel(1.3))) +
  scale_y_log10(breaks=c(10,100,1000),labels=c("10","100","1000"),limits=c(10,1000))
ggsave("~/Results/SEERaBomb/zoomScreenYrs.eps")

aBombHome="~/data/abomb"
load(file.path(aBombHome,"Hema87.RData"));
names(d)
d=d[d$py>0,] #remove two recs with zero py
d=d[d$kerma==1,] # take only kerma < 4 Gy
d$py=10^4*d$py

svc<-with(d,cut(sv,c(-1,.02,1,10)))
PYT<-with(d,tapply(py,list(svc,agexg),sum,na.rm=TRUE))
AGET<-with(d,tapply(agex,list(svc,agexg),mean,na.rm=TRUE))
CMLT<-with(d,tapply(CML,list(svc,agexg),sum,na.rm=TRUE)) 
(CMLt=cbind(apply(CMLT[,1:4],1,sum),apply(CMLT[,5:8],1,sum),apply(CMLT[,9:13],1,sum)))
(PYt=cbind(apply(PYT[,1:4],1,sum),apply(PYT[,5:8],1,sum),apply(PYT[,9:13],1,sum)))
(AGEt=cbind(apply(AGET[,1:4],1,mean),apply(AGET[,5:8],1,mean),apply(AGET[,9:13],1,mean)))
(AGEw=cbind(apply(AGET[,1:4]*PYT[,1:4],1,sum),apply(AGET[,5:8]*PYT[,5:8],1,sum),apply(AGET[,9:13]*PYT[,9:13],1,sum)))
(AGEtw=AGEw/PYt)
(incid=CMLt/PYt)
#	(incidUpper=(CMLt+2*sqrt(CMLt))/PYt)
#	(incidLow=(CMLt-2*sqrt(CMLt))/PYt)
brb=c("blue","red","black")
pchs=c(2,1,22)
graphics.off()
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )

windows(width=6,height=6)
par(mfrow=c(1,1),mar=c(4.7,5.4,1.3,.8))
matplot(t(AGEtw),t(incid),log="y",type='b',ylab=expression(paste("Cases per ",10^5," Person-Years")),
        xlab="Age at exposure",
        ylim=c(1e-6,8e-4),lty=1,col=brb,cex=2.5,pch=pchs,lwd=3,cex.lab=2,cex.axis=2,yaxt="n")
axis(2,at=c(1e-6,1e-5,1e-4),labels=c(0.1,1,10),cex.axis=2)
text(30,18e-5,"mostly radiogenic",cex=1.5)
text(37,1.3e-5,"mostly background",cex=1.5,col="blue")
legend(20,0.6e-5,c("High Dose","Medium Dose","Low Dose"),pch=pchs[3:1],col=brb[3:1],cex=1.5,pt.cex=2,pt.lwd=2)

###abombEx5.R
(d=heme%>%select(ageG:DG,age,agex,t,D,py,AML=AMLtot,ALL,CML))
myt=theme(legend.position=c(.52,.85),legend.key.height=unit(.7,'lines'))
cc=coord_cartesian(ylim=c(.2,200));f=facet_wrap(~cancer)

gx=xlab("Attained Age (Years)")
(dA=incidAbomb(d%>%group_by(ageG,DG)))
ggplot(dA,aes(x=age,y=I,col=DG))+gp+gl+gx+sy+gyi+ge+f+cc+tc(12)+myt+jco+sbb+ltb
ggsave("~/Results/tutorial/abombLeuAge.pdf",width=4,height=2.5)#Fig.5A

gx=xlab("Age at Time of Bombing (Years)")
(dB=incidAbomb(d%>%group_by(agexG,DG)))
ggplot(dB,aes(x=agex,y=I,col=DG))+gp+gl+gx+sy+gyi+ge+f+cc+tc(12)+myt+jco+sbb+ltb
ggsave("~/Results/tutorial/abombLeuAgex.pdf",width=4,height=2.5)#Fig.5B

gx=xlab("Years Since Bombing")
(dC=incidAbomb(d%>%group_by(tG,DG)))
ggplot(dC,aes(x=t,y=I,col=DG))+gp+gl+gx+sy+gyi+ge+f+cc+tc(12)+myt+jco+sbb+ltb
ggsave("~/Results/tutorial/abombLeuTsx.pdf",width=4,height=2.5)#Fig.5C

gx=xlab("Dose (Sv)")
d$DG<-cut(d$D,c(-1,.02,.25,.5,.75,1.5,100))
(dD=incidAbomb(d%>%group_by(DG)))
ggplot(dD,aes(x=D,y=I))+gp+gl+gx+sy+gyi+ge+f+cc+tc(12)+myt+jco+sbb+ltb+
  scale_x_continuous(breaks=0:2)
ggsave("~/Results/tutorial/abombLeuDoseResp.pdf",width=4,height=2.5)#Fig.5D

# setup.R
library(SEERaBomb)
# first chunk builds the SEER binaries 
(df=getFields("/Users/radivot/data/SEER")) 
(rdf=pickFields(df)) # this uses default picks of fields
mkSEER(rdf,seerHome="/Users/radivot/data/SEER") 
# the rest fixes tAML and rewrites the fix into cancDef.RData
load("~/data/SEER/mrgd/cancDef.RData") #loads in canc
sc=canc%>%filter(histo3==9920|histo3==9987) #tAML and tMDS  subset of cancs (sc)
d=sc%>%filter(yrdx>2000)%>%group_by(sex,yrdx,histo3)%>%summarize(cnt=n()) #count rows in sex-year-ICDO3 groups
library(ggplot2)
theme_update(axis.text=element_text(size=rel(1.2)),
             axis.title=element_text(size=rel(1.3)),
             strip.text = element_text(size = rel(1.5)))
qplot(yrdx,cnt,data=d,facets=sex~histo3,ylab="Cases",xlab="Year of Diagnosis")+
  scale_x_continuous(breaks=seq(2002,2015,4))
ggsave("~/Results/amlMDS/tAMLtMDSfixed.pdf")  



####### SKIP below. It was moved into tMDSrepair() inside of mkSEER() 

# 
# 
# yearEnd=range(canc$yrdx)[2]
# sc=canc%>%filter(histo3==9920|histo3==9987) #tAML and tMDS  subset of cancs (sc)
# table(sc$yrdx,sc$histo3)  # see that they start in 2001
# table(sc$ICD9,sc$histo3)  # only 2 9920 are ICD9 9999, so cant reverse it using ICD9
# head(sc)
# sc%>%group_by(histo3)%>%summarize(age=mean(agedx))# for kicks, see that tMDS cases arrive 5 years later in life
# d=sc%>%filter(yrdx>2000)%>%group_by(sex,yrdx,histo3)%>%summarize(cnt=n()) #count rows in sex-year-ICDO3 groups
# # Zeros for MDS in 2012 do not show up in d. The next line adds them in just to make the plots look right.
# d=bind_rows(d,data.frame(sex=c("Male","Female"),yrdx=rep(2010:yearEnd,each=2),histo3=9987,cnt=0)) 
# d
# library(ggplot2)
# theme_update(axis.text=element_text(size=rel(1.2)),
#              axis.title=element_text(size=rel(1.3)),
#              strip.text = element_text(size = rel(1.5)))
# qplot(yrdx,cnt,data=d,facets=sex~histo3,ylab="Cases",xlab="Year of Diagnosis")+
#   scale_x_continuous(breaks=seq(2002,2020,4))
# ggsave("~/Results/amlMDS/tAMLtMDSnotFixed.pdf")  
# 
# #fit line to left up to 2009, predict and give right the difference
# m=lm(cnt~yrdx,subset(d,histo3==9920&yrdx<2010&sex=="Male"))
# f=lm(cnt~yrdx,subset(d,histo3==9920&yrdx<2010&sex=="Female"))
# nd=list(yrdx=2010:yearEnd)
# dm=d%>%filter(yrdx>=2010&histo3==9920,sex=="Male")
# df=d%>%filter(yrdx>=2010&histo3==9920,sex=="Female")
# (xm=dm$cnt-round(predict(m,nd))) # numbers of male tAMLs that need to become tMDSs in 2010 and higher
# (xf=df$cnt-round(predict(f,nd))) # same for females
# canc$id=1:dim(canc)[1]  # set up an id column to use to pull the random sample
# set.seed(8675309)   # Call Jenny to make it reproducible. 
# rws=NULL
# for (i in 1:length(xm)){
#   rws=c(rws,sample((canc%>%filter(histo3==9920&sex=="Male"&yrdx==(2009+i)))$id,xm[i]))
#   rws=c(rws,sample((canc%>%filter(histo3==9920&sex=="Female"&yrdx==(2009+i)))$id,xf[i]))
# } 
# canc[rws,"cancer"]="MDS" # note that we don't need tMDS and tAML as separate cancer types
# canc[rws,"histo3"]=9987 # know which were mapped via this and yrdx>2009
# canc$id=NULL # no need to save this column
# save(canc,file="~/data/SEER/mrgd/cancDefFixed.RData") # this takes a bit of time because it's writing a big file
# 
# sc=canc%>%filter(histo3==9920|histo3==9987) #tAML and tMDS  subset of cancs (sc)
# table(sc$yrdx,sc$histo3)  # see that they start in 2001
# table(sc$ICD9,sc$histo3)  # only 2 9920 are ICD9 9999, so cant reverse it using ICD9
# head(sc)
# sc%>%group_by(histo3)%>%summarize(age=mean(agedx))# for kicks, see that tMDS cases arrive 5 years later in life
# d=sc%>%filter(yrdx>2000)%>%group_by(sex,yrdx,histo3)%>%summarize(cnt=n()) #count rows in sex-year-ICDO3 groups
# d
# library(ggplot2)
# theme_update(axis.text=element_text(size=rel(1.2)),
#              axis.title=element_text(size=rel(1.3)),
#              strip.text = element_text(size = rel(1.5)))
# qplot(yrdx,cnt,data=d,facets=sex~histo3,ylab="Cases",xlab="Year of Diagnosis")+
#   scale_x_continuous(breaks=seq(2002,2015,4))
# ggsave("~/Results/amlMDS/tAMLtMDSfixed.pdf")  
# 

# APL.R  (makes Figure 3)
rm(list=ls()) 
library(SEERaBomb) 
library(reshape2)
library(tidyverse)
library(magrittr)
library(grid)
# the following were made earlier using SEERaBomb's mkSEER
load("~/data/SEER/mrgd/cancDef.RData") #loads in canc
load("~/data/SEER/mrgd/popsae.RData") # loads in popsae (extended to ages 85-99)
# trim down columns to bare neccesities before burdening seerSet with more than it needs 
canc=canc%>%select(-reg,-COD,-radiatn,-histo3,-ICD9)
canc%<>%separate(trt,c("trt","trtc"))
canc$trt=factor(canc$trt)
popsa=popsae%>%group_by(db,race,sex,age,year)%>%summarize(py=sum(py)) # sum on regs

secs=c("AML","MDS","APL","AMLti") # second cancers of interest
brks=c(0,0.25,1,2,3,4,5,6,8,10,12)
(brkS=paste0("b",paste(brks,collapse="_")))

if (1) {
  pm=seerSet(canc,popsa,Sex="Male",ageStart=0,ageEnd=100) #pooled (races) male seerSet
  (pf=seerSet(canc,popsa,Sex="Female",ageStart=0,ageEnd=100)) #pooled (races) female seerSet
  pm=mk2D(pm,secondS=secs) 
  (pf=mk2D(pf,secondS=secs)) # list object pf goes in and also comes out, with more on it
  
  pm=tsd(pm,brks=brks,trts=c("rad","noRad")) 
  (pf=tsd(pf,brks=brks,trts=c("rad","noRad")) )
  system.time(save(pm,file="~/Results/amlMDS/pmAPL.RData")) #~10 seconds 
  system.time(save(pf,file="~/Results/amlMDS/pfAPL.RData")) 
} else {
  load("~/Results/amlMDS/pmAPL.RData") 
  load("~/Results/amlMDS/pfAPL.RData") 
}

head(popsa)
head(canc)

m=canc%>%filter(cancer%in%secs)%>%mutate(age=agedx+0.5)%>%
  group_by(cancer,sex,age)%>%summarise(cases=n())
pops=popsa%>%group_by(sex,age)%>%summarise(py=sum(py))
head(m)
s=data.frame(sex=sort(unique(m$sex)))
c=data.frame(cancer=secs)
cs=merge(c,s)
pL=left_join(cs,pops)
d=left_join(pL,m)
d[is.na(d$cases),"cases"]=0 #join left missings where zero's should be, so fix this
d$cancer=factor(d$cancer,levels=secs)
d=d%>%mutate(py=py/1e5,incid=cases/py)
# d$sex=gsub("^m","M",d$sex)
# d$sex=gsub("^f","F",d$sex)
# d$sex=factor(d$sex,levels=c("Male","Female"))
# d$sex=factor(d$sex)
library(ggplot2)
theme_set(theme_gray(base_size = 10))
# theme_set(theme_bw(base_size = 10))

theme_update(legend.position = c(.18, .75),
             axis.text=element_text(size=rel(2)),
             axis.title=element_text(size=rel(2)),
             legend.title = element_blank(),
#              legend.title=element_text(size=rel(1.5)),
             legend.text=element_text(size=rel(1.5)))
graphics.off()
quartz(height=5,width=7) 
g <- ggplot(d,aes(x=age,y=incid,shape=sex,col=cancer))+geom_point(size=3.3)+ 
  labs(x="Age (years)",y=expression(paste("Cases per ",10^5," Person-Years")))+    
  scale_y_log10(limits=c(.02,100)) 
# g = g + scale_color_grey(start = 0.8, end = 0)
g
ggsave("~/Results/amlMDS/APLage.png")  
ggsave("~/Results/amlMDS/APLage.eps")  

HM=c("AML","MDS","CMML","CML","MPN","ALL","CLL","HCL","OL","NHL","MM","hodgkin")
dm=mkDF(pm,brks)
df=mkDF(pf,brks)
sapply(df,class)
d=rbind(cbind(df,Sex="Female"),cbind(dm,Sex="Male"))
d=d%>%filter(!cancer1%in%HM)%>%group_by(Sex,trt,cancer2,int)%>%summarize(O=sum(O),E=sum(E),t=weighted.mean(t,py,na.rm=T))
d=d%>%mutate(RR=O/E, rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E))
head(d)

# this is to get the seconds ordered properly and colors back like they were before using mkD instead of mkDF
d$cancer2=as.character(d$cancer2)
d$cancer2=factor(d$cancer2,levels=c("AML","MDS","APL","AMLti")) 

graphics.off()
xlabNR="Years Since Dx of Non-Heme 1st Cancer Not Treated With Radiation"
xlabR="Years Since Dx of Non-Heme 1st Cancer Treated With Radiation"
# cbPalette <- c("#000000", "#E69F00", "#56B4E9", "#009E73", "#F0E442", "#0072B2", "#D55E00", "#CC79A7") #black
theme_update(legend.position = c(.92, .83))
theme_update(axis.text=element_text(size=rel(1.2)),
             axis.title=element_text(size=rel(1.3)),
             legend.text=element_text(size=rel(1)),
             strip.text = element_text(size = rel(1.5)))
# NR=TRUE # for Figure C
# NR=FALSE  # for Figure B
for (NR in c(FALSE,TRUE)) {
  quartz(width=6,height=3.8)
  if (NR) D=d%>%filter(trt=="noRad") else D=d%>%filter(trt=="rad")
  D$t=D$t+(as.numeric(D$cancer2)-1)*0.05 # for CI visibility
  g=qplot(x=t,y=RR,data=D,col=cancer2,geom=c("line","point"),#xlim=c(-.1,24),
          xlab=ifelse(NR,xlabNR,xlabR),ylab="Relative Risk")
  g=g+facet_grid(Sex~.,scales="free")+geom_abline(intercept=1, slope=0)
#   g1 <- guide_legend("Second Cancer")
#   g=g + guides(color=g1) 
#   g=g + scale_colour_manual(values=cbPalette)
  # g = g + scale_color_grey(start = 0.8, end = 0)
  g=g+  geom_errorbar(aes(ymin=rrL,ymax=rrU,width=.15))+ theme(legend.key.height=unit(.45, "cm"))
  print(g)
  if (NR) ggsave("~/Results/amlMDS/APLnr.eps")  else
    ggsave("~/Results/amlMDS/APLr.eps") 
  if (NR) ggsave("~/Results/amlMDS/APLnr.png")  else
    ggsave("~/Results/amlMDS/APLr.png") 
}
########### Note: RR ratio  CI are too wide and unstable to plot.

###install.R
install.packages("SEERaBomb")
install.packages("devtools")
devtools::install_github("radivot/SEERaBomb",subdir="SEERaBomb") 

library(SEERaBomb)  #loads installed package SEERaBomb into memory
(df=getFields())    #gets SEER fields into a data frame
(rdf=pickFields(df))#picks a subset of SEER fields and defines their types
mkSEER(rdf)         #makes merged data file ~/data/SEER/mrgd/cancDef.Rdata

load("~/data/SEER/mrgd/cancDef.RData")#loads data.frame canc into memory
head(canc,3)                          #returns top 3 rows of canc
table(canc$cancer) #reports numbers of each cancer type

mkAbomb()#converts files in ~/data/abomb into ~/data/abomb/abomb.RData
load("~/data/abomb/abomb.RData")#loads data frames heme and solid 
View(heme)                      #note descriptions under column names

mkMrt("username","password")#sub in your account info

install.packages(c("bbmle","survminer","ggsci","tidyverse"))

# confInts.R  
# Exponential background CML parameter estimate confidence intervals

# This script starts out by using optim() and an explicitly defined
# log-likelihood function to fit exp(c0+k*age) to CML incidence for ages >20 
# using Poisson regression.  It then shows that the same results are obtained by
# either mle2() or by glm(), but slightly different results are obtained using 
# the least squares functions nls() and lm().  This script also shows that when 
# ages are centered about a median age of 55, the confidence interval of c0 (the
# log-space intercept) is shortened more so than that of k (the log-space 
# slope).

# NOTICE: you must
if (0) {  # switch this to 1 (i.e. run this chunk) if you never ran it before
	library(SEERaBomb)
	(df=getFields())
	(df=pickFields(df))
	mkSEERold(df,dataset="00")  
}


rm(list=ls(all=TRUE))
seerHome="~/data/SEER"
load(file.path(seerHome,"00/pops.RData")) # this loads in pops
pym=NULL;pyf=NULL
for (i in 0:18) 
{   pym[i+1]=with(pops,sum(population[(popsex==1)&(popage==i)]))
	pyf[i+1]=with(pops,sum(population[(popsex==2)&(popage==i)])) }

load(file.path(seerHome,"00/lymyleuk.RData")) # this loads in DF
DF$agerec=as.numeric(cut(DF$agedx,breaks=c(0,1,seq(5,85,5),130)))
head(DF)
d=DF[(DF$cancer=="CML")&(DF$seqnum<=1),] # paper used SEER 1973-2008
m=hist(d$agerec[d$sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
f=hist(d$agerec[d$sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
age=c(0.5,3,seq(7.5,87.5,5))
agem=55  # center ages in fits
agem=0
datam=data.frame(age=age-agem,cases=m,py=pym)[6:19,] 
dataf=data.frame(age=age-agem,cases=f,py=pyf)[6:19,]

fexp<-function(p,dat)	{	c0=p[1];k=p[2]; 
	with(dat,{mn=exp(c0+k*age)*py
				-sum(cases*log(mn) - mn)})	}
p0=c(c0=-8,k=.04)
ssolm=optim(p0,fexp,method="L-BFGS-B",control=list(maxit=400),dat=datam,hessian=TRUE)
sig=sqrt(diag(solve(ssolm$hessian)))
(CIM=cbind(point=ssolm$par,lower=ssolm$par-1.96*sig,upper=ssolm$par+1.96*sig))
CIM[,3]-CIM[,2] # The intercept is ~3-fold more accurate when the data is centered around it!
p0=c(c0=-10,k=.04)
ssolf=optim(p0,fexp,method="L-BFGS-B",control=list(maxit=400),dat=dataf,hessian=TRUE)
sig=sqrt(diag(solve(ssolf$hessian)))
(CIF=cbind(point=ssolf$par,lower=ssolf$par-1.96*sig,upper=ssolf$par+1.96*sig))

# now compare CI by different fitting methods
# mle2 is an optim wrapper in bbmle that has some conveniences 
require(bbmle) # note that dataframes used globally below are already centered in age
nLL<-function(c0,k,x) with(x, 	
	{mn=exp(c0+k*age)*py
	-sum(stats::dpois(cases, mn, log=TRUE))})
fit0m <- mle2(nLL,start=list(c0=-10,k=.04),data=list(x=datam))
fit0f <- mle2(nLL,start=list(c0=-10,k=.04),data=list(x=dataf))
glm1m=glm(cases~age+offset(log(py)),data=datam,family=poisson)
glm1f=glm(cases~age+offset(log(py)),data=dataf,family=poisson)
datam=transform(datam,incid=cases/py)
dataf=transform(dataf,incid=cases/py)
nl1m=nls(incid~exp(c0+k*age),data=datam,start=c(c0=-10,k=0.1))
nl1f=nls(incid~exp(c0+k*age),data=dataf,start=c(c0=-10,k=0.1))
lm1m=lm(log(incid)~age,data=datam)
lm1f=lm(log(incid)~age,data=dataf)

CIM
cbind(coef(glm1m),confint(glm1m))
cbind(coef(fit0m),confint(fit0m))
cbind(coef(lm1m),confint(lm1m))
cbind(coef(nl1m),confint(nl1m))

CIF
cbind(coef(glm1f),confint(glm1f))
cbind(coef(fit0f),confint(fit0f))
cbind(coef(lm1f),confint(lm1f))
cbind(coef(nl1f),confint(nl1f))

# conclusions: optim, mle2 and glm all give the same result
# since they are all Poisson regression. The least squares
# approaches can yield noticeably different results.

## Program Dingli Model Diagnosis. Using a mathematical model described by Dingli and coworkers, analyzes and produces probability distributions for the latency time to diagnosis from one leukemic stem cell.
## Most of the parameters and procedures are outlined in the following papers:
## Dingli D, Traulsen A, Pacheco JM (2007) Compartmental Architecture and Dynamics of Hematopoiesis. PLoS ONE 2(4): e345. doi:10.1371/journal.pone.0000345
## Dingli D, Traulsen A, Pacheco JM (2008) Chronic Myeloid Leukemia: Origin, Development, Response to Therapy, and Relapse. Clinical Leukemia, Vol. 2, No. 2, 133-139. 
## Lenaerts T, Pacheco JM, Traulsen A, and Dingli D. Tyrosine kinase inhibitor therapy can cure chronic myeloid leukemia without hitting leukemic stem cells. Haematologica 2010;95:900-907. doi:10.3324/haematol.2009.015271

## Copyright (C) 2011 Julian Landaw and Rainer Sachs
## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; version 2.
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU General Public License http://www.r-project.org/ for more details.
## Contact Julian Landaw, jlandaw@berkeley.edu or Rainer Sachs (sachs@math.berkeley.edu) for questions or comments.

## The main purpose of the following code is for running the function 'diagnosisSim', which finds  a random sample of latency times between the first leukemic stem cell and diagnosis according to the model by Dingli and coworkers). After running the script you can type "diagnosisSim()", which will output a list of the following:
## a vector of 10 latency times before diagnosis,
## the total number of simulations it required to get 10 diagnoses,
## and the number of diagnoses for which there still happened to be a leukemic stem cell.

## To change the number of diagnosis times to, e.g., 100 (instead of 10), simply type in "diagnosisSim(diagnoses = 100)". 


lam = 14^(1/4); 					## N_i/N_i-1, ratio of sizes between 2 adjacent compartments. approximates to ~1.93. the number of stem cells, N_0, is about 400
rrat = 1825^(1/32); 				## r_i/r_i-1, ratio of rates of differentiation between 2 adjacent compartments. approximates to ~1.26
eps = rrat*lam/(2*(rrat*lam-1)); 	## Probability of differentiation for healthy cells
epsCml = 0.72; 					## ... for leukemic cells
rStoc = rrat^(1:6); 				## Rates of replication for the stem cells and next 6 compartments (the stem cell and stochastic compartments)
rDeterm = rrat^(7:30); 				## Rates of replication for the next 25 compartments (the deterministic compartments)
stage1Cells = 1/((2*eps-1)*rrat/400); ## The number of healthy cells in the first stochastic compartment at equilibrium (number of cells coming in = number of cells going out) 

moran = function(regIni=399, cmlIni=1, period, timestep = 0.0025) 
## This function simulates the progression of the population of healthy/leukemic stem cells and determines how many healthy/leukemic cells will be entering the next compartment (due to differentiation)
## 'regIni' is the initial number of healthy stem cells
## 'cmlIni' initial number of leukemic stem cells 
## 'timestep' is in years 
## the average amount of time for a replication/export is 1/400 of a year. 

## 'regIni' and 'cmlIni' may be changed, but the default is 399 healthy stem cells and 1 leukemic stem cell. 
## The default 'timestep' is somewhat arbitrarily chosen to be 1/400 ? 

## This is a subroutine that is used in the main function 
{
	numSteps = floor(period/timestep); 			## how many timesteps occur in the given period of time.
	regCells = c(regIni,rep(0,times=numSteps)); 	## initializes the progression of healthy cells - the initial number followed by N empty time slots.
	cmlCells = c(cmlIni,rep(0,times=numSteps)); 	## initializes the progression of leukemic cells
	regFeed = rep(0,times=numSteps); 			## initializes the amount of healthy cells moving to the next compartment
	cmlFeed = regFeed; 						## initializes the amount of leukemic cells moving to the next compartment
	prob = timestep; 							## the probability any cell replicates happens to be numerically equivalent to the timestep
	ran = rbinom(numSteps,400,prob); 			## binomial distribution to determine how many moran processes occur at each timestep
	for (i in 2:(numSteps+1)) 
	{
		regCells[i] = regCells[i-1];
		cmlCells[i] = cmlCells[i-1];
		regFeed[i-1] = 0;
		cmlFeed[i-1] = 0;
		if (ran[i-1] > 0) ##if ran[i-1] = 0, no moran processes will occur during the time step - population remains stagnant and no differentiation
		{
			for (j in 1:ran[i-1]) ##ran[i-1], determined by the binomial distribution, is the number of moran steps during the time step 
			{
				r = runif(1);
				if (r < cmlCells[i]/(cmlCells[i] + regCells[i]))
				{
					##leukemic cell is exported to next compartment
					cmlCells[i] = cmlCells[i] - 1;
					cmlFeed[i-1] = cmlFeed[i-1] + 1; 
				}
				else
				{
					##healthy cell is exported to next compartment
					regCells[i] = regCells[i] - 1;
					regFeed[i-1] = regFeed[i-1] + 1; 
				}
				r = runif(1);
				if (r < cmlCells[i]/(cmlCells[i] + regCells[i]))
				{
					##leukemic cell divides into 2 leukemic cells
					cmlCells[i] = cmlCells[i] + 1;
				}
				else
				{
					##healthy cell divides into 2 healthy cells
					regCells[i] = regCells[i] + 1;
				}
			}
		}
	}
	return(list(regCells,cmlCells,regFeed,cmlFeed,timestep)); 
}

stocs = function(regIni = round(stage1Cells*lam^(0:5)), cmlIni = rep(0,times=6), regFeed, cmlFeed, timestep = 0.0025)
## This function ('stocs' stands for 'stochastics'), with given parameters, simulates stochastically the progression of the next 6 compartments after the stem cell compartment, as well as determining how many cells will be entering the next compartment (due to differentiation).
## 'regIni' is a vector of the initial number of healthy cells in each compartment
## 'cmlIni' the initial number of leukemic cells
## 'timestep' is the length of time between readings, and is in years 
## 'regFeed' and 'cmlFeed' are the amounts of healthy and leukemic cells entering the first stochastic compartment at each time step (determined by the function moran).
{
	numSteps = length(regFeed);
	regFeedNext = rep(0,times=numSteps); 				## initializes what will be fed to the first deterministic compartment
	cmlFeedNext = regFeedNext;
	regCells = c(regIni,rep(0,times=6*numSteps));
	dim(regCells) = c(6,numSteps+1); 				## matrix where the first column vector is the initial number of healthy cells in each compartment, followed by N empty column vectors
	cmlCells = c(cmlIni,rep(0,times=6*numSteps));
	dim(cmlCells) = c(6,numSteps+1); 				## first column vector is initial number of leukemic cells in each compartment
	prob = timestep*rStoc; 							## vector of six probabilities where the ith probability is the probability a cell in the ith compartment will divide
	for (i in 2:(numSteps+1))
	{
		regCells[1:6,i] = regCells[1:6,(i-1)];
		cmlCells[1:6,i] = cmlCells[1:6,(i-1)];
		regCells[1,i] = regCells[1,i] + regFeed[i-1]; ##first compartment gets fed the number of exported cells from the moran processes
		cmlCells[1,i] = cmlCells[1,i] + cmlFeed[i-1];
		for (j in 1:5)
		{
			p = prob[j];
			regTotalReps = rbinom(1,regCells[j,i-1],p); ## binomial distribution with p the probability and regCells[j,i-1] the number of 'trials'
			## determines how many cells divide
			cmlTotalReps = rbinom(1,cmlCells[j,i-1],p);
			regDifferentiates = rbinom(1,regTotalReps,eps); ## given how many divisions there are, binomial distribution determines how many differentiate 
			
			cmldifferentiates = rbinom(1,cmlTotalReps,epsCml);
			regReplicates = regTotalReps - regDifferentiates;
			cmlReplicates = cmlTotalReps - cmldifferentiates;
			regCells[j,i] = regCells[j,i] + regReplicates - regDifferentiates;
			cmlCells[j,i] = cmlCells[j,i] + cmlReplicates - cmldifferentiates;
			regCells[j+1,i] = regCells[j+1,i] + 2*regDifferentiates;
			cmlCells[j+1,i] = cmlCells[j+1,i] + 2*cmldifferentiates;
		}
		##6th compartment is treated the same, only here the cells are exported to the 7th compartment (via regFeedNext and cmlFeedNext), which is governed by the function 'determs'
		regTotalReps = rbinom(1,regCells[6,i-1],prob[6]);
		cmlTotalReps = rbinom(1,cmlCells[6,i-1],prob[6]);
		regDifferentiates = rbinom(1,regTotalReps,eps);
		cmldifferentiates = rbinom(1,cmlTotalReps,epsCml);
		regReplicates = regTotalReps - regDifferentiates;
		cmlReplicates = cmlTotalReps - cmldifferentiates;
		regCells[6,i] = regCells[6,i] + regReplicates - regDifferentiates;
		cmlCells[6,i] = cmlCells[6,i] + cmlReplicates - cmldifferentiates;
		regFeedNext[i-1] = 2*regDifferentiates;
		cmlFeedNext[i-1] = 2*cmldifferentiates; 
	} 
	return(list(regCells,cmlCells,regFeedNext,cmlFeedNext,timestep));
}

diffEq = function(y,params)
## A helper function, in which the 24 deterministic compartments are governed by the differential equation y' = diffEq(y, params)
## 'params' is a list of parameters supplying the probability of differentiation (eps or epsCml) and the 24 rates of replication (rDeterm)
## The sole purpose of this function is for solving the system of differential equations for the deterministic compartments (used in the next function, 'determs')
{
	primes = rep(0,times=24);
	e = params[[1]];
	r = params[[2]];
	primes[1] = -(2*e-1)*r[1]*y[1];
	primes[2:24] = 2*e*r[1:23]*y[1:23] - (2*e-1)*r[2:24]*y[2:24];
	return(primes);
}

determs = function(regIni = c(round(stage1Cells*lam^(6:29)),0), cmlIni = rep(0,times=25), regFeed, cmlFeed, timestep = 0.0025)
## This function ('determs' stands for 'deterministic'), with given parameters, simulates deterministically the progression of the last 25 compartments after the 'stochastic' compartments (governed by the function 'stocs'), and simulates how many mature cells will be produced at each timestep. 
## 'regIni' is a vector of the initial number of healthy cells in each compartment 
## 'cmlIni' the initial number of leukemic cells 
## 'timestep' is the length of time between readings, and is in years 
## 'regFeed' and 'cmlFeed' are the amounts of healthy and leukemic cells entering the first of the compartments at each time step (determined by the function 'stocs').
{
	numSteps = length(regFeed);
	regParams = list(eps,rDeterm);
	cmlParams = list(epsCml,rDeterm); ## Parameters used for the function 'diffEq' for the system of differential equations
	regCells = c(regIni,rep(0,times=25*numSteps));
	dim(regCells) = c(25,numSteps+1);
	cmlCells = c(cmlIni,rep(0,times=25*numSteps));
	dim(cmlCells) = c(25,numSteps+1);
	for (i in 2:(numSteps+1))
	{
		k1reg = timestep*diffEq(regCells[1:24,i-1],regParams); ## Runge-Kutta method for solving the system for the healthy cells
		k2reg = timestep*diffEq(regCells[1:24,i-1]+k1reg/2,regParams);
		k3reg = timestep*diffEq(regCells[1:24,i-1]+k2reg/2,regParams);
		k4reg = timestep*diffEq(regCells[1:24,i-1]+k3reg,regParams);
		regCells[1:24,i] = regCells[1:24,i-1] + 1/6*(k1reg + 2*k2reg + 2*k3reg + k4reg);
		regCells[1,i] = regCells[1,i] + regFeed[i-1];
		
		k1cml = timestep*diffEq(cmlCells[1:24,i-1],cmlParams); ## RK method for the leukemic cells
		k2cml = timestep*diffEq(cmlCells[1:24,i-1]+k1cml/2,cmlParams);
		k3cml = timestep*diffEq(cmlCells[1:24,i-1]+k2cml/2,cmlParams);
		k4cml = timestep*diffEq(cmlCells[1:24,i-1]+k3cml,cmlParams);
		cmlCells[1:24,i] = cmlCells[1:24,i-1] + 1/6*(k1cml + 2*k2cml + 2*k3cml + k4cml);
		cmlCells[1,i] = cmlCells[1,i] + cmlFeed[i-1];
	}
	regCells[25,] = timestep*(2*eps)*rDeterm[24]*regCells[24,];
	cmlCells[25,] = timestep*(2*epsCml)*rDeterm[24]*cmlCells[24,];  
	return(list(regCells,cmlCells,timestep));
}

simulate = function(regIni = c(399,round(stage1Cells*lam^(0:29)),0),cmlIni = c(1,rep(0,times=31)),period,timestep = 0.0025)
## A very simple function that runs the functions 'moran', 'stocs', and 'determs' to follow the progression of all the compartments together
## 'regIni' is a vector of the initial number of healthy cells in each compartment 
## 'cmlIni' the initial number of leukemic cells 
## 'period' is the length of time for which to simulate an individual
## 'timestep' is the length of time between readings, and is in years
{
	regStemCells = regIni[1];
	regStocCells = regIni[2:7];
	regDetermCells = regIni[8:32];
	cmlStemCells = cmlIni[1];
	cmlStocCells = cmlIni[2:7];
	cmlDetermCells = cmlIni[8:32];
	p = period;
	t = timestep;
	moranCells = moran(regIni = regStemCells,cmlIni = cmlStemCells,period = p,timestep = t);
	stocCells = stocs(regIni = regStocCells,cmlIni = cmlStocCells,regFeed = moranCells[[3]],cmlFeed = moranCells[[4]],timestep = t);
	determCells = determs(regIni = regDetermCells,cmlIni = cmlDetermCells,regFeed = stocCells[[3]],cmlFeed = stocCells[[4]],timestep = t);
	return(list(rbind(moranCells[[1]],stocCells[[1]],determCells[[1]]),rbind(moranCells[[2]],stocCells[[2]],determCells[[2]])));
}

diagnosisSim = function(regIni = c(399,round(stage1Cells*lam^(0:30)),0),cmlIni = c(1,rep(0,times=32)),period=50,timestep = 0.0025,diagnoses = 1000,stop=0)
## This function forms various simulations and outputs a list of the following: 
## a vector of various times for which CML diagnosis first comes 
## the total number of simulations it took to get so many latency times and 
## the number of those diagnoses in which there were still leukemic stem cells.

## 'regIni' is a vector of the initial number of healthy cells in each compartment. The default is the amount of cells of a healthy individual at equilibrium, minus one stem cell. 
## 'cmlIni' the initial number of leukemic cells. The default is one leukemic stem cell, and no leukemic cells in any other compartment.
## 'period' is the maximum length of time in years for which to simulate an individual. The default is 50, which is an extremely conservative maximum amount of time
## 'timestep' is the length of time between readings, and is in years
## 'diagnoses' is the number of diagnoses for which the user wants to output the latency times. The default is 10, and running the function will take around a minute of computer time.
## 'stop' allows the user to stop running the function once the number of simulations equals 'stop.' If stop = 0, as is the default, the function will run indefinitely until the number of diagnoses is met.

## If during a simulation it is clear an individual will not develop CML diagnosis, the simulation terminates and a new simulation begins
{
	diagnosisCount = 0;
	numTotalSims = 0;
	leukStemCellCount = 0;
	diagnosisTimes = rep(0,times = diagnoses);
	regular = regIni;
	leukemic = cmlIni; 
	while (diagnosisCount < diagnoses & (numTotalSims < stop | stop == 0))
	{
		numTotalSims = numTotalSims + 1;
		reg1 = regular;
		leuk1 = leukemic;
		for(i in 1:floor(period/timestep))
		{
			s = simulate(regIni = reg1,cmlIni = leuk1,period = timestep,timestep = timestep); ## simulates only the number of cells in the next time step
			regCells = s[[1]];
			cmlCells = s[[2]];
			r1 = regCells[,2];
			l1 = cmlCells[,2];
			if (leuk1[32] >= 10^12*365*timestep) ## diagnosis occurs - there are (on average) 10^12 mature leukemic cells produced per day.
			{
				diagnosisCount = diagnosisCount + 1;
				diagnosisTimes[diagnosisCount] = i*timestep;
				if (leuk1[1] > 0)
				{
					leukStemCellCount = leukStemCellCount + 1;
				}
				break;
			}
			else if (sum(leuk1[1:7]) == 0 & l1[32] < leuk1[32])   
			{
				## There are no leukemic cells in the stochastic compartments, and the number of mature leukemic cells is decreasing. 
				## This implies the mature leukemic cells will continue decreasing, thus no diagnosis can occur. To save time, the simulation terminates here.
				break;
			}
			reg1 = r1;
			leuk1 = l1;
		}
	}
	return(list(diagnosisTimes,numTotalSims,leukStemCellCount));
}

###incidEx2.R
(D=incidSEER(canc,popsae,"CML"))
(D=D%>%filter(age>=20,age<=80,year>=2000)%>%mutate(ageG=cut(age,seq(20,80,5))))
(D=D%>%group_by(sex,race,ageG)%>%
  summarize(age=mean(age),py=sum(py),n=sum(n))%>%mutate(incid=n/py))
summary(mm1<-mle2(n~dpois(lambda=exp(c+k*(age-50))*py),
                  #parameters=list(c~sex,k~sex),#k no diff
                  parameters=list(c~sex,k~race),#kW-O P=7e-8
                  method="Nelder-Mead",start=list(c=0,k=0.04),data=D)) 
D$EI=predict(mm1)/D$py#same as D=D%>%ungroup()%>%mutate(EI=predict(mm1)/py) 
D%>%ggplot(aes(x=age,y=incid,col=sex,shape=sex))+gxi+gyi+facet_grid(~race)+gp+
  geom_line(aes(y=EI))+scale_y_log10(breaks=c(1,2,5))+agts+jco+tc(13)+sbb+ltb+
  theme(legend.position=c(.45,.91),legend.key.height=unit(.7,'lines'))
ggsave("~/Results/tutorial/incidEx2.pdf",width=4,height=3)

###msdEx1.R 
d=canc%>%filter(cancer=="CML")%>%print(n=13)
d%>%summarize(n=n(),na=sum(is.na(surv)),prct=100*na/n)#<2% missing
d=d%>%mutate(status=as.numeric(COD>0),surv=(surv+0.5)/12)
d=d%>%select(yrdx,agedx,sex,surv,status)%>%print(n=13)
(D=msd(d,mrt,brkst=c(0,0.5,1,2,3,4,5,6,8),brksy=c(1975,1990,2005,2016)))
gx=xlab("Years Since CML Diagnosis")
gy=ylab("Relative Risk of Mortality")
myt=theme(legend.text=element_text(size=12),strip.text=element_text(size=12))
D%>%ggplot(aes(x=t,y=RR,col=Years))+facet_grid(.~sex)+gp+gl+gx+gy+gh+
       svts+jco+tc(14)+ltb+ltp+sbb+ylim(c(0,NA))+geRR+myt
ggsave("~/Results/tutorial/msdEx1A.pdf",width=4.5,height=3)

labs=c("1975-1990","1991-2005","2006-2016")
d=d%>%mutate(yrg=cut(yrdx,c(1974,1990,2005,2016),labels=labs))%>%print(n=13)
fit=survfit(Surv(surv,status)~yrg+sex,data=d) 
gy=ylab("Survival Probability")
ggsurvplot_facet(fit,d,facet.by="sex",legend.title="",xlim=c(0,12),
          short.panel.labs=T)+svts+jco+sbb+myt+gx+gy
ggsave("~/Results/tutorial/survEx1B.pdf",width=4.5,height=3)

rm(list=ls(all=TRUE))
FIGS2=FALSE  # use 9863
FIGS2=TRUE   # use 205.1
load("/data/SEER/73/pops.RData") # this loads in pops
pops1=subset(pops,popyear<1985)
pops2=subset(pops,(popyear>=1985)&(popyear<1997))
pops3=subset(pops,popyear>=1997)
getSexPY<-function(pops) {pym=NULL;pyf=NULL
	attach(pops)
  for (i in 0:18) 
  {   pym[i+1]=sum(population[(popsex==1)&(popage==i)])
    pyf[i+1]=sum(population[(popsex==2)&(popage==i)]) }
  detach(pops)
  list(m=pym,f=pyf)
}
(py1=getSexPY(pops1))
(py2=getSexPY(pops2))
(py3=getSexPY(pops3))

load("/data/SEER/73/lymyleuk.RData") # this loads in DF
if (FIGS2) ndat=DF[(DF$ICD9==2051)&(DF$numprims==1),] else ndat=DF[(DF$histo3==9863)&(DF$numprims==1),] 
ndat1=subset(ndat,yrdx<1985)
ndat2=subset(ndat,(yrdx>=1985)&(yrdx<1997))
ndat3=subset(ndat,yrdx>=1997)

age=c(0.5,3,seq(7.5,87.5,5))
m1=with(ndat1,hist(agerec[sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts)
f1=with(ndat1,hist(agerec[sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts)
m2=with(ndat2,hist(agerec[sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts)
f2=with(ndat2,hist(agerec[sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts)
m3=with(ndat3,hist(agerec[sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts)
f3=with(ndat3,hist(agerec[sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts)

fexp<-function(p,dat){	c0=p[1];k=p[2]; 
	with(dat,{mn=exp(c0+k*age[6:19])*py[6:19]
				-sum(cases[6:19]*log(mn) - mn)})  }
p0=c(c0=-13,k=.04)  
ssolm=optim(p0,fexp,method="L-BFGS-B",control=list(maxit=400),dat=list(agex=age,cases=m1,py=py1$m))
ssolf=optim(p0,fexp,method="L-BFGS-B",control=list(maxit=400),dat=list(agex=age,cases=f1,py=py1$f))
print(km1<-ssolm$par["k"]); print(kf1<-ssolf$par["k"])  
ssolm=optim(p0,fexp,method="L-BFGS-B",control=list(maxit=400),dat=list(agex=age,cases=m2,py=py2$m))
ssolf=optim(p0,fexp,method="L-BFGS-B",control=list(maxit=400),dat=list(agex=age,cases=f2,py=py2$f))
print(km2<-ssolm$par["k"]); print(kf2<-ssolf$par["k"])  
ssolm=optim(p0,fexp,method="L-BFGS-B",control=list(maxit=400),dat=list(agex=age,cases=m3,py=py3$m))
ssolf=optim(p0,fexp,method="L-BFGS-B",control=list(maxit=400),dat=list(agex=age,cases=f3,py=py3$f))
print(km3<-ssolm$par["k"]); print(kf3<-ssolf$par["k"])  

graphics.off()
windows(height=5,width=12,xpos=-150)
par(mfrow=c(1,2),mar=c(4.7,6.2,0.8,1),lwd=3,cex.lab=2,cex.axis=2,cex.main=1.3)
plot(age,mincid1<-m1/py1$m,log="y",type='b',xlab="Age",pch=1,col='blue',ylab="",yaxt="n",ylim=c(0.9e-7,1.5e-4),cex=1.3)
lines(age,mincid2<-m2/py2$m,type='b',col='red',pch=2,cex=1.3)
lines(age,mincid3<-m3/py3$m,type='b',col='black',pch=3,cex=1.3)
axis(side=2,las=1, at=c(1e-7,1e-6,1e-5,1e-4),labels=expression(.1,1,10,10^2))
mtext(expression(paste("Cases per ",10^6," PY")),side=2,line=3.7,cex=2)
mtext("Males",side=3,line=-1.8,cex=2,adj=0.05)
legend(25,1.6e-6,c(paste("1973-1984   k =",format(km1,digits=2)), paste("1985-1996   k =",format(km2,digits=2)),
      paste("1997-2010   k =",format(km3,digits=2))), col=c("blue","red","black"),pch=1:3,bty="n",cex=1.5)

plot(age,fincid1<-f1/py1$f,log="y",type='b',xlab="Age",pch=1,cex=1.3,col='blue',ylab="",yaxt="n",ylim=c(.9e-7,1.5e-4)  )
lines(age,fincid2<-f2/py2$f,type='b',col='red',pch=2,cex=1.3)  
lines(age,fincid3<-f3/py3$f,type='b',col='black',pch=3,cex=1.3)  
mtext("Females",side=3,line=-1.8,cex=2,adj=0.05)
axis(side=2,las=1, at=c(1e-7,1e-6,1e-5,1e-4),labels=expression(.1,1,10,10^2))
mtext(expression(paste("Cases per ",10^6," PY")),side=2,line=3.5,cex=2)
legend(25,1.6e-6,c(paste("1973-1984   k =",format(kf1,digits=2)), paste("1985-1996   k =",format(kf2,digits=2)),
      paste("1997-2010   k =",format(kf3,digits=2))), col=c("blue","red","black"),pch=1:3,bty="n",cex=1.5)

# PYnMDSvsDBs.R   (Figure 1)
# the following was made earlier using SEERaBomb's mkSEER
load("~/data/SEER/mrgd/popsa.RData")
library(dplyr)
library(ggplot2)
(pys=popsa%>%group_by(db,year)%>%summarize(npy=sum(py)))
(pys2=pys%>%mutate(year=year+0.999)) # to make step function plots hold flat across each year
pys=rbind(pys,pys2)
graphics.off() # start fresh on plots
quartz(width=7,height=5)
# quartz(width=7,height=5,dpi=300)
# quartz(width=3.4,height=2.5,dpi=300)
# theme_set(theme_bw())
theme_update(axis.title = element_text(size = rel(2.3)),
             axis.text = element_text(size = rel(1.5)),
             legend.position = c(.1, .16),
             legend.title=element_text(size=rel(1.2)),
             legend.text=element_text(size=rel(1.2)),
             strip.text = element_text(size = rel(1.5)))
g=ggplot(pys)+geom_ribbon(aes(x=year,ymax=npy/1e6,ymin=0,fill=db))+facet_grid(db~.) #+ theme_bw()
# g = g + scale_fill_grey(start = 0.8, end = 0)
g=g+labs(y=expression(paste(10^6," Person Years")),x="Year") 
g+guides(fill = guide_legend("SEER\nDatabase"))+scale_x_continuous(breaks=c(1973,seq(1980,2010,by=10))) 

ggsave("~/Results/amlMDS/fig1A.pdf")
# ggsave("~/Results/amlMDS/fig1A.png")
# ggsave("~/Results/amlMDS/fig1A.eps")

load("~/data/SEER/mrgd/cancDef.RData") #loads in canc
mds=canc%>%filter(cancer=="MDS")
mds=mds%>%filter(yrdx>2000) # filter out 22 scattered cases before 2001 (that may be typos, i.e. bad data)
head(mds)
(D=mds%>%group_by(db,yrdx)%>%summarize(cases=n()))
(D2=D%>%mutate(yrdx=yrdx+0.999))
D=rbind(D,D2)

# quartz(width=7,height=5,dpi=300)
quartz(width=7,height=5)
# quartz(width=3.4,height=2.5)
theme_update(axis.title = element_text(size = rel(2.3)),
             axis.text = element_text(size = rel(1.5)),
             legend.position = "none",
             strip.text = element_text(size = rel(1.5)))
g=ggplot(D)+geom_ribbon(aes(x=yrdx,ymax=cases,ymin=0,fill=db))+facet_grid(db~.)
# g = g + scale_fill_grey(start = 0.8, end = 0)
g=g+labs(y="MDS Cases",x="Year")+scale_x_continuous(breaks=seq(2001,2015,by=2)) 
g+scale_y_continuous(breaks=seq(0,2000,by=1000)) 
ggsave("~/Results/amlMDS/fig1B.pdf")
# ggsave("~/Results/amlMDS/fig1B.png")
# ggsave("~/Results/amlMDS/fig1B.eps")

# amlAbombAge.R  (Figure 2J)
library(dplyr)
# library(SEERaBomb)
# mkAbomb() #~\data\abomb\lsshempy.csv, lssinc07.csv=> tables heme and solid in abomb.db
db <- src_sqlite("~/data/abomb/abomb.db")
d=collect(tbl(db, sql("SELECT * from heme")))%>%   
  mutate(Dose=cut(D,c(-1,.01,.4,10),labels=c("Low","Medium","High"),include.lowest=TRUE)) %>%
  mutate(agec=cut(age,c(seq(0,80,20),110),labels=seq(10,90,20))) %>%
  group_by(Dose,agec) %>%
  summarise(age=mean(age),py=sum(py)/1e5,AML=sum(AMLtot),
            L=qpois(.025,AML),U=qpois(.975,AML),Incid=AML/py,IL=L/py,IU=U/py)
d
d$Dose=factor(d$Dose,levels=c("High","Medium","Low"))
library(ggplot2)
graphics.off()
quartz(width=7,height=5)
# theme_set(theme_bw(base_size = 18))
theme_set(theme_gray(base_size = 16)) 
theme_update(legend.position = c(.7, .2),
             axis.text=element_text(size=rel(1.3)),
             axis.title=element_text(size=rel(1.3)),
             legend.title=element_text(size=rel(1.1)),
             legend.text=element_text(size=rel(1.1)))
g=qplot(x=age+0.5*(as.numeric(Dose)-1),y=Incid,data=d,col=Dose,log="y",ylab="Incidence (Cases/100,000 PY)",
        geom=c("line","point"),xlab="Age")+geom_line(lwd=1.3)
# g = g + scale_color_grey(start = 0.8, end = 0)
g+  geom_errorbar(aes(ymin=IL,ymax=IU,width=.15))

ggsave("~/Results/amlMDS/abombAMLage.eps")  
ggsave("~/Results/amlMDS/abombAMLage.png")  

# Side calculation
(2.5/9)^0.5 # = whole body A-bomb dose equivalent of average radiation therapy AML carcinogenicity

rm(list=ls());library(tidyverse);library(SEERaBomb)
load("~/data/SEER/mrgd/popsae.RData") 
(p=popsae%>%count(race,sex,age,year,wt=py)%>%rename(py=n))
load("~/data/SEER/mrgd/cancDef.RData") 
canc$cancer=fct_collapse(canc$cancer,AML=c("AML","AMLti","APL"))
secs=c("CML","AML","ALL") 
(d=canc%>%filter(sex=="Female",cancer%in%c("breast",secs)))
pf=seerSet(d,p,Sex="Female")#pooled (races) females 
pf=mk2D(pf,secondS=secs)#adds secs background rates to pf
trts=c("rad.chemo","rad.noChemo","noRad.chemo","noRad.noChemo")
pf=csd(pf,brkst=c(0,1,2,3,5,10),brksa=c(0,60),trts=trts,firstS="breast")
(D=pf$DF%>%filter(ageG=="(0,60]")) 
D=D%>%mutate(cancer2=fct_relevel(cancer2,"AML"))#make AML 1st
D$t=D$t+c(0,0.075,0.15)#shift times to separate error bars
myt=theme(legend.title=element_blank(),legend.margin=margin(0,0,0,0))
myth=theme(legend.direction="horizontal",legend.key.height=unit(.25,'lines'))
myth=myt+myth+theme(legend.position=c(.25,.95))
g=ggplot(aes(x=t,y=RR,col=cancer2),data=D)+geom_point()+geom_line()+myth+
  labs(x="Years Since Breast Cancer Diagnosis",y="Relative Risk of Leukemia")
g=g+facet_grid(rad~chemo)+geom_abline(intercept=1,slope=0) 
g+geom_errorbar(aes(ymin=rrL,ymax=rrU),width=0.05)+coord_cartesian(ylim=c(0,25)) 
ggsave("~/Results/tutorial/breast2leu.pdf",width=4,height=2.5) 

# D%>%filter(cancer2=="CML",rad=="Rad") # see values of CML RR CI at peaks
# D%>%group_by(rad,chemo)%>%summarize(O=sum(O),E=sum(E),meanPYage=weighted.mean(age,w=py)) 
# pf=csd(pf, brkst=c(0,1,2,3,5,10),brksy=c(1973,2000), brksa=c(0,60), trts=trts, firstS="breast")
# (D=pf$DF%>%filter(ageG=="(0,60]",yearG=="[2000,2016)")) #no diff in CML (0,1] of noRad.chemo

# Figure S1: Plots the CI of the Fk estimates in Fig. 2
aBombHome="/data/abomb"
cols=c("city","sex","doseg","agexg","calg","kerma","PY","adjPY","num.entering",
		"age","agex","tsx","cal","sv","gam","neut","lymphoma","NHL","leukemia","AML","ALL","CML","ATL","MM")      
d<-read.table(file.path(aBombHome,"hema87.dat"), header=F,col.names=cols);
d=d[d$adjPY>0,] #remove two recs with zero py
d=d[d$kerma==1,] # take only kerma < 4 Gy
d$py=10^4*d$adjPY
m=d[d$sex==1,]; f=d[d$sex==2,] 
years=c(1951,1953,1956,1959,1963,1968,1973,1978,1983,1987)-1945
agem=0
flin<-function(x,df) {
	c0=x[1];k=x[2];L=x[3:12]; # let data speak through L, like a one way anova
	with(df,{mn = exp(c0+k*(age-agem))*py + sv*exp(L[calg])*py;
				-sum(CML*log(mn) - mn)})	}

X0=c(c0=ifelse(agem==0,-13,-10),k=0.05,rep(-10,10))
solm=optim(X0,flin,df=m,method="L-BFGS-B",hessian=TRUE,control=list(maxit=400))  
waitm=exp(solm$par[3:12])
solf=optim(X0,flin,df=f,method="L-BFGS-B",hessian=TRUE,control=list(maxit=400))  
waitf=exp(solf$par[3:12])
getCI<-function(sol) {
	if (det(sol$hessian)>0) {
		sig=sqrt(diag(solve(sol$hessian)))
		print("Hessian OK") 
	} else {
		sig=Inf
		print("Hessian Singular") 
	}
	upper=signif(sol$par+1.96*sig,5)
	lower=signif(sol$par-1.96*sig,5)
	point=signif(sol$par,5)
	CI=cbind(point,lower,upper)
	CI=exp(CI) 
	row.names(CI)=1:nrow(CI)
	CI=transform(CI,li=point-lower,ui=upper-point,len=upper-lower)
	CI
}
(mCI=getCI(solm))
(fCI=getCI(solf))

mui=mCI[3:12,"ui"]
mli=mCI[3:12,"li"]
mpt=mCI[3:12,"point"]

fui=fCI[3:12,"ui"]
fli=fCI[3:12,"li"]
fpt=fCI[3:12,"point"]

require(plotrix)
windows(width=5,height=5)
par(mfrow=c(1,1),mar=c(4.7,4.7,2.3,0.2),lwd=2,cex.lab=1.8,cex.axis=1.7,cex.main=1.7)
plotCI(x=years,y=mpt,uiw=mui,liw=mli,ylab="",yaxt="n",col="blue",xlab="Years Since Exposure",ylim=c(0,8.2e-4),pch="x",cex=2)
plotCI(x=years+.3,y=fpt,uiw=fui,liw=fli,col="red",add=T,pch="o",cex=2)
axis(side=2,las=1, at=c(0,2e-4,4e-4,6e-4,8e-4),labels=c(0,2,4,6,8))
mtext(expression(paste("Cases per ",10^4," Person-Year-Sv")),side=2,line=2.6,cex=1.8)
mtext("Males (x)",side=3,line=.6,cex=1.8,col="blue",adj=0.05)
mtext("Females (o)",side=3,line=.6,cex=1.8,col="red",adj=0.95)

rm(list=ls()) 
# The first step is to show that there are lower AIC EAR models than Hsu's CML
# ERR and EAR models in: Hsu, W. L., Preston, ... and Mabuchi, K.
# The Incidence of Leukemia, Lymphoma ... among Atomic Bomb Survivors:
# 1950–2001. Radiat. Res. 179, 361–382 (2013). To use it please place
# lsshempy.csv in /data/abomb or change this line
d<-read.csv("/data/abomb/lsshempy.csv",header=T)#,col.names=cols);
head(d,2)
d=d[d$mar_an>=0,] # take only those with known doses 
sum(d$cml) # checks with their 75 cases
d=within(d,{rm(distcat,agxcat, agecat, dcat, time,upyr,subjects,year,
               nhl,hl,mye,all,oll,alltot,cll,hcl,clltot,atl,aml,oml,amol,amltot,
               othleuk,noncll,leuktot,hldtot,mar_ag,mar_an)}) # remove unused columns
head(d,2)
# the next line follows the epicure log file
d=within(d, {nic = as.numeric(gdist > 12000); over4gy = 1 - un4gy ; 
             # yob = year-age; 
             # bcohort = (yob-1915)/10; bcsq = bcohort*bcohort;
             # e30 = (agex - 30)/10 ;
             tsx = (age -agex) ;         #              tsx25 = (tsx-25)/10 ;
             lt25 = log(tsx/25) ; #ltsx25sq = ltsx25^2 ;
             rm(gdist,un4gy)
             # tsx40 = (tsx - 40) / 10;
             # ltsx40 = log(tsx/40); ltsx40sq = ltsx40^2;
             a = log(age/70) ; #lage70sq = lage70^2 ;
             a55 = log(age/55) ;
             age55=age-55
             agex30=agex-30
             ax30 = log(agex/30) ;
             # lage40 = log(age/40); lage40sq = lage40^2;
             # lage40qsp = lage40sq*(age < 40);
             # lage70qsp = lage70sq*(age > 70) ;
            py10k = pyr/10000 ;
             py = pyr;
             s=sex-1
             c=city-1
             #              male = sex == 1 ; female = sex == 2;
             # msex = 2*sex - 3 ;
             # adult = (agex >= 20);
             # adultf = adult * female;
             sv=mar_ad10/1000;
             # dosegysq=dosegy*dosegy*1.12;
             hiro = as.numeric(city == 1) ; naga = as.numeric(city ==2);
             rm(sex,city,pyr,mar_ad10)
})

head(d)

bk=d[d$sv<0.05,]
library(bbmle)
# ERR model of CML. From Table S2
# back=0.22*exp(-0.06*s + 1.38*a + 1.75*(s*a))
# Induced=(5.24*d)*exp(-1.50*c - 1.59*lt25 - 1.42*a55)
# Where
# c = 0 for Hiroshima and 1 for Nagasaki        # below are not used for CML
# s = 0 for men and 1 for women                 # b = (birth year – 1915) / 10
# a = ln(age/70); a55 = ln(age/55)              # a40 = ln(age / 40 ); 
# d = weighted bone marrow dose (Gy)            # e = (1945 – birth year – 30) / 10
# lt25 = ln(time since exposure/25)             # lt40 = ln(time since exposure / 40)
# first compare their polynomial in age background model to our preferred exponential in age model
summary(p1<-mle2(cml~dpois(lambda=py10k*A*exp(cs*s+ca*a+csa*a*s)),
#                      method="L-BFGS-B",
                     start=list(A=.22,cs=-0.06,ca=1.38,csa=1.75),data=bk) ) 
summary(e1<-mle2(cml~dpois(lambda=py10k*A*exp(cs*s+k*age55)),
                     start=list(A=.22,cs=-0.6,k=0.04),data=bk) ) 
summary(e2<-mle2(cml~dpois(lambda=py10k*A*exp(cs*s+k*age55+ks*s*age55)),
                 start=list(A=.22,cs=-0.6,k=0.03,ks=.02),data=bk) ) 
AIC(p1,e1,e2)
BIC(p1,e1,e2) # favors exponential over polynomial background; also, sex diffs in k not justified

# now add in their ERR induced term
# Induced=(5.24*d)*exp(-1.50*c - 1.59*lt25 - 1.42*a55)
# with extra terms in epicure log file also included in the model 
summary(err<-mle2(cml~dpois(lambda=py10k*(A1*exp(c1s*s+c1a*a+c1sa*a*s+c1nic0*hiro*nic+c1nic1*naga*nic)*
                          (1+sv*A2*exp(c2c*c + c2t*lt25 + c2a*a55+c2o4g*over4gy)   ) ) ),
#                                        method="L-BFGS-B",
                 start=list(A1=.22,c1s=-0.06,c1a=1.38,c1sa=1.75,c1nic0=-0.2,c1nic1=-0.86,
                            A2=5.24,c2c=-1.50,c2t=-1.59,c2a=-1.42,c2o4g=-0.3),data=d) ) 

AIC(err)
logLik(err)
deviance(err)
summary(err)
prd=predict(err)
sum(d$cml==1)
-2*sum(d$cml*log(prd))+2*length(coef(err))
-2*sum(d$cml*log(prd))
# [1] 754.454 # exactly as in epicure log file of supplement. In computing the 
# deviance here, I'm OK with ditching the third term below since it only depends
# on the data, and since it vanishes anyway since the cells are all 0 or 1 (in this data)
# and the factorial takes these all to 1 which the log then takes to zero, but was wondering
# how they can leave out the second term, i.e. -prd
-2*sum(d$cml*log(prd)-prd-log(factorial(d$cml)))
-2*sum(d$cml*log(prd)-prd)
sum(predict(err)) # my only guess is that the sum of the expected means = sum of observed cases
# so that it too really only depends on the data, at the level of the whole sum. 

# EAR model of CML. From Table S2
# back=0.25*exp(-0.28*s + 1.60*a + 1.38*(s*a))
# Induced=
# (0.68*d)*exp(-1.49*c - 1.63*lt25 - 0.20*a55) men
# (0.57*d)*exp(-1.49*c - 1.63*lt25 + 2.10*a55) women
# but the epicure log shows more to the model, as follows
summary(ear<-mle2(cml~dpois(lambda=py10k*(A1*exp(c1s*s+c1a*a+c1sa*a*s+c1nic0*hiro*nic+c1nic1*naga*nic)
                        +sv*A2*exp(c2c*c + c2s*s+c2t*lt25 + c2a*a55+c2sa*s*a55+c2o4g*over4gy)   ) ) ,
                 #                                        method="L-BFGS-B",
                 start=list(A1=.22,c1s=-0.06,c1a=1.38,c1sa=1.75,c1nic0=-0.2,c1nic1=-0.86,
                            A2=5.24,c2c=-1.50,c2s=-0.18,c2t=-1.59,c2a=-1.42,c2sa=2.3,c2o4g=-0.3),data=d) ) 
prd=predict(ear)
-2*sum(d$cml*log(prd))
-2*sum(d$cml*log(prd))+2*length(coef(ear))
# 753.7032  # also exactly as in the epicure log file supplement. 

AIC(err,ear)
ICtab(err,ear) # err wins by AIC
anova(err,ear) # err wins by likelihood ratio test (i.e. deviance difference test)


################################################################################3
# The following EAR model beats out Hsu's ERR model (in terms of AICs)  
summary(s1<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
                                      +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx)  ) ),
         start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,c2s=-0.18,c2t=-0.4,c2ts=0.3),data=d) ) 
prd=predict(s1)
-2*sum(d$cml*log(prd))
-2*sum(d$cml*log(prd))+2*length(coef(s1))
ICtab(err,s1) # s1 wins by AIC
anova(err,s1) # s1 wins by likelihood ratio test (i.e. deviance difference test)


# # using this model there is no evidence for the need for kerma>4gy correction
# summary(s1ov<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
#                                       +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx+c2o4g*over4gy)  ) ),
#                  start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
#                             c2s=-0.18,c2t=-0.4,c2ts=0.3,c2o4g=-0.3),data=d) ) 
# prd=predict(s1ov)
# -2*sum(d$cml*log(prd))
# -2*sum(d$cml*log(prd))+2*length(coef(s1ov))
# 
# # checking the need for tsx power out in front of the exponential decay 
# summary(s1pow<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
#                                         +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx+c2tpow*lt25 )  ) ),
#                    start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
#                               c2s=-0.18,c2t=-0.4,c2ts=0.3,c2tpow=0),data=d) ) 
# prd=predict(s1pow)
# -2*sum(d$cml*log(prd))                       # => no need to add power in front
# -2*sum(d$cml*log(prd))+2*length(coef(s1pow))

# checking if adding lage55 in the induced term helps, yes, it does 
summary(s1a55<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
                     +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx + c2a*a55+c2sa*s*a55 )  ) ),
                    start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
                               c2s=-0.18,c2t=-0.4,c2ts=0.3,c2a=-1.42,c2sa=2.3),data=d) ) 
prd=predict(s1a55)
-2*sum(d$cml*log(prd))                       
-2*sum(d$cml*log(prd))+2*length(coef(s1a55)) # lage55 terms are justified! new best model
ICtab(err,s1a55) # new model wins by AIC diff of 3.4
anova(err,s1a55) # new has less deviance and fewer parameters!

# keeping only the female component of lage55  
summary(s1a55f<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+(k+ks*s)*age)
                         +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx +c2sa*s*a55 )  ) ),
                    start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
                               c2s=-0.18,c2t=-0.4,c2ts=0.3,c2sa=2.3),data=d) ) 
prd=predict(s1a55f)
-2*sum(d$cml*log(prd))                       
-2*sum(d$cml*log(prd))+2*length(coef(s1a55f)) # new best model 
ICtab(err,s1a55f) # now new model wins by AIC diff of 5.3
anova(err,s1a55f) # deviance loss was negligible, consistent with AIC drop of almost 2
summary(s1a55f)

# # do we still need a sex diff in exponential decays?  
# summary(m1a55f<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
#                                           +sv*exp(c20+c2c*c + c2s*s+c2t*tsx +c2sa*s*a55 )  ) ),
#                      start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
#                                 c2s=-0.18,c2t=-0.4,c2sa=2.3),data=d) ) 
# prd=predict(m1a55f)
# -2*sum(d$cml*log(prd))                       
# -2*sum(d$cml*log(prd))+2*length(coef(m1a55f)) #  yes, keep the difference in exponential decays

# # try switching to age at exposure in induced term doesn't help
# summary(s1a55x<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+(k+ks*s)*age)
#                                           +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx +c2sa*s*agex )  ) ),
#                      start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
#                                 c2s=-0.18,c2t=-0.4,c2ts=0.3,c2sa=2.3),data=d) ) 
# prd=predict(s1a55x)
# -2*sum(d$cml*log(prd))                       
# -2*sum(d$cml*log(prd))+2*length(coef(s1a55x)) 
# ICtab(s1a55f,s1a55x) # fit is worse


# what about the age at exposure hump for HM only  
a55HMb<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)    +
      sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx +c2sa*s*a55+ c2x*(1-c)*(1-s)*abs(agex-30))  ) ),
                     start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
                                c2s=-0.18,c2t=-0.4,c2ts=0.3,c2x=.1,c2sa=2.3),data=d)  
prd=predict(a55HMb)
-2*sum(d$cml*log(prd))                       
-2*sum(d$cml*log(prd))+2*length(coef(a55HMb)) # 

summary(a55HMb)     #P=0.2 on c2x param is consistent with 0.18 below for model diffs
AIC(a55HMb,s1a55f)
ICtab(a55HMb,s1a55f) #AIC difference of 0.2 is not much, so the param was almost a wash
anova(a55HMb,s1a55f) # P=0.18 => no HM hump at agex=30

#rewrite to estimate sex difference in EAR time constants 
summary(best<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
                                          +sv*exp(c20+c2c*c + c2s*s-tsx/(c2t+exp(c2ts)*s) +c2sa*s*a55 )  ) ),
                     start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
                                c2s=-0.18,c2t=5,c2ts=log(10),c2sa=2.3),data=d) ) 
prd=predict(best)
-2*sum(d$cml*log(prd))                       
-2*sum(d$cml*log(prd))+2*length(coef(best))  # see that it still is the best
AIC(s1a55f,best) # i.e. these should be identical, and they are (this is just a reparameterization)

(sb=summary(best))
sd=coef(sb)["c2ts",2]
mn=coef(best)["c2ts"]
(tauDiff=c(mn,mn-1.96*sd,mn+1.96*sd))
# c2ts      c2ts      c2ts 
# 7.728236  2.415438 24.726620 
# confint(best,parm="c2ts") This  takes too long (I killed it with esc)
###############################################################################

# The next goal is to make something like the dots in Fig 4B of Hsu et al, but for tsx decays
# To do this we replace the tsx exponential decays with a "nonparameteric" model (not distribution),
# i.e. this is non-parameteric like a one-way anova is of a time course. 
d=transform(d,tsxf=cut(tsx,6),sex=as.factor(s))
head(d)
summary(s3<-mle2(cml~dpois(lambda=py*(exp(c10 + c2c*c + c2s*s + k*age + ks*s*age)
                                +sv*exp(c2c*c  + f + c2sa*s*a55 )  ) ),
                 parameters=list(f~-1 + tsxf:sex),
                 start=list(c10=-12.4,k=0.025,ks=0,c2c=-1.50,
                              c2s=-0.18,f=-5,c2sa=2),data=d) ) 
prd=predict(s3)
-2*sum(d$cml*log(prd))  # fit is much improved, with deveiance now at 746.07 (lowest of all)
-2*sum(d$cml*log(prd))+2*length(coef(s3))# but the extra parameters are not justified: this is OK, 
# the point here is to plot the points, not say that this is a better model. 

ss3=summary(s3)
wait=exp(coef(ss3)[6:17,1])*1e4
waitL=exp(coef(ss3)[6:17,1]-1.96*coef(ss3)[6:17,2])*1e4
waitU=exp(coef(ss3)[6:17,1]+1.96*coef(ss3)[6:17,2])*1e4
(lvls=levels(d$tsxf))
(Lvls=strsplit(lvls,","))
substring("(4.23",2)
(lows=sapply(Lvls,function(x) as.numeric(substring(x[1],2))))
(ups=sapply(Lvls,function(x) as.numeric(substring(x[2],1,4))))
(mids=round(apply(rbind(lows,ups),2,mean),2))
(dfc=data.frame(mids,wait,waitL,waitU,Sex=gl(2,6,labels=c("Male","Female") ) ) )
dfc
library(ggplot2)
pd <- position_dodge(1) 
(p=ggplot(dfc, aes(x=mids, y=wait, shape=Sex,ymax=10)) + 
   geom_point(size=6,position=pd) ) # + ylim(0, 10) ) # scale_y_log10(limits=c(1e-5,10)) 
(p=p+labs(title="IR-to-CML Latency",x="Years since exposure",
          y=expression(paste("Cases per ",10^4," Person-Year-Sv") ) ) )    
(p=p+geom_errorbar(aes(ymin=waitL, ymax=waitU),width=.01,position=pd))
(p=p+theme(plot.title = element_text(size = rel(2.3)),
           axis.title = element_text(size = rel(2.3)),
           axis.text = element_text(size = rel(2.3)))  )
(p=p+theme(legend.position = c(0.8, .5), 
           legend.title = element_text(size = rel(2)) ,
           legend.text = element_text(size = rel(2))  ) )  

waitm=exp(coef(ss3)[6:11,1])
waitf=exp(coef(ss3)[12:17,1])
(MovF<-format(sum(waitm)/sum(waitf),digits=3))
pm=waitm/sum(waitm)
pf=waitf/sum(waitf)
(taum<-round(mids%*%pm,2))
(tauf<-round(mids%*%pf,2))
(p=p+annotate("text",x=25,y=10, hjust=0, label = paste("M/F =",MovF),size=9) )
(lb1=paste0("tau[m] == ",taum,"*~Yrs"))
(p=p+annotate("text",x=25,y=9, hjust=0, label = lb1,size=9,parse=T) )
(lb1=paste0("tau[f] == ",tauf,"*~Yrs"))
(p=p+annotate("text",x=25,y=8, hjust=0, label = lb1,size=9,parse=T) )

# This next block calculates the 95% CI of the difference in waiting times
rdiscrete <- function(n, probs,values) {
  cumprobs <- cumsum(probs)
  singlenumber <- function() {
    x <- runif(1)
    N <- sum(x > cumprobs)
    N
  }
  values[replicate(n, singlenumber())+1]
}
x=rdiscrete(1e5,pf,mids)
summary(as.factor(x))
y=rdiscrete(1e5,pm,mids)
summary(as.factor(y))
(delT=quantile(x-y,c(0.025,0.975)))
(lb1=paste0("Delta*tau == ",tauf-taum,"(",delT[1],", ",delT[2],")"))
#(lb1=paste0("Delta*tau == ",tauf-taum,"~group(\"(\",",delT[1],",",delT[2],",\")\")")) # attempt with group() failed
windows(height=7,width=8,xpos=-100,ypos=-100)  # set back to square
(p=p+annotate("text",x=25,y=7, hjust=0, label = lb1,size=7,parse=T) ) #just show since can't add space before ( 
ggsave(p,file="/users/radivot/downloads/sachs/IR2CML.wmf")


### Figure 7: interpretations ##############
graphics.off()
windows(height=6,width=6,xpos=-100,ypos=-100) 
k=0.025
Tp=22.1
Rp=1.73
Tf=-15:23
fR=function(Tf) exp(-k*(Tf-Tp))
R=fR(Tf)


par(mar=c(4.5,4.5,0,.5))
plot(Tf,R,type="l",lwd=2.5,cex.lab=1.8,cex.axis=1.8,
     ylab="(male risk)/(female risk) M/F",
     xlab="extra female latency time T in years",axes=F,font=2)
mtext(side=3,line=-4,"Continuum of SEER CML\n Sex Difference Interpretations",cex=1.5,font=2)
axis(1);axis(2)
points(x=c(0,Tp),y=c(Rp,1),pch=1,cex=3,lwd=3)
abline(h=1,v=0,lty=3)
fT=function(R) Tp-log(R)/k
Tx=3.86
Rx=1.26
points(x=c(fT(Rx),Tx),y=c(Rx,fR(Tx)),pch="+",cex=3)
# plot(1:20,pch=1:20)
x=seq(Tx,fT(Rx),0.1)
y=fR(x)
points(x,y,type="l",lwd=6)
rect(-1,1.13*Rp,23,1.26*Rp,lwd=2)
text(12,1.2*Rp,"interpretations by\n a single cause",cex=1.4,font=2,bty="o")
arrows(x0=0,y0=1.13*Rp,x1=0,y1=Rp+0.05,lwd=2,angle=20)
arrows(x0=Tp,y0=1.13*Rp,x1=Tp,y1=1.05,lwd=2,angle=20)
text(4,1.04*Rp,"higher\nmale\nrisk",cex=1.4,font=2)
text(10,0.96*Rp,"or",cex=1.4,font=2)
text(18,0.9*Rp,"shorter\nmale\nlatency",cex=1.4,font=2)
text(-9,1.28,
     "interpretations\nconsistent with\ntime-since-\nexposure data\n(heavy line)",
     cex=1.4,font=2)
arrows(x0=-2,y0=1.4,fT(1.4),y1=1.4,lwd=2,angle=20)

###############################################33


# Age at exposure: Figure 8
windows(height=7,width=8,xpos=-100,ypos=-100)  

head(d)
d$Dose<-cut(d$sv,c(-1,.02,1,100),labels=c("Low","Moderate","High"))
d$agexc<-cut(d$agex,c(0,20,40,180),labels=c("10","30","50"))
d$Sex<-factor(d$s,labels=c("Male","Female"))
head(d)
library(plyr) 
(d2<-ddply(subset(d,c==0), .(Dose,Sex,agexc), summarise,
           PY=sum(py),cases=sum(cml),agex=weighted.mean(agex,py) )) #
(d2=within(d2,{incid=1e5*cases/PY}))

library(ggplot2)
(p <- ggplot(d2,aes(x=agex,y=incid,shape=Dose,group=Dose))+geom_point(size=5) +geom_line()
 + labs(title="Hiroshima A-bomb Survivors",x="Age-at-exposure (PY-weighted)",
        y=expression(paste("CML Cases per ",10^5," Person-Years")))    
 + scale_y_log10(limits=c(.1,130)) +xlim(8,52) )
(p=p + facet_grid(. ~ Sex))
(p=p+theme(legend.position = c(0.67, .85), 
           legend.title = element_text(size = rel(2)) ,
           legend.text = element_text(size = rel(1.7))  ) )  

(p=p+theme(plot.title = element_text(size = rel(2.5)),
           strip.text = element_text(size = rel(2)),
           axis.title.y = element_text(size = rel(2.5)),
           axis.title.x = element_text(size = rel(2.3)),
           axis.text = element_text(size = rel(2.3)))  )

# ggsave(p,file="/users/radivot/igv/agex.wmf")
# ggsave(p,file="/users/radivot/case/grants/sachs/HSCepi/figs/agex.png")
###############################################33
# for b test bin up times since exposure in groups of two to make fewer parameters
dHM=subset(d,Sex=="Male"&c==0)
head(dHM)
summary(hm0<-mle2(cml~dpois(lambda=py*(exp(c10 + k*age)+sv*exp(f)) ),
                 parameters=list(f~-1 + tsxf),
                 start=list(c10=-12.4,k=0.025,f=-10),data=dHM ) )

summary(hm1<-mle2(cml~dpois(lambda=py*(exp(c10 + k*age)+
                                         exp(-b*abs(agex-30)/28.85)*sv*exp(f)) ),
                  parameters=list(f~-1 + tsxf),
                  start=list(c10=-12.4,k=0.025,f=-10,b=0.5),data=dHM ) )
anova(hm0,hm1) # P=0.12  HM only => no longer can claim significance


# Skip below 
# #################### try full model
# summary(s3<-mle2(cml~dpois(lambda=py*(exp(c10 + c2c*c + c2s*s + k*age + ks*s*age)
#                                       +sv*exp(c2c*c  + f + c2sa*s*a55 )  ) ),
#                  parameters=list(f~-1 + tsxf:sex),
#                  start=list(c10=-12.4,k=0.025,ks=0,c2c=-1.50,
#                             c2s=-0.18,f=-5,c2sa=2),data=d) ) 
# 
# summary(s3x<-mle2(cml~dpois(lambda=py*(exp(c10 + c2c*c + c2s*s + k*age + ks*s*age)
#                     +sv*exp(c2c*c  + f + c2sa*s*a55 + c2x*(1-c)*(1-s)*abs(agex-30) )  ) ),
#                  parameters=list(f~-1 + tsxf:sex),
#                  start=list(c10=-12.4,k=0.025,ks=0,c2c=-1.50,
#                             c2s=-0.18,f=-5,c2sa=2,c2x=.05),data=d) ) 
# summary(a55HMb)
# AIC(s3,s3x)
# ICtab(s3,s3x)
# anova(s3,s3x)

# CLLcomputing.R
rm(list=ls()) 
library(dplyr)  
library(SEERaBomb) 
library(scales)
cf=function (x) comma_format()(x)
cfc=function (x) paste0(comma_format()(x),collapse=", ")
# the following were made earlier using SEERaBomb's mkSEER
load("~/data/SEER13/mrgd/cancDef.RData") #loads in canc
load("~/data/SEER13/mrgd/popsae.RData") # loads in popsa
# seerStats(canc,popsae)
head(canc)
# trim down columns to bare neccesities needed for this paper. 
canc=canc%>%select(-reg,-COD,-histo3,-ICD9,-db)
# answer reviewer's question regarding unknown survival and radiation types
svUnk=canc$surv==9999 # surv unknown = 9999 months
radUnk=canc$radiatn%in%c(8,9) # 8 and 9 are unknown
t1=table(svUnk,radUnk)
(t2=addmargins(t1))
78917/101584 # 77.7%
prop.table(t1) # over 97% both known => <3% either is unknown
# merge SLL in with CLL 
canc$cancer=as.character(canc$cancer)
canc$cancer[canc$cancer=="SLL"] ="CLL" 
canc$cancer=factor(canc$cancer)

#get CLLs in background incidence calcs
cf(canc%>%filter(cancer%in%c("CLL"))%>%group_by(cancer)%>%summarize(cases=n()) )
canc%>%filter(agedx>99,cancer%in%c("CLL"))%>%summarize(cases=n()) 
canc%>%filter(agedx<100,cancer%in%c("CLL"))%>%summarize(cases=n()) 
cf(sum(popsae$py)) # total PY at risk

#  get PY after firsts (note: we will subset on nonheme firsts after getting PY)
pm=seerSet(canc,popsae,Sex="male",ageStart=0,ageEnd=100) #pooled (races) male seerSet
pf=seerSet(canc,popsae,Sex="female",ageStart=0,ageEnd=100) #pooled (races) female seerSet
pm=mk2D(pm,secondS=c("CLL")) 
pf=mk2D(pf,secondS=c("CLL")) 
# plot2D(pm,col="gray") #  the pngs go to "~/Results/plots/pMs0e100/CLL.png"
# plot2D(pf,col="gray") #  the pngs go to "~/Results/plots/pFs0e100/CLL.png"
# to just look at the surfaces, override the default of write, e.g. use plot2D(pm,write=F)

########## START  get remaining numbers in Figure 1. 
# For Fig 1 we want all times t>0, so we set the brks vector to brks = 0
pm=tsd(pm,brks=0,trts=c("rad","noRad"),PYLong=T)  
pf=tsd(pf,brks=0,trts=c("rad","noRad"),PYLong=T) # get individual PY to make medians 
PYm=pm$L$b0$rad$PYL$'(0,100]' 
PYmN=pm$L$b0$noRad$PYL$'(0,100]' 
head(PYm) # cancer1 is the first cancer type, cancer2 the second cancer type
# year is the starting year of a PY strip of length py between ages ageL and ageR
PYf=pf$L$b0$rad$PYL$'(0,100]' #sexes are separated by default, so we have to merge them
PYfN=pf$L$b0$noRad$PYL$'(0,100]' #sexes are separated by default, so we have to merge them
PY=rbind(PYm,PYf)                                # with rbinds to get totals
HM=c("AML","AMLti","APL","MDS","CMML","CML","MPN","ALL","CLL","HCL","OL","NHL","MM","HL")
PYnh=PY%>%filter(!cancer1%in%HM)
cf(sum(PYnh$py))
cf(length(PYnh$py))
table(PYnh$cancer1)

PYN=rbind(PYmN,PYfN)
PYNnh=PYN%>%filter(!cancer1%in%HM)
cf(sum(PYNnh$py))
cf(length(PYNnh$py))

Om=pm$L$b0$rad$Obs$'(0,100]'
Of=pf$L$b0$rad$Obs$'(0,100]'
O=rbind(Om,Of)
cf(sum(O[!rownames(O)%in%HM,]))

Om=pm$L$b0$noRad$Obs$'(0,100]'
Of=pf$L$b0$noRad$Obs$'(0,100]'
O=rbind(Om,Of)
cf(sum(O[!rownames(O)%in%HM,]))

Em=pm$L$b0$rad$Exp$'(0,100]'
Ef=pf$L$b0$rad$Exp$'(0,100]'
E=rbind(Em,Ef)
cf(sum(E[!rownames(E)%in%HM,]))

Em=pm$L$b0$noRad$Exp$'(0,100]'
Ef=pf$L$b0$noRad$Exp$'(0,100]'
E=rbind(Em,Ef)
cf(sum(E[!rownames(E)%in%HM,]))

# zap out memory hog
pf$L$b0$rad$PYL$'(0,100]'=NULL
pf$L$b0$noRad$PYL$'(0,100]'=NULL
pm$L$b0$rad$PYL$'(0,100]'=NULL
pm$L$b0$noRad$PYL$'(0,100]'=NULL

########  now make CLL 2nd cancer RR time courses
brks=c(0,.1,.2,.3,0.6,1,1.5,2,2.5,3,4,5,7,10,13,16,20) 
pm=tsd(pm,brks=brks,trts=c("rad","noRad")) 
pf=tsd(pf,brks=brks,trts=c("rad","noRad")) 
system.time(save(pm,file="~/Results/CLL/pm.RData")) #~10 seconds
system.time(save(pf,file="~/Results/CLL/pf.RData")) #~10 seconds

load("/data/SEER/00/pops.RData") # this loads in pops
pyf=pym=vector(3,mode="list"); 
for (i in 0:18) { for (r in 1:2) {
		pym[[r]][i+1]=with(pops,sum(population[(popsex==1)&(popage==i)&(poprace==r)]))
		pyf[[r]][i+1]=with(pops,sum(population[(popsex==2)&(popage==i)&(poprace==r)]))}
	pym[[3]][i+1]=with(pops,sum(population[(popsex==1)&(popage==i)&(poprace>2)]))
	pyf[[3]][i+1]=with(pops,sum(population[(popsex==2)&(popage==i)&(poprace>2)])) }

load("/data/SEER/00/lymyleuk.RData") # this loads in DF
casesf=casesm=vector(3,mode="list"); 
for (i in 1:3) {
	if (i==3) d=DF[(DF$histo2==9863)&(DF$numprims==1)&(DF$race>2)&(DF$race<98),] else 
		d=DF[(DF$histo2==9863)&(DF$numprims==1)&(DF$race==i),] 
	casesm[[i]]=hist(d$agerec[d$sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
	casesf[[i]]=hist(d$agerec[d$sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts}	

(DF=data.frame(age=rep(c(0.5,3,seq(7.5,87.5,5)),6),race=rep(c("white","black","asian"),each=19,times=2),
	sex=rep(c("male","female"),each=57),cases=c(unlist(casesm),unlist(casesf)),py=c(unlist(pym),unlist(pyf))))
lapply(DF,class)
DF=subset(DF,age>20)
DF=transform(DF,agec=age-55)  # center so that intercept is incidence at age 55
head(DF)

summary(lmf<-glm(cases~agec*race*sex+offset(log(py)),family=poisson,data=DF))
# as expected, sex has no significant interactions with anything so move it to additive
summary(lmf<-glm(cases~agec*race+sex+offset(log(py)),family=poisson,data=DF))
# shows that Asians (reference group) do not differ significantly from blacks in slope, but do in intercept
# also shows that Asians differ from whites in both slope and intercept	
exp(0.383664) # confirms average M/F across races of ~1.5
exp(coef(lmf)[5]) # same thing: 5th coeff is male offset

summary(lmf<-glm(cases~agec+sex+offset(log(py)),family=poisson,data=subset(DF,race=="asian") ))
# confirms Asian slope of k= 0.025 in Figure 4 
exp(coef(lmf)[3]) # confirms Asian M/F = 1.7 in Figure 4

# interactions2D.R (Fig S2: show NHL and liver need an interaction term in the model)
library(SEERaBomb)
load("~/data/SEER/mrgd/cancDef.RData")
levels(canc$cancer)
load("~/data/SEER/mrgd/popsa.RData")
zap=c("cervixCIS","benign")
# mk2D cannot handle cervixCIS because it ends abruptly in 1995. Benigns 
# starting in 2004 are also a problem. The problem is that a plane of zeros ends
# up with too much of a smooth landing from the hills, i.e. tall cliffs aren't
# well approximated by splines. So for CMML and MDS special handing of smaller
# PY matrices takes place, but such code is ugly and hard to think about, so we
# don't want to clutter SEERaBomb source with additional special cases unless
# the second cancers are very important to us. So cervicalCIS and benigns are
# being left out. Note that benigns cause an additional problem, which is that
# their seqnums go 60 to 88. Handling this would be additional work that
# probably isn't worth it from a heme cancer centric perspective.
canc=canc%>%filter(!cancer%in%zap)
canc$cancer=factor(canc$cancer)
pm=seerSet(canc,popsa,Sex="Male")
pm=mk2D(pm,txt="interaction") # pooled race males, all male cancers not zapped get fitted
plot2D(pm)

# Figure 2 of active MS  (differs from Blood Fig 4 only in computing mean T and M/F)
aBombHome="/data/abomb"
cols=c("city","sex","doseg","agexg","calg","kerma","PY","adjPY","num.entering",
		"age","agex","tsx","cal","sv","gam","neut","lymphoma","NHL","leukemia","AML","ALL","CML","ATL","MM")      
d<-read.table(file.path(aBombHome,"hema87.dat"), header=F,col.names=cols);
d=d[d$adjPY>0,] #remove two recs with zero py
d=d[d$kerma==1,] # take only kerma < 4 Gy
d$py=10^4*d$adjPY
m=d[d$sex==1,]; f=d[d$sex==2,] 
years=c(1951,1953,1956,1959,1963,1968,1973,1978,1983,1987)-1945
agem=0
flin<-function(x,df) {
	c0=x[1];k=x[2];L=x[3:12]; # let data speak through L, like a one way anova
	with(df,{mn = exp(c0+k*(age-agem))*py + sv*exp(L[calg])*py;
				-sum(CML*log(mn) - mn)})	}

X0=c(c0=ifelse(agem==0,-13,-10),k=0.05,rep(-10,10))
solm=optim(X0,flin,df=m,method="L-BFGS-B",hessian=TRUE,control=list(maxit=400))  
waitm=exp(solm$par[3:12])
solf=optim(X0,flin,df=f,method="L-BFGS-B",hessian=TRUE,control=list(maxit=400))  
waitf=exp(solf$par[3:12])
graphics.off()
windows(width=5,height=5)
par(mfrow=c(1,1),mar=c(4.7,0,2.3,0.2),lwd=3,cex.lab=1.8,cex.axis=1.7,cex.main=1.7,oma=c(0,4.5,1,0.7))
plot(years,waitm,cex=2,pch=1,xlab="Years Since Exposure",ylab="",yaxt="n",col="blue",ylim=c(0,8.2e-4))
points(years,waitf,pch=2,cex=2,col="red")
legend(25,8.6e-4,c("Males","Females"),pch=1:2,col=c("blue","red"),cex=1.8,bty="n")
mtext(expression(paste("Cases per ",10^4," Person-Year-Sv")),side=2,line=2.6,cex=1.8,outer=T)
axis(side=2,las=1, at=c(0,2e-4,4e-4,6e-4,8e-4),labels=c(0,2,4,6,8),outer=T)
title("IR-to-CML Latency",outer=T,line=-1)
print(sum(waitm)/sum(waitf)); print(MovF<-format(sum(waitm)/sum(waitf),digits=2))
pm=waitm/sum(waitm)
pf=waitf/sum(waitf)
print(taum<-sprintf("%s yrs",format(years%*%pm,digits=3)))
print(tauf<-sprintf("%s yrs",format(years%*%pf,digits=4)))
mtext(bquote(tau[m] == .(taum)),side=3,line=-6,cex=1.5,adj=.9,col="blue")
mtext(bquote(tau[f] == .(tauf)),side=3,line=-7.5,cex=1.5,adj=.9,col="red")
mtext(bquote(M/F == .(MovF)),side=3,line=-9.3,cex=1.3,adj=.9)
par(mar=c(5.1,4.1,4.1,2.1),oma=c(0,0,0,0)) # reset to standards

### thyr2CMLfig1d.R   
# source("CML/naga/common.R")#run it first directly
secs=c("CML")#second cancers of interest
(d=canc%>%filter(cancer%in%c("thyroid",secs)))
load("~/data/SEER/mrgd/popsae.RData")
pf=seerSet(d,popsae,Sex="Female");pm=seerSet(d,popsae,Sex="Male") 
pf=mk2D(pf,secondS=secs);pm=mk2D(pm,secondS=secs)
trts=c("rad.noChemo","noRad.noChemo")
pf=csd(pf,brkst=c(0,1,6,10),brksa=c(0,60),trts=trts,firstS="thyroid")
pm=csd(pm,brkst=c(0,1,6,10),brksa=c(0,60),trts=trts,firstS="thyroid")
DF=bind_rows(pf$DF,pm$DF)
gx=xlab("Years Since Thyroid Cancer Diagnosis")
gy=ylab("Relative Risk of CML")
Ds=DF%>%group_by(sex,int,rad)%>%summarize(O=sum(O),E=sum(E),t=mean(t))
Ds=Ds%>%mutate(RR=O/E,rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E))
Ds=Ds%>%filter(rad=="Rad")
summary(m1<-mle2(O~dpois(lambda=(1+k1^3*t^2*exp(c1-k1*t))*E),
                 # parameters=list(c1~sex,k1~sex),
                 # parameters=list(k1~sex),
                 # parameters=list(c1~sex),
                 method="Nelder-Mead",start=list(c1=2.8,k1=.22),data=Ds,
                 control=list(maxit=10000))) 
pd=data.frame(t=seq(0,15,0.1),E=100)
(ds=data.frame(sex=c("Male","Female")))
pd=merge(ds,pd)
pd$Err=predict(m1,pd)/pd$E
Ds%>%ggplot(aes(x=t,y=RR,shape=sex))+
  geom_point(size=3)+
  gx+gy+gh+tc(14)+jco+sbb+ltb+gp+gl+geRR+cc+
  geom_line(aes(y=Err),size=.5,alpha=.4,data=pd)+
  theme(legend.position=c(.62,.75),legend.title=element_blank())
ggsave("~/Results/CML/thyr2CMLfig2B.pdf",width=4,height=3)
#  END Figure 1. Plot of thyroid cancer to CML kinetics 
#  Begin Calculation of latency of fitted curve
(cf=coef(summary(m1)))
(m1=round(cbind(point=cf[,1],LL=cf[,1]-1.96*cf[,2],UL=cf[,1]+1.96*cf[,2]),2))
(P=signif(cf[,4],2))
parms=row.names(cf)
(str=str_c(parms," = ",m1[,1]," (",m1[,2],", ",m1[,3],"), P = ",P,collapse="; "))
del=0.1
t=seq(0,100,del)
k=0.49
p=k^3*t^2*exp(-k*t)/2
sum(p)*del  #prove we have a prob density
p=k^3*t^3*exp(-k*t)/2
sum(p)*del  # mean of the density with k at its mean is 6.1 y
k=0.36
p=k^3*t^3*exp(-k*t)/2
sum(p)*del  # mean with k at its lower limit => latency upper limit
k=0.62
p=k^3*t^3*exp(-k*t)/2
sum(p)*del  # mean with k at its upper limit => latency lower limit
# END calculations of latency of smooth curve in Figure 1

# The point of this script is to discourage ICD-O3 9863 use because it is CML NOS (not otherwise specified).
# And to discourage O3 9875 (bcr-abl +) use because those tested may be selectively younger.
# Note that 9876 probably equals CMML since its aging rate constants are high. 
# Note also that ICD-O2 9863 is the sum of ICD-O3 9863 + 9875 + 9876

rm(list=ls(all=TRUE))
fexp<-function(p,dat)	{	c0=p[1];k=p[2]; 
	with(dat,{mn=exp(c0+k*age)*py
				-sum(cases*log(mn) - mn)})	}

load("/data/SEER/00/pops.RData") # this loads in pops
pym=NULL;pyf=NULL
for (i in 0:18) 
{   pym[i+1]=with(pops,sum(population[(popsex==1)&(popage==i)]))
	pyf[i+1]=with(pops,sum(population[(popsex==2)&(popage==i)])) }

load("/data/SEER/00/lymyleuk.RData") # this loads in DF
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
graphics.off()
windows(width=13,height=7,xpos=-300)
par(mfrow=c(2,3),mar=c(4.7,6,3.3,1),oma=c(0,0,0,0),lwd=3,cex.lab=1.8,cex.axis=1.7,cex.main=1.8)
for (i in 1:6) {
	if (i==1) {Indx=(DF$histo2==9863);tit="CML 9863 O2 "} 
	if (i==2) {Indx=(DF$histo2==9863)&(DF$seqnum<2);tit="CML 9863 O2 First"} 
	if (i==3) {Indx=(DF$histo2==9863)&(DF$numprims==1);tit="CML 9863 O2 Only 1"} 
	if (i==4) {Indx=(DF$histo3==9863);tit="CML NOS 9863 O3"} 
	if (i==5) {Indx=(DF$histo3==9863)&(DF$seqnum<2);tit="CML NOS 9863 O3 First"} 
	if (i==6) {Indx=(DF$histo3==9863)&(DF$numprims==1);tit="CML NOS 9863 O3 Only 1 "} 
	d=DF[Indx,] # paper used SEER 1973-2008
	m=hist(d$agerec[d$sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
	f=hist(d$agerec[d$sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
	age=c(0.5,3,seq(7.5,87.5,5))
	datam=data.frame(age,cases=m,py=pym,incid=m/pym)[6:19,] 
	dataf=data.frame(age,cases=f,py=pyf,incid=f/pyf)[6:19,]
	plot(age,m/pym,log="y",xlab="Age",type='p',col='blue',pch=1,ylab="",cex=2,yaxt="n",ylim=c(1e-7,1e-4)  )
	lines(age,f/pyf,type='p',col='red',cex=2,pch=2)  
	ssolm=optim(c(c0=-10,k=.1),fexp,dat=datam)
	ssolf=optim(c(c0=-10,k=.1),fexp,dat=dataf)
	ym=exp(ssolm$par["c0"]+ssolm$par["k"]*age[6:19])
	yf=exp(ssolf$par["c0"]+ssolf$par["k"]*age[6:19])
	axis(side=2,las=1, at=c(1e-7,1e-6,1e-5,1e-4),labels=expression(.1,1,10,10^2))
	lines(age[6:19],ym,col="blue")
	lines(age[6:19],yf,col="red")
	mtext(expression(paste("Cases per ",10^6," Person-Years")),side=2,line=3.3,cex=1.5)
	title(paste(tit,"2000-2010"))
	legend(-3,1.7e-4,
      c(sprintf("%3s Males; M/F=%3.2f; k = %5.3f",sum(m),mean(datam$incid/dataf$incid),ssolm$par["k"]),
		sprintf("%3s Females; k = %5.3f",sum(f),ssolf$par["k"])),
		col=c("blue","red"),pch=1:2,text.col=c("blue","red"),bty="n",cex=1.7)
}

windows(width=13,height=7,xpos=-300, ypos=-50)
par(mfrow=c(2,3),mar=c(4.7,6,3.3,1),oma=c(0,0,0,0),lwd=3,cex.lab=1.8,cex.axis=1.7,cex.main=1.8)
for (i in 1:6) {
	if (i==1) {Indx=(DF$histo3==9875);tit="CML 9875 O3 (BA-)"} 
	if (i==2) {Indx=(DF$histo3==9875)&(DF$seqnum<2);tit="CML 9875 O3 First"} 
	if (i==3) {Indx=(DF$histo3==9875)&(DF$numprims==1);tit="CML 9875 O3 Only 1 "} 
	if (i==4) {Indx=(DF$histo3==9876);tit="CML 9876 O3 (BA-)"} 
	if (i==5) {Indx=(DF$histo3==9876)&(DF$seqnum<2);tit="CML 9876 O3 First"} 
	if (i==6) {Indx=(DF$histo3==9876)&(DF$numprims==1);tit="CML 9876 O3 Only 1 "} 
	d=DF[Indx,] # paper used SEER 1973-2008
	m=hist(d$agerec[d$sex==1],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
	f=hist(d$agerec[d$sex==2],breaks=c(seq(-.5,17.5,1),100),plot=FALSE)$counts
	age=c(0.5,3,seq(7.5,87.5,5))
	datam=data.frame(age,cases=m,py=pym,incid=m/pym)[6:19,] 
	dataf=data.frame(age,cases=f,py=pyf,incid=f/pyf)[6:19,]
	plot(age,m/pym,log="y",xlab="Age",type='p',col='blue',pch=1,ylab="",cex=2,yaxt="n",ylim=c(1e-7,1e-4)  )
	lines(age,f/pyf,type='p',col='red',cex=2,pch=2)  
	ssolm=optim(c(c0=-10,k=.1),fexp,dat=datam)
	ssolf=optim(c(c0=-10,k=.1),fexp,dat=dataf)
	ym=exp(ssolm$par["c0"]+ssolm$par["k"]*age[6:19])
	yf=exp(ssolf$par["c0"]+ssolf$par["k"]*age[6:19])
	axis(side=2,las=1, at=c(1e-7,1e-6,1e-5,1e-4),labels=expression(.1,1,10,10^2))
	lines(age[6:19],ym,col="blue")
	lines(age[6:19],yf,col="red")
	mtext(expression(paste("Cases per ",10^6," Person-Years")),side=2,line=3.3,cex=1.5)
	title(paste(tit,"2000-2010"))
	legend(-3,1.7e-4,
			c(sprintf("%3s Males; M/F=%3.2f; k = %5.3f",sum(m),mean(datam$incid/dataf$incid,na.rm=T),ssolm$par["k"]),
					sprintf("%3s Females; k = %5.3f",sum(f),ssolf$par["k"])),
			col=c("blue","red"),pch=1:2,text.col=c("blue","red"),bty="n",cex=1.7)
}

# timeCrs.R   (CLL RR time courses after Non-Hematological first cancers)
rm(list=ls()) 
library(SEERaBomb) 
library(reshape2)
library(dplyr)  
library(grid)
load("~/Results/CLL/pm.RData") 
load("~/Results/CLL/pf.RData") 
brks=c(0,.1,.2,.3,0.6,1,1.5,2,2.5,3,4,5,7,10,13,16,20) # res back up since now only CLL
(brkS=paste0("b",paste(brks,collapse="_")))
HM=c("AML","AMLti","APL","MDS","CMML","CML","MPN","ALL","CLL","HCL","OL","NHL","MM","HL")
dm=mkDF(pm,brkS)
df=mkDF(pf,brkS)
df=df[!df$cancer1%in%HM,]  # exclude non-heme first cancers
dm=dm[!dm$cancer1%in%HM,]
paste(levels(df$int),collapse=", ") # to paste intervals into Figure caption
# sum observed and expected cases across all non-heme first cancer types
f=df%>%group_by(trt,int)%>%summarize(O=sum(O),E=sum(E),t=mean(t,na.rm=T),sex="Female")
m=dm%>%group_by(trt,int)%>%summarize(O=sum(O),E=sum(E),t=mean(t,na.rm=T),sex="Male")
D=rbind(f,m)
(D=D%>%mutate(RR=O/E,rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E)))
D$Radiation="No" # update treatment names for legend
D$Radiation[D$trt=="rad"]="Yes"
D$Period="Early"  # make two separate time scales for plotting
D$Period[D$t>5]="Late"
graphics.off()
quartz(width=6.5,height=3.8)
# theme_set(theme_bw())
theme_update(legend.position = c(.80, .35))
theme_update(axis.text=element_text(size=rel(1.4)),
             axis.title=element_text(size=rel(1.4)),
             legend.title=element_text(size=rel(1.1)),
             legend.text=element_text(size=rel(1.1)),
             strip.text = element_text(size = rel(1.4)))
g=qplot(x=t,y=RR,data=D,col=Radiation,geom=c("line","point"),
        xlab="Years Since Dx of Non-Hematologic 1st Cancer",ylab="CLL 2nd Cancer Relative Risk")
g=g+scale_y_log10(breaks=c(0.3,1,10),labels=c("0.3","1","10"),limits=c(0.2,20))
g=g+facet_grid(sex~Period,scales="free")+geom_abline(intercept=0, slope=0)
# g = g + scale_color_grey(start = 0, end = 0.6)
g=g+  geom_errorbar(aes(ymin=rrL,ymax=rrU,width=.15))+ theme(legend.key.height=unit(.45, "cm"))
print(g)
ggsave("~/Results/CLL/timeCrs.eps") 

#allTimeRRtab1.R  (gets all-time RR in Table 1)
# first run CLLcomputing.R
rm(list=ls())
library(dplyr)
library(SEERaBomb)
system.time(load("~/Results/CLL/pm.RData")) # 1 secs to load. 
system.time(load("~/Results/CLL/pf.RData")) # 1 secs to load. 
mkci=function(x) sprintf("%.2f (%.2f, %.2f)",x[1],x[2],x[3])
dm=mkDF(pm,"b0")
df=mkDF(pf,"b0")
HM=c("AML","AMLti","APL","MDS","CMML","CML","MPN","ALL","CLL","HCL","OL","NHL","MM","HL")
df=df[!df$cancer1%in%HM,]
dm=dm[!dm$cancer1%in%HM,]
head(df)
f=df%>%group_by(trt)%>%summarize(O=sum(O),E=sum(E),sex="F")
m=dm%>%group_by(trt)%>%summarize(O=sum(O),E=sum(E),sex="M")
D=rbind(f,m)
(T1=D%>%mutate(RR=O/E,rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E)))
mkci(T1[1,5:7]) #F IR
mkci(T1[2,5:7]) #F no IR
mkci(T1[3,5:7]) #M IR
mkci(T1[4,5:7]) #M no IR

#now pool sexes
D1=D%>%group_by(trt)%>%summarize(O=sum(O),E=sum(E))
(T1=D1%>%mutate(RR=O/E,rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E)))
mkci(T1[1,4:6]) #IR
mkci(T1[2,4:6]) # no IR

# NOTE: This script assumes that the SEER data is in /data/SEER 
.seerHome="/data/SEER" 
rm(list=ls()) # note: dot variables defined above persist through such cleanings
# install.packages("RSQLite")
# install.packages("bbmle")
# install.packages("ggplot2")
library(RSQLite)
m=dbDriver("SQLite")
library(plyr)
library(bbmle)
library(ggplot2)

# SEER CML versus Race Figure 4 (show sex CI separately)
con=dbConnect(m,dbname=file.path(.seerHome,"00/all.db"))
pops=dbGetQuery(con, "SELECT * from pops where popyear>2000 and popage>5 and popage<19")
head(pops,20)
summary(as.factor(pops$poprace))
pops$poprace[pops$poprace>2]=3
(pop<-ddply(pops, .(popage,popsex,poprace), summarise,py=sum(population)))
head(pop)
d=dbGetQuery(con, 
# ICDO3 CML codes 9875 = bcr-abl+ and 9876 =bcr-abl neg CML are not in full use yet, i.e.
# many ICD-O3 CML codes are still 9863 carried over from ICD-O2
# "SELECT * from lymyleuk where histo3=9876 and seqnum<2 and race<98 and agerec>5 and agerec<19")
"SELECT * from lymyleuk where histo2=9863 and seqnum<2 and race<98 and agerec>5 and agerec<19")
d$race[d$race>2]=3
head(d)
(ddply(d, .(agerec,sex,race), summarise,cases=length(agerec))) #only 5 of the 16s 
count(d, vars=c("agerec","sex","race"))  # same here, and no options to fix it
(d=ddply(d, .(agerec,sex,race), summarise,cases=length(agerec),.drop=F))# this gets them all
head(cbind(d,pop)) # see alignment
d=cbind(d,py=pop[,"py"])
d=transform(d,incid=1e6*cases/py)
head(d,15)
d$Sex=factor(d$sex,labels=c("Male","Female"))
d$race=factor(d$race,labels=c("White","Black","Asian"))
age=c(0.5,3,seq(7.5,87.5,5))
d$age=age[d$agerec+1]
d$age55=d$age-55
d$s=d$sex-1
head(d,15)
dwm=subset(d,race=="White"&Sex=="Male")
dwf=subset(d,race=="White"&Sex=="Female")
summary(wm<-mle2(cases~dpois(lambda=exp(c+k*age)*py),method="Nelder-Mead",
             start=list(c=-12,k=0.04),data=dwm))
summary(wf<-mle2(cases~dpois(lambda=exp(c+k*age)*py),method="Nelder-Mead",
                 start=list(c=-12,k=0.04),data=dwf))
dbm=subset(d,race=="Black"&Sex=="Male")
dbf=subset(d,race=="Black"&Sex=="Female")
summary(bm<-mle2(cases~dpois(lambda=exp(c+k*age)*py),method="Nelder-Mead",
                 start=list(c=-12,k=0.04),data=dbm))
summary(bf<-mle2(cases~dpois(lambda=exp(c+k*age)*py),method="Nelder-Mead",
                 start=list(c=-12,k=0.04),data=dbf))
dam=subset(d,race=="Asian"&Sex=="Male")
daf=subset(d,race=="Asian"&Sex=="Female")
summary(am<-mle2(cases~dpois(lambda=exp(c+k*age)*py),method="Nelder-Mead",
                 start=list(c=-12,k=0.04),data=dam))
summary(af<-mle2(cases~dpois(lambda=exp(c+k*age)*py),method="Nelder-Mead",
                 start=list(c=-12,k=0.04),data=daf))
kwmci=c(coef(wm)[2],confint(wm)[2,])
kwfci=c(coef(wf)[2],confint(wf)[2,])
kbmci=c(coef(bm)[2],confint(bm)[2,])
kbfci=c(coef(bf)[2],confint(bf)[2,])
kamci=c(coef(am)[2],confint(am)[2,])
kafci=c(coef(af)[2],confint(af)[2,])
outs=rbind(kwmci,kwfci,kbmci,kbfci,kamci,kafci)
row.names(outs)<-c("White Males","White Females","Black Males","Black Females",
                   "Asian Males","Asian Females")
(outs=round(outs,4))
library(hwriter)
setwd("/users/radivot/downloads/sachs")
hwrite(outs,"table1.html")

### fig1abcTab1.R    Figure 1abc and Table 1  and calculations in the text 
# source("~/case/active/seer/CML/naga/common.R") #run it first directly
load("~/data/abomb/abomb.RData")#loads data frames heme and solid 
(d=heme%>%select(city,sex,ageG:DG,age,year,t,D,py,CML))
d%>%filter(CML>0)%>%print(n=100)
d$ageG=cut(d$age,c(0,20,40,60,80,126),include.lowest =T)
d$DG="Unknown"  #negative doses are unknown
d$DG[d$D==0]="Not in City"
d$DG[d$D>0&d$D<0.2]="<0.2 Sv"
d$DG[d$D>=0.2&d$D<=1]="0.2-1 Sv"
d$DG[d$D>1]=">1 Sv" #next line puts >1Sv at top of legends
d$DG=factor(d$DG,levels=c(">1 Sv","0.2-1 Sv","<0.2 Sv","Not in City","Unknown"))
(dA=incidAbomb(d%>%group_by(ageG,DG)))
# get SEER groups
load("~/data/SEER/mrgd/popsae.RData") 
(D=incidSEER(canc,popsae,"CML")) #%>%filter(race=="Other"))
D=D%>%mutate(ageG=cut(age,c(0,20,40,60,80,126),include.lowest=T))%>%
  group_by(cancer,race,ageG)%>%summarize(age=mean(age),py=sum(py),O=sum(n))%>%
  mutate(I=O/py,LL=qpois(0.025,O)/py,UL=qpois(0.975,O)/py)
D$DG=paste0("SEER ",D$race)
D=bind_rows(dA,D) 
D=D%>%filter(!DG%in%c(">1 Sv","0.2-1 Sv","Unknown")) # next line puts SEER at bottom
D$DG=factor(D$DG,levels=c("<0.2 Sv","Not in City","SEER White","SEER Black","SEER Other"))
D$age=D$age+(as.integer(D$DG)-3)/4 #shift on both sides to see CI
myt=theme(legend.position=c(.52,.85),legend.key.height=unit(.7,'lines'))
cc=coord_cartesian(ylim=c(.2,15));f=facet_wrap(~cancer)
gx=xlab("Attained Age (Years)");gp3=geom_point(size=3)
ggplot(D,aes(x=age,y=I,shape=DG))+gp3+gl+gx+sy+gyi+ge+cc+tc(14)+myt+jco+sbb+ltb
ggsave("~/Results/CML/abombAgeFig1A.pdf",width=4,height=3.2)
# END creating Figure 1A
# Begin creating Table 1
d=d%>%mutate(city=ifelse(city==1,"Hiroshima","Nagasaki"))
d=d%>%mutate(sex=as_factor(ifelse(sex==1,"Male","Female")))
d1=d%>%group_by(city,sex,DG,ageG)%>%  #set aside A-bomb as d1
  summarize(t=weighted.mean(t,w=CML),CML=sum(CML),age=mean(age),py=sum(py))
(D=incidSEER(canc,popsae,"CML")) #recreate to make sex specific rates for E estimates
(D=D%>%filter(year>=2000)%>%mutate(ageG=cut(age,c(0,20,40,60,80,126),include.lowest =T)))
(D=D%>%group_by(sex,race,ageG)%>%
    summarize(age=mean(age),py=sum(py),n=sum(n))%>%mutate(incid=n/py))
(dS=ungroup(D)%>%filter(race=="Other")%>%select(sex,ageG,incidence=incid))
(dB=left_join(d1,dS))
dB=dB%>%mutate(E=incidence*py/1e5)
dB=dB%>%select(city,sex,DG,ageG,O=CML,E,t)
dB=ungroup(dB)%>%mutate(E=round(E,3),t=round(t,1),t=ifelse(is.nan(t),NA,t))
dB=dB%>%filter(as.integer(DG)<=3) #leave out NIC and UNK DG in tables
library(openxlsx)
hs1=createStyle(fgFill="#DDDDDD",halign="CENTER",textDecoration="bold")
hs2=createStyle(fgFill="#FFFFFF",halign="CENTER",textDecoration="bold")
unlink(f<-"~/Results/CML/Table1.xlsx")
wb <- createWorkbook() 
addWorksheet(wb,"NH")
(tbm=dB%>%filter(city=="Nagasaki",sex=="Male")%>%select(-city,-sex))
(tbf=dB%>%filter(city=="Nagasaki",sex=="Female")%>%select(-city,-sex))
snm=tbm%>%group_by(DG)%>%summarize(O=sum(O),E=sum(E),t=mean(t,na.rm=T))
snf=tbf%>%group_by(DG)%>%summarize(O=sum(O),E=sum(E),t=mean(t,na.rm=T))
snf$t[is.nan(snf$t)]=NA
writeData(wb,"NH",data.frame("1950-2001"), startRow=1,colNames=F)
mergeCells(wb,"NH", cols = 4:9, rows = 1)
writeData(wb,"NH",data.frame("                                  Nagasaki"), startRow=1,startCol=4,colNames=F,headerStyle = hs2)
# writeData(wb,"NH",data.frame("Totals"), startRow=19,colNames=F)
mergeCells(wb,"NH", cols = 4:6, rows = 2)
mergeCells(wb,"NH", cols = 7:9, rows = 2)
writeData(wb,"NH",data.frame("               Males"), startRow=2,startCol=4,colNames=F)
writeData(wb,"NH",data.frame("             Females"), startRow=2,startCol=7,colNames=F)
names(tbm)=c("Dose","Age","Obs","Exp","Tsx")
names(tbf)=c("Dose","Age","Obs","Exp","Tsx")
# names(snm)=c("Totals","Obs","Exp")
# names(snf)=c("Dose","Obs","Exp")
writeData(wb,"NH",tbm[1:2], startRow=3,startCol=1,headerStyle = hs1)
writeData(wb,"NH",tbm[3:5], startRow=3,startCol=4,headerStyle = hs1)
writeData(wb,"NH",tbf[3:5], startRow=3,startCol=7,headerStyle = hs1)
writeData(wb,"NH",snm[1],   startRow=19,startCol=1,colNames=F)
writeData(wb,"NH",data.frame(rep("all",3)), startRow=19,startCol=2,colNames=F)
writeData(wb,"NH",snm[2:4],  startRow=19,startCol=4,colNames=F)
writeData(wb,"NH",snf[2:4],  startRow=19,startCol=7,colNames=F)
setColWidths(wb, "NH", cols=4:16, widths = 4)
setColWidths(wb, "NH", cols=c(5,8,12,15), widths = 6)
setColWidths(wb, "NH", cols=c(3,10), widths = 0.25)
(tbm=dB%>%filter(city=="Hiroshima",sex=="Male")%>%select(-city,-sex))
(tbf=dB%>%filter(city=="Hiroshima",sex=="Female")%>%select(-city,-sex))
shm=tbm%>%group_by(DG)%>%summarize(O=sum(O),E=sum(E),t=mean(t,na.rm=T))
shf=tbf%>%group_by(DG)%>%summarize(O=sum(O),E=sum(E),t=mean(t,na.rm=T))
mergeCells(wb,"NH", cols = 11:16, rows = 1)
mergeCells(wb,"NH", cols = 11:13, rows = 2)
mergeCells(wb,"NH", cols = 14:16, rows = 2)
writeData(wb,"NH",data.frame("                                   Hiroshima"), startRow=1,startCol=11,colNames=F)
writeData(wb,"NH",data.frame("               Males"), startRow=2,startCol=11,colNames=F)
writeData(wb,"NH",data.frame("             Females"), startRow=2,startCol=14,colNames=F)
names(tbm)=c("Dose","Age","Obs","Exp","Tsx")
names(tbf)=c("Dose","Age","Obs","Exp","Tsx")
writeData(wb,"NH",tbm[3:5],      startRow=3,startCol=11,headerStyle = hs1)
writeData(wb,"NH",tbf[3:5], startRow=3,startCol=14,headerStyle = hs1)
writeData(wb,"NH",shm[2:4],  startRow=19,startCol=11,colNames=F)
writeData(wb,"NH",shf[2:4],  startRow=19,startCol=14,colNames=F)
saveWorkbook(wb,file=f,overwrite = TRUE)
###### END creating Table 1
###### below are calculations given in the text
library(rateratio.test)
(hn2=dB%>%filter(ageG!="[0,20]",DG==">1 Sv"|DG=="0.2-1 Sv")%>%
  group_by(city)%>%summarize(O=sum(O),E=sum(E)))
rateratio.test(c(0,29),c(1.54,5)) #adults P=0.0008
(hn1=dB%>%filter(ageG=="[0,20]",DG==">1 Sv"|DG=="0.2-1 Sv")%>%
  group_by(city)%>%summarize(O=sum(O),E=sum(E)))
rateratio.test(c(2,3),c(0.01,0.028)) #children P=0.8
(x=dpois(0:10,0.01)) 
1-sum(x[1:2]) #Nagasaki P value for difference from RR=1 
(x=dpois(0:10,0.03)) #same for Hiroshima
1-sum(x[1:3]) 
# city difference P values below
(hn=dB%>%filter(DG=="<0.2 Sv")%>%
    group_by(city)%>%summarize(O=sum(O),E=sum(E)))
rateratio.test(hn$O,hn$E) # low doses, all ages combined
O=24; E=25.6
round(c(O/E,qchisq(0.025, 2*O)/(2*E),qchisq(0.975, 2*O+2)/(2*E)),2)
O=9; E=11.3
round(c(O/E,qchisq(0.025, 2*O)/(2*E),qchisq(0.975, 2*O+2)/(2*E)),2)

(t1=dB%>%filter(ageG=="[0,20]",DG=="<0.2 Sv")%>%
    group_by(city)%>%summarize(O=sum(O),E=sum(E)))
rateratio.test(t1$O,t1$E) #low doses, young
(t1=dB%>%filter(ageG!="[0,20]",DG=="<0.2 Sv")%>%
    group_by(city)%>%summarize(O=sum(O),E=sum(E)))
rateratio.test(t1$O,t1$E)#low doses, NOT young 
## Create RR CI
(HN=bind_rows(hn2,hn1,hn))
(HN=HN%>%mutate(RR=O/E,low=qchisq(0.025, 2*O)/(2*E),hi=qchisq(0.975, 2*O+2)/(2*E)))
O=0; E=1.5
round(c(O/E,qchisq(0.025, 2*O)/(2*E),qchisq(0.975, 2*O+2)/(2*E)),2)
O=29; E=5; O/E
c(qchisq(0.025, 2*O)/(2*E),qchisq(0.975, 2*O+2)/(2*E))
O=2;E=0.01; O/E
c(qchisq(0.025, 2*O)/(2*E),qchisq(0.975, 2*O+2)/(2*E))
O=3; E=0.03; O/E
c(qchisq(0.025, 2*O)/(2*E),qchisq(0.975, 2*O+2)/(2*E))
### make forest plot
graphics.off()
quartz(width=7,height=2.2)
myticks=c(-1,0,1,2,3)
attr(myticks,"labels")=as.character(c(0.1,1,10,100,1000))
dput(myticks)
(myticks)
library(forestplot)
text <- bind_cols(t1=c("","City",NA,HN$city),
             t2=c("","Age (y)",NA,c(rep(">20",2),rep("<20",2),rep("All",2)) ),
             t3=c("","Dose (mSv)",NA,c(rep(">200",4),rep("<200",2)) ))
text <- bind_cols(t1=c("City",NA,HN$city),
                  t2=c("Age (y)",NA,c(rep(">20",2),rep("<20",2),rep("All",2)) ),
                  t3=c("Dose (mSv)",NA,c(rep(">200",4),rep("<200",2))),
                  t4=c("Obs/Exp",NA,paste0(HN$O,"/",round(HN$E,2))))
text
forestplot(text, 
           mean=c(rep(NA,2),log10(HN$RR)),
           lower=c(rep(NA,2),log10(HN$low)),
           upper=c(rep(NA,2),log10(HN$hi)),
           # title="Nagasaki Mystery",
           xlab="Relative Risk of CML",
           col=fpColors(box="black", lines="black", zero = "gray50"),
           zero=-1,
           xticks=myticks,
           boxsize=0.3,
           colgap=unit(3,"mm"),
           lineheight = unit(7,"mm"),
           lwd.ci=1.3, ci.vertices=TRUE, ci.vertices.height = 0.2,
           clip=c(-1,3),
           txt_gp=fpTxtGp(label=gpar(cex=1),
                          ticks=gpar(cex=1),
                          xlab=gpar(cex = 1),
                          title=gpar(cex = 1))
           )  #end forest plot
## END RR CI
## Get P value for longer delays in HF 
d3m=d%>%filter(DG==">1 Sv",city=="Hiroshima",CML==1,sex=="Male")
d3f=d%>%filter(DG==">1 Sv",city=="Hiroshima",CML==1,sex=="Female")
wilcox.test(d3f$t,d3m$t) #P=0.02
quantile(d3f$t)
quantile(d3m$t) 
(L=list(F=sort(round(d3f$t,1)),M=sort(round(d3m$t,1))))
lapply(L,paste0,collapse=", ")
Dt=data.frame(t=c(d3f$t,d3m$t),Sex=c(rep("Female",6),rep("Male",10)))
graphics.off()
Dt%>%ggplot(aes(x=Sex,y=t))+geom_boxplot(alpha=0)+geom_jitter(width=.15)+
  ylab("CML Latency (Years)")+tc(14)
ggsave("~/Results/CML/latencyFig2A.pdf",width=4,height=2.8)
heme%>%filter(DG==">1Sv",city==1,CML==1)%>%select(sex,D,age,t)
dB%>%filter(DG==">1 Sv")%>%group_by(city)%>%summarize(O=sum(O),E=sum(E))
dB%>%filter(DG==">1 Sv")%>%group_by(city,sex)%>%summarize(O=sum(O),E=sum(E))
O=16;E=0.96;O/E
c(qchisq(0.025, 2*O)/(2*E),qchisq(0.975, 2*O+2)/(2*E))
# Get P values for young being all Males
rateratio.test(c(2,0),c(0.006,0.004), alt="greater")  # N young M vs. F
rateratio.test(c(3,0),c(0.017,0.011), alt="greater")#H young M vs. F
rateratio.test(c(5,0),c(0.023,0.015), alt="greater")#HN young M vs. F
# show no other diffs in Nagasaki
rateratio.test(c(5,4),c(5.5,5.9), alt="greater")#N low dose total
rateratio.test(c(2,0),c(0.8,0.76), alt="greater")#N >200 mSv, M vs. F, all ages
rateratio.test(c(7,3),c(0.96,1.36), alt="greater")  # P=0.066  old M vs. F
# Neutron dose differences between cities
head(heme)
heme%>%filter(D>0.2)%>%group_by(city)%>%summarize(ratio=1-mean(g/D,na.rm=T))
heme%>%group_by(city)%>%summarize(ratio=weighted.mean(g/D,na.rm=T,weight=py))
# Get ATL city differences
(d=heme%>%select(city,sex,ageG:DG,age,year,t,D,py,ATL)) 
d=d%>%mutate(city=ifelse(city==1,"Hiroshima","Nagasaki"))
d=d%>%mutate(sex=as_factor(ifelse(sex==1,"Male","Female")))
(da=d%>%group_by(city)%>%summarize(t=weighted.mean(t,w=ATL),
                                   ATL=sum(ATL),age=mean(age),
                                   py=sum(py)/1e5,incid=ATL/py))
rateratio.test(da$ATL,da$py) 
(da=d%>%group_by(city,sex)%>%summarize(t=weighted.mean(t,w=ATL),
                                       ATL=sum(ATL),age=mean(age),
                                       py=sum(py)/1e5,incid=ATL/py))
da%>%mutate(rrL=qchisq(.025,2*ATL)/(2*py),rrU=qchisq(.975,2*ATL+2)/(2*py))
## Standarized incidence: compare SEER race other vs. white
(D=incidSEER(canc,popsae,"CML")) #recreate to get sex specific rates 
(D=D%>%filter(year>=2000)%>%group_by(race,age)%>%
    summarize(py=sum(py),n=sum(n))%>%mutate(incid=n/py))
D%>%summarize(py=sum(py*stdUS$prop),n=sum(n))%>%mutate(incid=n/py)
82.7/107 #77% not quite 50% as below but in right direction
# https://www.ncbi.nlm.nih.gov/pmc/articles/PMC3907701/pdf/bjh0164-0536.pdf
(d=heme%>%select(city,sex,ageG:DG,age,year,t,D,py,CML)) 
d=d%>%mutate(city=ifelse(city==1,"Hiroshima","Nagasaki"))
(db=d%>%filter(city=="Hiroshima",CML==1)%>%mutate(Sex=c("M","F")[sex]))
db%>%ggplot(aes(x=Sex,y=t))+geom_boxplot(alpha=0)+geom_jitter(width=.15)+facet_grid(~DG)+
  ylab("Hiroshima CML Latency (Years)")+tc(14)+sbb
ggsave("~/Results/CML/hiroCMLlatencyNIC.pdf",width=5,height=3)
(db1=db%>%group_by(DG)%>%nest())
d1=db1$data[[1]]
db1=db1%>%mutate(wc=map(data,function(x) wilcox.test(t~sex,data=x)))
db1%>%mutate(P=map_dbl(wc,function(x) x$p.value))%>%select(DG,P)

rm(list=ls());library(tidyverse);library(SEERaBomb)
load("~/data/SEER/mrgd/popsae.RData")
(p=popsae%>%count(race,sex,age,year,wt=py)%>%rename(py=n))
load("~/data/SEER/mrgd/cancDef.RData")
canc$cancer=fct_collapse(canc$cancer,AML=c("AML","AMLti","APL"))
secs=c("CML","AML","ALL")
(d=canc%>%filter(cancer%in%c("thyroid",secs)))
pf=seerSet(d,p,Sex="Female");pm=seerSet(d,p,Sex="Male") 
pf=mk2D(pf,secondS=secs);pm=mk2D(pm,secondS=secs)
trts=c("rad.noChemo","noRad.noChemo")
pf=csd(pf,brkst=c(0,1,2,3,5,10),brksa=c(0,60),trts=trts,firstS="thyroid")
pm=csd(pm,brkst=c(0,1,2,3,5,10),brksa=c(0,60),trts=trts,firstS="thyroid")
DF=bind_rows(pf$DF,pm$DF)
DF=DF%>%mutate(cancer2=fct_relevel(cancer2,"AML"))
DF$t=DF$t+c(0,0.075,0.15)
D=DF%>%group_by(int,rad,cancer2)%>%summarize(O=sum(O),E=sum(E),t=mean(t))
D=D%>%mutate(RR=O/E,rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E))
Dtop=D%>%mutate(grp=str_c(rad,": All Ages"))
D=DF%>%filter(rad=="Rad")
D=D%>%group_by(int,ageG,cancer2)%>%summarize(O=sum(O),E=sum(E),t=mean(t))
D=D%>%mutate(RR=O/E,rrL=qchisq(.025,2*O)/(2*E),rrU=qchisq(.975,2*O+2)/(2*E))
D$ageG=c("Age 0-60","Age >60")[D$ageG]
Dbot=D%>%mutate(grp=str_c("Rad: ",ageG))
D=bind_rows(Dtop,Dbot)
D$grp=as_factor(D$grp)
myt=theme(legend.title=element_blank(),legend.margin=margin(0,0,0,0))
myth=theme(legend.direction="horizontal",legend.key.height=unit(.25,'lines'))
myth=myt+myth+theme(legend.position=c(.25,.95))
g=ggplot(aes(x=t,y=RR,col=cancer2),data=D)+geom_point()+geom_line()+myth+
  labs(x="Years Since Thyroid Cancer Diagnosis",y="Relative Risk of Leukemia")
g=g+facet_wrap(~grp)+geom_abline(intercept=1,slope=0) 
g+geom_errorbar(aes(ymin=rrL,ymax=rrU),width=0.1)+coord_cartesian(ylim=c(0,15))
ggsave("~/Results/tutorial/thyroid2leu.pdf",width=4,height=2.5)

# 
# 
# graphics.off();quartz(width=4,height=2.5)
# myt=theme(legend.position=c(.25, .95),legend.title=element_blank(),
#           legend.direction="horizontal",legend.margin=margin(0,0,0,0),
#           legend.key.height = unit(.25, 'lines'))
# g=ggplot(aes(x=t,y=RR,col=cancer2),data=D)+geom_point()+geom_line(size=1)+myt+
#   labs(x="Years Since Thyroid Cancer Diagnosis",y="Relative Risk of Leukemia")
# g=g+facet_grid(~rad)+geom_abline(intercept=1, slope=0) 
# g +geom_errorbar(aes(ymin=rrL,ymax=rrU)) +coord_cartesian(ylim = c(0, 10))
# ggsave("~/Results/tutorial/thyroid2leu.pdf") # Fig 5
# 
# g=ggplot(aes(x=t,y=RR,col=cancer2),data=D)+geom_point()+geom_line(size=1)+myt+
#   labs(x="Years Since Thyroid Cancer Diagnosis",y="Relative Risk of Leukemia")
# g=g+facet_grid(~ageG)+geom_abline(intercept=1, slope=0) 
# g +geom_errorbar(aes(ymin=rrL,ymax=rrU)) +coord_cartesian(ylim = c(0, 15))
# ggsave("~/Results/tutorial/thyroid2leuAge.pdf") # Fig 5B

# aveAge.R (plot of average ages in PY and observed cases)
rm(list=ls()) 
graphics.off()
.simpleCap <- function(s) paste(toupper(substring(s, 1, 1)), substring(s, 2),sep = "", collapse = " ")
library(tidyverse)
library(magrittr)
library(SEERaBomb)
if (0) {  # 1 to run, 0 to comment (this way it can be folded while looking more useful than commented code)
  load("~/data/SEER/mrgd/cancDef.RData") #loads in canc
  load("~/data/SEER/mrgd/popsae.RData") # loads in popsae (extended to ages 85-99)
  canc=canc%>%select(-reg,-COD,-radiatn,-histo3,-ICD9)
  popsa=popsae%>%group_by(db,race,sex,age,year)%>%summarize(py=sum(py)) # sum on regs
  # canc$cancer=as.character(canc$cancer) # need this if merging types into a new name, like lymphoma=NHL+HL
  canc$cancer[canc$cancer=="APL"] ="AML" # overwrite back to AML
  canc$cancer[canc$cancer=="AMLti"] ="AML" # overwrite back to AML
  canc$cancer=factor(canc$cancer) 
  canc%<>%separate(trt,c("trt","trtc"))
  canc$trt=factor(canc$trt)
  pm=seerSet(canc,popsa,Sex="Male",ageStart=0,ageEnd=100) #pooled (races) male seerSet
  head(pm$canc)
  pf=seerSet(canc,popsa,Sex="Female",ageStart=0,ageEnd=100) #pooled (races) female seerSet
  head(pf$canc)
  pm=mk2D(pm,secondS=c("AML","MDS"))
  pf=mk2D(pf,secondS=c("AML","MDS"))
  levels(pm$canc$cancer)
  brks=c(0,0.25,0.5,0.75,1,1.5,2,2.5,3,4,5,6,8,10,12) 
  pm=tsd(pm,brks=brks,trts=c("rad","noRad"))
  pf=tsd(pf,brks=brks,trts=c("rad","noRad"))
  system.time(save(pm,pf,file="~/Results/amlMDS/aveAgeFull.RData")) #~25 seconds 
}

load("~/Results/amlMDS/aveAgeFull.RData")
# load("~/Results/amlMDS/pm.RData")
# load("~/Results/amlMDS/pf.RData")
# debug(mkDF)
dm=mkDF(pm,1)
df=mkDF(pf,1)

names(pf$L[[1]][["rad"]])
head(dm)
library(ggplot2)
library(grid)
library(reshape2)
# glimpse(df)

D=rbind(dm%>%filter(cancer1=="prostate")%>%select(t,Observed=ageO,Expected=age,trt,cancer2)%>%mutate(cancer1="Prostate"),
    df%>%filter(cancer1=="breast")%>%select(t,Observed=ageO,Expected=age,trt,cancer2)%>%mutate(cancer1="Breast"))
D=melt(D,id.vars=c("t","trt","cancer1","cancer2"))
head(D)
D$trt=factor(as.numeric(D$trt),labels=c("Radiation","No Radiation"))


graphics.off()
quartz(width=6,height=6)
theme_set(theme_bw())
# theme_update()
theme_update(axis.text=element_text(size=rel(1.2)),
             axis.title=element_text(size=rel(1.3)),
             legend.text=element_text(size=rel(1)),
             strip.text = element_text(size = rel(1.5)))

g=qplot(x=t,y=value,data=D,col=trt,shape=variable,geom=c("line","point"),
        xlab=paste("Years Since First Cancer Dx"),ylab="Age at Second Cancer Dx")
g=g+facet_grid(cancer1~cancer2,scales="free")+geom_abline(intercept=1, slope=0) 
# g = g + scale_color_grey(start = 0, end = 0.6)
g+  theme(legend.title = element_blank(),legend.key.height=unit(.34, "cm"),legend.position = c(.24, .5))
ggsave(paste0("~/Results/amlMDS/prosBreastAge.pdf"))
# ggsave(paste0("~/Results/amlMDS/prosBreastAge.eps"))

DL=rbind(dm%>%filter(cancer1=="prostate")%>%select(t,Observed=aoL,Expected=aeL,trt,cancer2)%>%mutate(cancer1="Prostate"),
        df%>%filter(cancer1=="breast")%>%select(t,Observed=aoL,Expected=aeL,trt,cancer2)%>%mutate(cancer1="Breast"))

DU=rbind(dm%>%filter(cancer1=="prostate")%>%select(t,Observed=aoU,Expected=aeU,trt,cancer2)%>%mutate(cancer1="Prostate"),
         df%>%filter(cancer1=="breast")%>%select(t,Observed=aoU,Expected=aeU,trt,cancer2)%>%mutate(cancer1="Breast"))
head(DU)
DU=melt(DU,id.vars=c("t","trt","cancer1","cancer2"))
DL=melt(DL,id.vars=c("t","trt","cancer1","cancer2"))
head(DU,3)
head(DL,3)
D$L=DL$value
D$U=DU$value
head(D,3)
D$t=D$t+0.1*(as.numeric(D$trt)-1)
quartz(width=8,height=6)
g=qplot(x=t,y=value,data=D,col=trt,shape=variable,geom=c("line","point"),
        xlab=paste("Years Since First Cancer Dx"),ylab="Age at Second Cancer Dx")
g=g+facet_grid(cancer1~cancer2,scales="free")+geom_abline(intercept=1, slope=0) 
# g = g + scale_color_grey(start = 0, end = 0.6)
g=g+geom_errorbar(aes(ymin=L,ymax=U),width=.15)
g+  theme(legend.title = element_blank(),legend.key.height=unit(.45, "cm"),legend.position = c(.22, .5))
ggsave(paste0("~/Results/amlMDS/prosBreastAgeCI.pdf"))
# ggsave(paste0("~/Results/amlMDS/prosBreastAgeCI.eps"))

summary(pm)
summary(pf)

# the point here is to map incidences into estimates of how many americans get the cancer each year.
.seerHome="~/data/SEER" 
rm(list=ls()) # note: dot variables defined above persist through such cleanings
getUS=function(d,pop) {
  (pyM=pop$py[1])
  (pyF=pop$py[2])
  d$agerec=as.numeric(cut(d$agedx,breaks=c(0,1,seq(5,85,5),130)))
  (d<-ddply(d, .(sex), summarise,cases=length(agerec))) 
  (M=d$cases[1])
  (F=d$cases[2])
  (crudeIm=M/pyM)
  (crudeIf=F/pyF)
  (malesPerYear=151*crudeIm)
  (femalesPerYear=178*crudeIm)
  (malesPerYear+femalesPerYear)*1e6
} 

# NOTICE: you must
if (0) {  # switch this to 1 (i.e. run this chunk) if you never ran it before
  library(SEERaBomb)
  (df=getFields())
  (df=pickFields(df))
  mkSEERold(df,dataset="00")  
}

library(RSQLite)
m=dbDriver("SQLite")
con=dbConnect(m,dbname=file.path(.seerHome,"00/all.db"))
dbListTables(con)
pops=dbGetQuery(con, "SELECT * from pops")
library(plyr)
(pop<-ddply(pops, .(popsex), summarise,py=sum(population)))

dbListFields(con,"lymyleuk")

d=dbGetQuery(con, "SELECT * from lymyleuk where cancer='CML'") 
getUS(d,pop) # 4600 CML/year
d=dbGetQuery(con, "SELECT * from lymyleuk where cancer='CML' and COD=35022") 
getUS(d,pop) # 600/year=CML deaths

d=dbGetQuery(con, "SELECT * from lymyleuk where cancer='CMML'") 
getUS(d,pop) # 1400 CMML/year
d=dbGetQuery(con, "SELECT * from lymyleuk where cancer='CMML' and COD=35022") 
getUS(d,pop) # 116/year=CMML deaths.
d=dbGetQuery(con, "SELECT * from lymyleuk where cancer='CMML' and COD=35021") 
getUS(d,pop) # 146/year go down as AML
d=dbGetQuery(con, "SELECT * from lymyleuk where cancer='CMML' and COD=35023") 
getUS(d,pop) # 253/year go down as other myeloid cancers

d=dbGetQuery(con, "SELECT * from lymyleuk where cancer='AML'") 
getUS(d,pop) # 12.5k AML/year
d=dbGetQuery(con, "SELECT * from lymyleuk where cancer='AML' and COD=35021") 
getUS(d,pop) # 6k/year=AML deaths

d=dbGetQuery(con, "SELECT * from other where cancer='MDS'") 
getUS(d,pop) # 15k MDS/year


# d=dbGetQuery(con, "SELECT * from lymyleuk where histo3=9863") # 3634/year CML not coded as 9875 or 9876  
# d=dbGetQuery(con, "SELECT * from lymyleuk where histo3=9875") # 834/year BCR-ABL+ CML 
# d=dbGetQuery(con, "SELECT * from lymyleuk where histo3=9876") # 49/year BCR-ABL neg CML 
# d=dbGetQuery(con, "SELECT * from lymyleuk where ICD9=2051") # 5924/year =CML+CMML
# d=dbGetQuery(con, "SELECT * from lymyleuk where histo3==9945") # 1371/year =CMML
d=dbGetQuery(con, "SELECT * from lymyleuk where ICD9=2050") # 12437/year = AML
# d=dbGetQuery(con, "SELECT * from lymyleuk where ICD9=2070") # 260/year = erythroleukemia
# d=dbGetQuery(con, "SELECT * from lymyleuk where ICD9=2072") # 131/year = Megakaryocytic leukemia
d=dbGetQuery(con, "SELECT * from lymyleuk where ICD9=2050 and COD>=20010 and COD<=37000")#8510/year 
d=dbGetQuery(con, "SELECT * from lymyleuk where ICD9=2050 and COD=35021") # 5929/year = AML deaths
d=dbGetQuery(con, "SELECT * from lymyleuk where COD=35021") # 7465/year = AML deaths 
length(unique(d$casenum)) # 9388/9541 = 98.3% unique
d=dbGetQuery(con, "SELECT * from lymyleuk where COD=35023") # 607/year = other myeloid deaths 
d=dbGetQuery(con, "SELECT * from other where COD=35021") # 1379/year AML death  other e.g. MDS incidence 
d=dbGetQuery(con, "SELECT * from other where COD=35022") # 109/year CML death other incidence 
# I'm not seeing a COD code for MDS in http://seer.cancer.gov/codrecode/1969+_d09172004/index.html
getUS(d,pop)



d=dbGetQuery(con, "SELECT * from other where cancer='MDS' and COD=35022") 
getUS(d,pop) # 44/year deaths

# Sex Difference in Myelodysplastic Syndrome Survival and Balance in Randomized
# Clinical Trials. Radivoyevitch T, Saunthararajah Y. J Clin Oncol. 2013 Nov 18.
# [Epub ahead of print] No abstract available. PMID:  24248691

# diffs in sex proportions between arms A and B, 2/22=9% vs 18/43=42%
(X <-  matrix(c(2, 20, 18, 25), nrow = 2))
fisher.test(X)



.seerHome="~/data/SEER" # Assume here that the SEER data is in /data/SEER. Change this if not. 
rm(list=ls()) # note: dot variables defined above persist through such cleanings
library(RSQLite) # install.packages("RSQLite")
m=dbDriver("SQLite")
con=dbConnect(m,dbname=file.path(.seerHome,"00/all.db"))
dbListTables(con)
dbListFields(con,"other")
d=dbGetQuery(con, 
             "SELECT * from other where histo3>9979 and histo3<9990")#MDS
head(d)
summary(d)
summary(as.factor(d$COD))
MFcnts=summary(as.factor(d$sex))
summary(as.factor(d$surv))
# nd=transform(d,dwd=((COD>=20010)&(COD<=37000)) ) # dead with disease
nd=transform(d,dwd=(COD>0) ) # not alive; 0=alive
# d[d$COD==0,c("COD","surv")]
summary(as.factor(nd$surv))
# nd=transform(nd,decade=cut(yrdx,br=c(1999,2003,2011),labels=c("2000-2003","2004-2010"))) 
# # nd=transform(nd,agedxF=cut(agedx,br=c(20,69,77,83,1010),labels=c("35-68","69-76","77-83","84-106"))) 
# nd=transform(nd,agedxF=cut(agedx,br=c(20,77,1010),labels=c("<77",">77"))) 
# head(nd[,c("yrdx","decade")],40)

library(survival)
graphics.off()
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
windows(width=9,height=5)
par(mfrow=c(1,2),mar=c(4.5,4.1,1,1),cex=1.4,lwd=1.5)
rb=c("blue","red") #males blue, femals red 
bbr=c("black","blue","red") #males blue, femals red 
plot(survfit(Surv(surv,dwd)~sex,data = nd),  main="MDS", #: SEER 2000-2010",
     xlab="Months",ylab="Survival", xlim=c(0,60) , #ylim=c(0.6,1),
     col=rb)
print(S<-survdiff(Surv(surv,dwd)~sex,data = nd)) 
options(digits=10)
dput(S)
mtext("A",side=3,line=0,cex=1.5,adj=-.3,font=2)
# legend("topright",c("Males","Females"),text.col=rb,bty="n")
legend("bottomleft",expression(paste("P < ",10^-15)),bty="n")
legend("topright",c("Cases",paste("Males =",MFcnts[1]),paste("Females =",MFcnts[2])),text.col=bbr,bty="n")
# legend("topleft",c("MDS"),bty="n")

d=dbGetQuery(con, "SELECT * from lymyleuk where ICD9=2050")#AML
# nd=transform(d,dwd=((COD>=20010)&(COD<=37000)) ) # dead with disease
MFcnts=summary(as.factor(d$sex))
nd=transform(d,dwd=(COD>0) ) # not alive; 0=alive
plot(survfit(Surv(surv,dwd)~sex,data = nd),main="AML", #: SEER 2000-2010",
     xlab="Months",ylab="Survival", xlim=c(0,60), #ylim=c(0.6,1),
     col=rb)
print(S<-survdiff(Surv(surv,dwd)~sex,data = nd)) 
mtext("B",side=3,line=0,cex=1.5,adj=-.3,font=2)
# legend("topright",c("Males","Females"),text.col=rb,bty="n")
legend("bottomleft",c("P=0.051"),bty="n")
# legend("topleft",c("AML"),bty="n")
legend("topright",c("Cases",paste("Males =",MFcnts[1]),paste("Females =",MFcnts[2])),text.col=bbr,bty="n")
# legend("topright",c(paste("Males =",MFcnts[1]),paste("Females =",MFcnts[2])),text.col=rb,bty="n")

###tMDSrepair.R
(sc=canc%>%filter(histo3==9920|histo3==9987,yrdx>2000))#subset canc
(d=sc%>%count(sex,yrdx,histo3))#n in d holds sex-year-ICDO3 group row counts 
d%>%ggplot(aes(x=yrdx,y=n))+facet_grid(sex~histo3)+ylab("Cases")+gp+
 xlab("Year of Diagnosis")+scale_x_continuous(breaks=seq(2005,2015,5))+tc(11)+sbb
ggsave("~/Results/tutorial/tMDSrepaired.pdf",width=3,height=2.5) 

# simulate.R  (validates tsd implementation using simulated data, makes Figure S4)
rm(list=ls()) 
library(SEERaBomb) 
library(dplyr)  
library(reshape2)
graphics.off()
library(ggplot2)
theme_update(legend.position = c(.75, .815),
             axis.text=element_text(size=rel(1.2)),
             axis.text=element_text(size=rel(1.2)),
             axis.title=element_text(size=rel(1.3)),
             legend.title=element_text(size=rel(1.2)),
             legend.text=element_text(size=rel(1.2)))

simAB<-function(N=1e6,yearEnd=2012,rateA=0.0001,rateB=0.0001,rrAB=5,t1=1,t2=10,mkD=TRUE,te=0) {
  # N=1e6;yearEnd=2012;rateA=0.0001;rateB=0.0001;rrAB=0;library(dplyr)
  lastCN=1 # last casenum
  lastRN=1 # last row number
  brthyrs=1873:2012
  M=matrix(0,nrow=2.3e8*length(brthyrs)*(rateA+rateB),ncol=5)
  colnames(M)<-c("casenum","age","seqnum","yrdx","cancer")
  TC=cbind(matrix(1,ncol=2,nrow=N),matrix(2,ncol=3,nrow=N)) #type of cancer. Need to distinguish 1st from 2nds
  A=rexp(N,rateA)
  B=rexp(N,rateB)
  
  # early detection of background B cases
  BB=B+rexp(N,rateB) # store away now before B gets altered by early detection due to A.
  BE=rexp(N,10) # B Early: on average, latent B are detected within 0.1 yrs of A  
  B=ifelse((B-A<te)&(B-A>0),A+BE,B)
  
  # induction/association of B with A
  if(rrAB>0) {AB=rexp(N,rrAB*rateB) 
              AB=ifelse(AB<t1|AB>t2,Inf,AB) }
  else AB=Inf
  
  AC=cbind(A,A+rexp(N,rateA),A+AB,B,BB)
  system.time(Ord<-t(apply(AC,1,order))) # 7 secs!
  for (i in 1:N) TC[i,]=TC[i,Ord[i,]]
  for (i in 1:N) AC[i,]=AC[i,Ord[i,]]
  I=AC[,1]<100
  TC=TC[I,1:2]
  AC=AC[I,1:2]
  for (k in brthyrs) {
    Age=AC[,1]
    n=length(Age)
    casenumsk=casenums=lastCN:(lastCN+n-1)
    lastCN=lastCN+n
    rownums=lastRN:(lastRN+n-1)
    M[rownums,]=cbind(casenum=casenumsk,age=Age,seqnum=0,yrdx=k+Age,cancer=TC[,1])
    I=AC[,2]<100 
    casenums=casenums[I]
    M[lastRN-1+which(casenumsk%in%casenums),"seqnum"]=1
    lastRN=lastRN+n
    Age=AC[I,2]
    n=length(Age)
    rownums=lastRN:(lastRN+n-1)
    M[rownums,]=cbind(casenum=casenums,age=Age,seqnum=2,yrdx=k+Age,cancer=TC[I,2])
    lastRN=lastRN+n
  } # k loop on birth years
  sum(M[,"casenum"]>0) # 9916+9883 +9948 + 39+ 51 +59
  head(M)
  tail(M)
  dim(M)
  M=M[M[,"casenum"]>0,]
  canc=tbl_df(as.data.frame(M))
  head(canc)
  fixem=canc%>%filter(seqnum==2,yrdx>=(yearEnd+1))
  fixem=fixem$casenum
  canc[canc$casenum%in%fixem,"seqnum"]=0
  canc=canc%>%filter(yrdx>=1973,yrdx<(yearEnd+1))
  canc$surv=100-canc$age
  trimSurv=function(x) {
    x$surv=ifelse(x$surv+x$yrdx>yearEnd+0.9999,yearEnd+0.9999-x$yrdx,x$surv)
    x  }
  canc=trimSurv(canc)
  canc=canc%>%mutate(trt="noRad",year=floor(yrdx))
  canc$trt=factor(canc$trt)
  canc$cancer=factor(canc$cancer,labels=c("A","B"))
  popsa=merge(data.frame(age=0.5:99.5),data.frame(year=1973:yearEnd))
  popsa$py=N
  popsa=tbl_df(popsa)
  cancerS=levels(canc$canc)
  if(mkD) {
    D=canc%>%mutate(age=floor(age)+0.5)
    D=D%>%group_by(cancer,year,age)%>%summarize(cases=n())
    D=cbind(D[,1:3],py=N,D[,4]) 
    D=D%>%mutate(incid=1e5*cases/py,Ecases=ifelse(cancer=="A",rateA,rateB)*1e6,Eincid=Ecases/(N/1e5))
    D=tbl_df(D)
    seerSet=list(canc=canc,popsa=popsa,ageStart=0,ageEnd=100,sex="neut",race="neut",
                 cancerS=cancerS,yearEnd=yearEnd,secondS=c("A","B"),D=D,bfn="nNs0.5e99.5")
  } else {  # if using mk2D downstream
    seerSet=list(canc=canc,popsa=popsa,ageStart=min(popsa$age),ageEnd=max(popsa$age),sex="neut",race="neut",
                 cancerS=cancerS,yearEnd=max(popsa$year))  
  }
  class(seerSet)="seerSet"
  seerSet
} # return a list that can be attached or with-ed in other functions



LO=NULL
LE=NULL
LR=NULL
mybrks=seq(0,20,by=5)
mybrks=c(0,0.75,0.9,1.1,1.25,2,2.5,3,3.5,4,4.75,4.9,5.1,5.25,6)
mybrks=c(0,0.1,0.2,0.3,0.5,0.75,0.9,1.1,1.25,2,2.5,3,3.5,4,4.75,4.9,5.1,5.25,6)
mybrks=c(0,0.1,0.2,0.3,0.5,0.75,1,1.25,2,2.75,3,3.25,4,4.75,5,5.25,6)
for (i in 1:20) {  # i=1 
  print(i)
  n=simAB(rateA=0.001,rateB=0.0002,rrAB=4,t1=1,t2=5,mkD=F,te=0.5)# 100x: 1.011872 1.011866 1.011468 1.012264
  n=mk2D(n)
  n=tsd(n,brks=mybrks,trts=c("noRad")) 
  lab=paste0("b",paste(mybrks,collapse="_"))
  LM=n$L[[lab]]$'noRad'
  LM$Exp
  LM$Obs
  (O=sapply(LM$Obs,cbind)) 
  D=data.frame(first=rep(c("A","B"),2),second=rep(c("A","B"),each=2))
  dO=cbind(D,O)
  (E=sapply(LM$Exp,cbind))
  dE=cbind(D,E)
  LR[[i]]=O/E
  LE[[i]]=E
  LO[[i]]=O
  dO=melt(dO)
  dE=melt(dE)
  M=data.frame(dO,O=dO[,"value"],E=dE[,"value"],t=rep(LM$mids,each=4))
  M=M%>%mutate(RR=O/E)
  g=qplot(x=t,y=RR,col=first,shape=second,data=M,geom=c("line","point"),
          xlab="Years Since First Cancer Diagnosis",ylab="Relative Risk")
  g=g+geom_abline(intercept=1, slope=0)
  print(g)
}

TMP=LR[[1]]
n=length(LR)
for (i in 2:n) TMP=TMP+LR[[i]]
(R=TMP/n)
(R=cbind(D,R))
(LL=qchisq(.025,2*LO[[1]])/(2*LE[[1]]))
(LU=qchisq(.975,2*LO[[1]]+2)/(2*LE[[1]]))
for (i in 2:n) {
  (LL=LL+qchisq(.025,2*LO[[i]])/(2*LE[[i]]))
  (LU=LU+qchisq(.975,2*LO[[i]]+2)/(2*LE[[i]]))
}
(LU=cbind(D,LU=LU/n) )
(LL=cbind(D,LL=LL/n))  
R
dR=melt(R)
dLL=melt(LL)
dLU=melt(LU)

M=data.frame(dR,LL=dLL[,"value"],UL=dLU[,"value"],t=rep(LM$mids,each=4))
head(M)
levels(M$first)
M$first=factor(M$first,labels=c("First Cancer A","First Cancer B"))
theme_update(legend.position = c(.8, .7),
             strip.text=element_text(size=rel(1.2)))
quartz(width=6,height=3.25)
g=qplot(x=t,y=value,col=second,data=M,geom=c("line","point"),xlim=c(0,6),
        xlab="Years Since First Cancer Diagnosis",ylab="Relative Risk")
g=g+facet_grid(~first,scales="free")+geom_abline(intercept=1, slope=0)
g1 <- guide_legend("Second\nCancer")
g=g + guides(color=g1) 
g+  geom_errorbar(aes(ymin=LL,ymax=UL,width=.05))
ggsave("~/Results/amlMDS/ABdipNpeak.png")  

# consort.R  (figure 1) 
rm(list=ls()) 
library(tidyverse)
library(magrittr)
library(scales);  #comma_format comes from here   
cf=function (x) comma_format()(x)
library(SEERaBomb) 
library(dplyr)  
load("~/data/SEER/mrgd/cancDef.RData") #loads in canc
canc=canc%>%select(-reg,-COD,-radiatn,-histo3,-ICD9)
(tb=table(canc$seqnum))
sum(tb[1:2])
canc=canc%>%filter(cancer!="benign")
canc%<>%separate(trt,c("trt","trtc"))
canc$trt=factor(canc$trt)
(tb=table(canc$seqnum)) #60-88 has been removed
sum(tb[1:2])
#upgrade AML definition to include APL
# mapCancs# shows cancer definitions (i.e. that APL overwrites AML)
canc$cancer[canc$cancer=="APL"] ="AML" # overwrite back to AML
canc$cancer[canc$cancer=="AMLti"] ="AML" # overwrite other translocations and inversion AMLs back to AML
canc$cancer=factor(canc$cancer)  # removes APL and AMLti levels, as well as benign from above
levels(canc$cancer)

# first get the top three rows of numbers
cf(canc%>%group_by(db)%>%summarize(cases=n()) )
canc%>%filter(cancer%in%c("AML","MDS"))%>%group_by(cancer,db)%>%summarize(cases=n()) 

# now get numbers for background cases
aml=canc%>%filter(cancer=="AML")
aml%>%filter(agedx>99)%>%summarize(cases=n()) # 31 AMLs were over 99 at diagnosis will be left out
aml%>%filter(agedx<100)%>%summarize(cases=n()) # 69079 will be used to form background incidence

mds=canc%>%filter(cancer=="MDS")
table(mds$yrdx) # cases before 2001 are likely typos
mds=mds%>%filter(yrdx>2000) # so filter them out. 22 cases
mds%>%filter(agedx>99)%>%summarize(cases=n()) # 70 were over 99 at diagnosis will be left out
mds%>%filter(agedx<100)%>%summarize(cases=n()) # 49502 will be used to form background incidence

# next line not in a Figure but in Methods text for justification of spreading pop PY in 85+ out to 100
mds%>%filter(agedx>84,seqnum==2)%>%summarize(cases=n())/mds%>%filter(seqnum==2)%>%summarize(cases=n())# 21% 2nd MDS are >84

load("~/data/SEER/mrgd/popsae.RData") # loads in popsae (extended to ages 85-99)
cf(popsae%>%summarize(py=sum(py))) # total PY at risk are 1,788,450,864
cf(popsae%>%filter(year>2000)%>%summarize(py=sum(py))) # total PY at risk for MDS are 1,001,683,402
popsa=popsae%>%group_by(db,race,sex,age,year)%>%summarize(py=sum(py)) # sum on regs
cf(dim(canc)[1]) # 8,565,745 cancers, out of 8,677,429 total (benign+cancers)
# There are 5 more numbers in Figure 1 that we will get below, after we compute post first PY

load("~/Results/amlMDS/consort.RData") # has both pm and pf (made by amlMDScomputing)
PYm=pm0$L$b0$rad$PYL$'(0,100]' 
PYf=pf0$L$b0$rad$PYL$'(0,100]'
#sexes are separated by default, so we have to merge them
printPY=function(PYm,PYf) {
  D=rbind(cbind(PYm,sex="male"),cbind(PYf,sex="female"))
  print(cf(D%>%summarize(cases=n(),py=sum(py))))
  D=D%>%group_by(sex)%>%summarize(cases=n(),PY=sum(py),mean=mean(py),median=median(py))
  I=sapply(D,is.numeric)
  D[,I]=round(D[,I],2)
  cf(D)
}
printPY(PYm,PYf)
# 9,797,380 PY after firsts with radiation
# 1,906,425  cases

PYm=pm0$L$b0$noRad$PYL$'(0,100]' 
PYf=pf0$L$b0$noRad$PYL$'(0,100]'
printPY(PYm,PYf)
# 27,766,900 PY after firsts without radiation
#5,001,800 cases

Om=pm0$L$b0$rad$Obs$'(0,100]'
Of=pf0$L$b0$rad$Obs$'(0,100]'
head(Of,3) # rows are first cancers (see firstS arg of tsd), columns secondS specified by mk2D call
cf(apply(rbind(Om,Of),2,sum)) # 2,239 AML and 2,065 MDS cases observed

Om=pm0$L$b0$noRad$Obs$'(0,100]'
Of=pf0$L$b0$noRad$Obs$'(0,100]'
cf(apply(rbind(Om,Of),2,sum)) # 5,550 AML; 4,799 MDS cases observed

Em=pm0$L$b0$rad$Exp$'(0,100]'
Ef=pf0$L$b0$rad$Exp$'(0,100]'
cf(round(apply(rbind(Em,Ef),2,sum),1)) #1,225.2 AML and 1,430.0 MDS cases expected

Em=pm0$L$b0$noRad$Exp$'(0,100]'
Ef=pf0$L$b0$noRad$Exp$'(0,100]'
cf(round(apply(rbind(Em,Ef),2,sum),1)) #3,452.7 AML 3,755.5 MDS cases expected 
########  END getting numbers in consort diagram

# lymphoidFirsts.R (Figure 4)
# first run amlMDScomputing.R, then start here to make time course plots 
rm(list=ls())
library(dplyr)
library(reshape2)
library(ggplot2)
library(SEERaBomb)
LC=c("CLL","SLL","HCL","NHL","MM","HL") # lymphoid first cancers
system.time(load("~/Results/amlMDS/pm.RData")) # 4 secs to load. 
system.time(load("~/Results/amlMDS/pf.RData")) # 4 secs to load. 
brks=c(0,0.25,0.5,0.75,1,1.5,2,2.5,3,4,5,6,8,10,12)
df=mkDF(pf,brks)
dm=mkDF(pm,brks)
d=rbind(cbind(df,Sex="Female"),cbind(dm,Sex="Male"))
d=d%>%filter(cancer1%in%LC)%>%group_by(cancer2,Sex,int)%>%summarize(O=sum(O),E=sum(E),t=weighted.mean(t,py,na.rm=T))
D=d%>%mutate(RR=O/E, L=qchisq(.025,2*O)/(2*E),U=qchisq(.975,2*O+2)/(2*E))
D[D$cancer2=="MDS","t"]=D[D$cancer2=="MDS","t"]+0.05
graphics.off()
quartz(width=7,height=4)
# theme_set(theme_bw())
theme_update(legend.position = c(.92, .825),
             axis.text=element_text(size=rel(1.2)),
             axis.title=element_text(size=rel(1.3)),
             axis.title.x=element_text(size=rel(1.0)),
             legend.title=element_text(size=rel(1)),
             legend.text=element_text(size=rel(1)),
             strip.text = element_text(size = rel(1.5)))
g=qplot(x=t,y=RR,data=D,col=cancer2,geom=c("line","point"),
        xlab="Years Since Dx of Lymphoid First Cancer",ylab="Relative Risk")
g=g+facet_grid(Sex~.,scales="free")+geom_abline(intercept=1, slope=0)
# g = g + scale_color_grey(start = 0, end = 0.6)
g1 <- guide_legend("Second\nCancer")
g=g + guides(color=g1) 
g=g+  geom_errorbar(aes(ymin=L,ymax=U,width=.15))+scale_y_continuous(breaks=c(0,5,10,15))
print(g)
ggsave("~/Results/amlMDS/lymphoidFirst.eps")  
ggsave("~/Results/amlMDS/lymphoidFirst.png")  

# This script performs the deviance calculations associated with Eq. 2 in our active MS
rm(list=ls(all=TRUE))
cols=c("city","sex","doseg","agexg","calg","kerma","PY","adjPY","num.entering",
"age","agex","tsx","cal","sv","gam","neut","lymphoma","NHL","leukemia","AML","ALL","CML","ATL","MM")      
d<-read.table("c:/data/abomb/HEMA87.dat", header=F,col.names=cols);
d=d[d$adjPY>0,] #remove two recs with zero py
d=d[d$kerma==1,] # take only kerma < 4 Gy
d=d[d$city==1,]#hiroshima=1, comment for pooling
#d=d[d$age>=20,]# restriction to adults => male difference regardless of city pooling
d$py=10^4*d$adjPY
d$calg=as.integer(cut(d$calg,c(0,2,4,6,8,10))) # pairwise binning of waiting time groups
m=d[d$sex==1,]; f=d[d$sex==2,] 
agem=55  # pooling cities holds significance with age>20 only if agem=55 centering is used
agem=0   # Hiroshima alone, with or without age>20, holds significance regardless of agem=0 or 55

require(bbmle)
nLL<-function(c0,k,beta,L1,L2,L3,L4,L5,x,agem) with(x, {L=c(L1,L2,L3,L4,L5)
				mn = (exp(c0+k*(age-agem)) + exp(-beta*abs(agex-30)/28.85)*sv*exp(L[calg]))*py
				-sum(stats::dpois(CML, mn, log=TRUE))})	
fit0 <- mle2(nLL,start=list(c0=-10,k=.04,L1=-10,L2=-10,L3=-10,L4=-10,L5=-10,beta=0.5),data=list(x=m,agem=agem))
fit0Fx <- mle2(nLL,start=list(c0=-10,k=.04,L1=-10,L2=-10,L3=-10,L4=-10,L5=-10),fixed = list(beta=0),data=list(x=m,agem=agem))
deviance(fit0Fx)-deviance(fit0)

fit0 <- mle2(nLL,start=list(c0=-10,k=.04,L1=-10,L2=-10,L3=-10,L4=-10,L5=-10,beta=0.5),data=list(x=f,agem=agem))
fit0Fx <- mle2(nLL,start=list(c0=-10,k=.04,L1=-10,L2=-10,L3=-10,L4=-10,L5=-10),fixed = list(beta=0),data=list(x=f,agem=agem))
deviance(fit0Fx)-deviance(fit0)

rm(list=ls()) 
# The first step is to show that there are lower AIC EAR models than the CML ERR
# and EAR models in: Hsu, W. L., Preston, ... and Mabuchi, K. The Incidence of
# Leukemia, Lymphoma ... among Atomic Bomb Survivors: 1950-2001. Radiat. Res.
# 179, 361-382 (2013). To use this script please place lsshempy.csv in
# /data/abomb or change this line
d<-read.csv("~/data/abomb/lsshempy.csv",header=T)
head(d,2)
d=d[d$mar_an>=0,] # take only those with known doses 
sum(d$cml) # check to see that we have 75 cases of CML
# viewing d as an environment, use within to remove columns not needed here
d=within(d,{rm(distcat,agxcat, agecat, dcat, time,upyr,subjects,year,
               nhl,hl,mye,all,oll,alltot,cll,hcl,clltot,atl,aml,oml,amol,amltot,
               othleuk,noncll,leuktot,hldtot,mar_ag,mar_an)}) 
head(d,2)
# the next line uses within to transform columns, as in the beginning of the
# epicure log file in Hsu et al's supplement 3
d=within(d, {nic = as.numeric(gdist > 12000) # nic= not in city
             over4gy = 1 - un4gy  
             rm(gdist,un4gy)  # get rid of things no longer needed as we go
             tsx = (age -agex) 
             lt25 = log(tsx/25) 
             a = log(age/70) 
             a55 = log(age/55) ;
             age55=age-55
             agex30=agex-30
             ax30 = log(agex/30) ;
             py10k = pyr/10000 ;
             py = pyr;
             s=sex-1
             c=city-1
             sv=mar_ad10/1000;
             hiro = as.numeric(city == 1) 
             naga = as.numeric(city ==2)
             rm(sex,city,pyr,mar_ad10)
})


head(d)
bk=d[d$sv<0.05,]
library(bbmle)
# ERR model of CML in Table S2 (in Supplement 1) is:
# back=0.22*exp(-0.06*s + (1.38 + 1.75*s)*a)
# Induced=(5.24*d)*exp(-1.50*c - 1.59*lt25 - 1.42*a55)
# where
# c = 0 for Hiroshima and 1 for Nagasaki        
# s = 0 for men and 1 for women                 
# a = ln(age/70) 
# a55 = ln(age/55)              
# lt25 = ln(tsx/25) 

# first compare their polynomial in age background model to our preferred exponential in age model
summary(pow1<-mle2(cml~dpois(lambda=py10k*A*exp(cs*s+(ca+csa*s)*a)),
                     start=list(A=.22,cs=-0.06,ca=1.38,csa=1.75),data=bk) ) 
summary(exp1k<-mle2(cml~dpois(lambda=py10k*A*exp(cs*s+k*age55)),
                     start=list(A=.22,cs=-0.6,k=0.04),data=bk) ) 
summary(exp2k<-mle2(cml~dpois(lambda=py10k*A*exp(cs*s+(k+ks*s)*age55)),
                 start=list(A=.22,cs=-0.6,k=0.03,ks=.02),data=bk) ) 
AIC(pow1,exp1k,exp2k)
ICtab(pow1,exp1k,exp2k)
# AIC favors exp(k*age) over  age^k for background; also, sex diff in k is not justified
BIC(pow1,exp1k,exp2k) # BIC seems to penalize too much for adding a parameter

# now add in their ERR induced term
# Induced=(5.24*d)*exp(-1.50*c - 1.59*lt25 - 1.42*a55)  [according to Table S2 in Supplement 1], but 
# with extra terms according to the epicure log file in Supplement 3. 
# Since the Supplement 3 model exactly reproduces Table S9 in Supplement 2, we go with it:
summary(err<-mle2(cml~dpois(lambda=py10k*(A1*exp(c1s*s+c1a*a+c1sa*a*s+c1nic0*hiro*nic+c1nic1*naga*nic)*
                          (1+sv*A2*exp(c2c*c + c2t*lt25 + c2a*a55+c2o4g*over4gy)   ) ) ),
                 start=list(A1=.22,c1s=-0.06,c1a=1.38,c1sa=1.75,c1nic0=-0.2,c1nic1=-0.86,
                            A2=5.24,c2c=-1.50,c2t=-1.59,c2a=-1.42,c2o4g=-0.3),data=d) ) 
# note that many parameters are highly insignificant by the Wald test, so this looks overparameterized!

AIC(err)
logLik(err)
deviance(err)
prd=predict(err)
-2*sum(d$cml*log(prd))
-2*sum(d$cml*log(prd))+2*length(coef(err)) # 11-parameter model => diff of 22
# [1] 754.454 # exactly as in epicure log file of supplement. In computing the 
# deviance here, I'm OK with ditching the third term below since it only depends
# on the data, and since it vanishes anyway since the cells are all 0 or 1 (in this data)
# and the factorial takes these all to 1 which the log then takes to zero, but was wondering
# how they can leave out the second term, i.e. -prd
-2*sum(d$cml*log(prd)-prd-log(factorial(d$cml)))
-2*sum(d$cml*log(prd)-prd)
sum(prd) # my only guess is that the sum of the expected means = sum of observed cases
# so that it too really only depends on the data, at the level of the whole sum. 

# EAR model of CML. From Table S2 in Supplement 2
# back=0.25*exp(-0.28*s + 1.60*a + 1.38*(s*a))
# Induced=
# (0.68*d)*exp(-1.49*c - 1.63*lt25 - 0.20*a55) men
# (0.57*d)*exp(-1.49*c - 1.63*lt25 + 2.10*a55) women
# but the epicure log shows more to the model, as follows
summary(ear<-mle2(cml~dpois(lambda=py10k*(A1*exp(c1s*s+c1a*a+c1sa*a*s+c1nic0*hiro*nic+c1nic1*naga*nic)
                        +sv*A2*exp(c2c*c + c2s*s+c2t*lt25 + c2a*a55+c2sa*s*a55+c2o4g*over4gy)   ) ) ,
                 #                                        method="L-BFGS-B",
                 start=list(A1=.22,c1s=-0.06,c1a=1.38,c1sa=1.75,c1nic0=-0.2,c1nic1=-0.86,
                            A2=5.24,c2c=-1.50,c2s=-0.18,c2t=-1.59,c2a=-1.42,c2sa=2.3,c2o4g=-0.3),data=d) ) 
# still lots of insignificant parameters.
prd=predict(ear)
-2*sum(d$cml*log(prd))
-2*sum(d$cml*log(prd))+2*length(coef(ear)) # 13-parameter model, so add 26 => worse model 
# 753.7032  # also exactly as in the epicure log file supplement => a better fit than the ERR model

AIC(err,ear)
ICtab(err,ear) # err wins by AIC
anova(err,ear) # err wins by likelihood ratio test (i.e. deviance difference test)


################################################################################3
# The following EAR model beats out Hsu's ERR model (in terms of AICs)  
summary(s1<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
                                      +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx)  ) ),
         start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,c2s=-0.18,c2t=-0.4,c2ts=0.3),data=d) ) 
prd=predict(s1)
-2*sum(d$cml*log(prd))
-2*sum(d$cml*log(prd))+2*length(coef(s1)) # 8 parameters, so add 16
ICtab(err,s1) # s1 wins by AIC
anova(err,s1) # s1 wins by likelihood ratio test (i.e. deviance difference test)


# # using this model there is no evidence for the need for kerma>4gy correction
# summary(s1ov<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
#                                       +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx+c2o4g*over4gy)  ) ),
#                  start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
#                             c2s=-0.18,c2t=-0.4,c2ts=0.3,c2o4g=-0.3),data=d) ) 
# prd=predict(s1ov)
# -2*sum(d$cml*log(prd))
# -2*sum(d$cml*log(prd))+2*length(coef(s1ov))
# 

# checking if adding lage55 in the induced term helps, yes, it does 
summary(s1a55<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
                     +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx + c2a*a55+c2sa*s*a55 )  ) ),
                    start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
                               c2s=-0.18,c2t=-0.4,c2ts=0.3,c2a=-1.42,c2sa=2.3),data=d) ) 
prd=predict(s1a55)
-2*sum(d$cml*log(prd))                       
-2*sum(d$cml*log(prd))+2*length(coef(s1a55)) # lage55 terms are justified! new best model
ICtab(err,s1a55) # new model wins by AIC diff of 3.4
anova(err,s1a55) # new model has less deviance and fewer parameters!

# keeping only the female component of lage55  
summary(s1a55f<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+(k+ks*s)*age)
                         +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx +c2sa*s*a55 )  ) ),
                    start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
                               c2s=-0.18,c2t=-0.4,c2ts=0.3,c2sa=2.3),data=d) ) 

prd=predict(s1a55f)
-2*sum(d$cml*log(prd))                       
-2*sum(d$cml*log(prd))+2*length(coef(s1a55f)) # new best model 
ICtab(err,s1a55f) # now new model wins by AIC diff of 5.3
anova(err,s1a55f) # deviance loss was negligible, consistent with AIC drop of almost 2

# # do we still need a sex diff in exponential decays?  
# summary(m1a55f<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
#                                           +sv*exp(c20+c2c*c + c2s*s+c2t*tsx +c2sa*s*a55 )  ) ),
#                      start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
#                                 c2s=-0.18,c2t=-0.4,c2sa=2.3),data=d) ) 
# prd=predict(m1a55f)
# -2*sum(d$cml*log(prd))                       
# -2*sum(d$cml*log(prd))+2*length(coef(m1a55f)) #  yes, keep the difference in exponential decays

# # try switching to age at exposure in induced term doesn't help
# summary(s1a55x<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+(k+ks*s)*age)
#                                           +sv*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx +c2sa*s*agex )  ) ),
#                      start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
#                                 c2s=-0.18,c2t=-0.4,c2ts=0.3,c2sa=2.3),data=d) ) 
# prd=predict(s1a55x)
# -2*sum(d$cml*log(prd))                       
# -2*sum(d$cml*log(prd))+2*length(coef(s1a55x)) 
# ICtab(s1a55f,s1a55x) # fit is worse

# make exponential more realistic by bringing tsx out in front of induced term   
summary(s1tsx<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+(k+ks*s)*age)
                                          +sv*tsx*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx +c2sa*s*a55 )  ) ),
                     start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
                                c2s=-0.18,c2t=-0.4,c2ts=0.3,c2sa=2.3),data=d) ) 
# note that the parameter P values are now almost all signficant
prd=predict(s1tsx)
-2*sum(d$cml*log(prd))                       
-2*sum(d$cml*log(prd))+2*length(coef(s1tsx)) # new best model 
ICtab(s1tsx,s1a55f) # tsx in front wins by AIC diff of 0.4


# what about the age at exposure hump for HM only  
a55HMb<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)    +
      sv*tsx*exp(c20+c2c*c + c2s*s+c2t*tsx+c2ts*s*tsx +c2sa*s*a55+ c2x*(1-c)*(1-s)*abs(agex-30))  ) ),
                     start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
                                c2s=-0.18,c2t=-0.4,c2ts=0.3,c2x=.1,c2sa=2.3),data=d)  
prd=predict(a55HMb)
-2*sum(d$cml*log(prd))                       
-2*sum(d$cml*log(prd))+2*length(coef(a55HMb)) # 

summary(a55HMb)     #P=0.23 on c2x param is consistent with 0.21 below for model diffs
AIC(a55HMb,s1tsx)
ICtab(a55HMb,s1tsx) #AIC difference of 0.4 => deviance better by 1.6 (i.e. maybe something to it)
anova(a55HMb,s1tsx) # P=0.21 => HM hump at agex=30 is not statistically significant

#rewrite to estimate sex difference in EAR time constants 
summary(best<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
                                        +sv*tsx*exp(c20+c2c*c + c2s*s-tsx/(c2t+c2ts*s) +c2sa*s*a55 )  ) ),
                     start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
                                c2s=-0.18,c2t=5,c2ts=10,c2sa=2.3),data=d) ) 
prd=predict(best)
-2*sum(d$cml*log(prd))                       
-2*sum(d$cml*log(prd))+2*length(coef(best))  
# see that it still is the best
AIC(s1tsx,best) # i.e. these should be identical, and they are (this is just a reparameterization)
ICtab(err,best) 
anova(err,best) 

# show that can't remove ks by AIC, but perhaps by LRT and BIC
summary(best) # see that ks was not significant by Wald Test
summary(bestT<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age)
                                        +sv*tsx*exp(c20+c2c*c + c2s*s-tsx/(c2t+c2ts*s) +c2sa*s*a55 )  ) ),
                   start=list(c10=-12.4,k=0.025,c20=-10.5,c2c=-1.50,
                              c2s=-0.18,c2t=5,c2ts=10,c2sa=2.3),data=d) ) 
prd=predict(bestT)
-2*sum(d$cml*log(prd))                       
anova(best,bestT) 
BICtab(best,bestT)  # LRT and Bayes both say take out ks 
ICtab(best,bestT)  # but AIC says leave it in. 

# Since I would prefer to see agex over age in my induced term, I tried things
# like this that failed
# d$oldF=d$s*as.numeric(d$agex>40)
# head(d)
# summary(bestT<-mle2(cml~dpois(lambda=py*(exp(c10+c2c*c+c2s*s+k*age+ks*s*age)
#                                         +sv*tsx*exp(c20+c2c*c + c2s*s-tsx/(c2t+c2ts*s) +c2sa*oldF )  ) ),
#                    start=list(c10=-12.4,k=0.025,ks=0,c20=-10.5,c2c=-1.50,
#                               c2s=-0.18,c2t=5,c2ts=log(10),c2sa=2.3),data=d) ) 
# prd=predict(bestT)
# -2*sum(d$cml*log(prd))                       
# ICtab(bestT,best) # all of my attempts to get age out of the induced term failed
# anova(bestT,best) 

#OK, so we stop at this point and now make tables and figures for the paper
(sb=summary(best))
(outs=round(coef(sb),4))
rownames(outs)[c(1,4:8)]<-c("c1hm","c2hm","cn","cs","tau","taus")
outs  # parameter names mapped to those in paper before sending to the table
library(hwriter)
# setwd("/users/radivot/downloads/sachs")
# hwrite(outs,"table2.html")

sd=coef(sb)["c2ts",2]
mn=coef(best)["c2ts"]
(tauDiff=round(2*c(mn,mn-1.96*sd,mn+1.96*sd),2)) # mean is twice tau for gamma with t^1 in front
sprintf("%s (%s, %s)",tauDiff[1],tauDiff[2],tauDiff[3])
(Taum=coef(best)["c2t"])  #so twice these are the mean male and female waiting times
(Tauf=Taum + mn)

# now get amplitude parameter ratio (M/F) estimates and CI 
sdA=coef(sb)["c2s",2]
mnA=coef(best)["c2s"]
(MovF=round((Taum/Tauf)^2*exp(-c(mnA,mnA+1.96*sdA,mnA-1.96*sdA)),2))
sprintf("%s (%s, %s)",MovF[1],MovF[2],MovF[3])
# note that the (Taum/Tauf)^2 is needed because the normalized density
# function is (1/Tau^2)*t*exp(-t/Tau)

###############################################################################

# The next goal is to make something like the dots in Fig 4B of Hsu et al, but for tsx decays
# To do this we replace the tsx exponential decays with a "nonparameteric" model (not distribution),
# i.e. this is non-parameteric like a one-way anova is of a time course. 
d=transform(d,tsxf=cut(tsx,6),sex=as.factor(s))
head(d)
summary(s3<-mle2(cml~dpois(lambda=py*(exp(c10 + c2c*c + c2s*s + k*age + ks*s*age)
                                +sv*exp(c2c*c  + f + c2sa*s*a55 )  ) ),
                 parameters=list(f~-1 + tsxf:sex),
                 start=list(c10=-12.4,k=0.025,ks=0,c2c=-1.50,
                              c2s=-0.18,f=-5,c2sa=2),data=d) ) 
prd=predict(s3)
-2*sum(d$cml*log(prd))  # fit is much improved, with deviance now at 746.07 (lowest of all)
-2*sum(d$cml*log(prd))+2*length(coef(s3))# but the extra parameters are not justified: this is OK, 
# the point here is to plot the points, not say that this is a better model. 
AIC(s3,best)
ICtab(s3,best) 
anova(s3,best) 

ss3=summary(s3)
wait=exp(coef(ss3)[6:17,1])*1e4
waitL=exp(coef(ss3)[6:17,1]-1.96*coef(ss3)[6:17,2])*1e4
waitU=exp(coef(ss3)[6:17,1]+1.96*coef(ss3)[6:17,2])*1e4
(lvls=levels(d$tsxf))
(Lvls=strsplit(lvls,","))
substring("(4.23",2)
(lows=sapply(Lvls,function(x) as.numeric(substring(x[1],2))))
(ups=sapply(Lvls,function(x) as.numeric(substring(x[2],1,4))))
(mids=round(apply(rbind(lows,ups),2,mean),2))
(dfc=data.frame(mids,wait,waitL,waitU,Sex=gl(2,6,labels=c("Male","Female") ) ) )

graphics.off()
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
windows(width=7,height=6)

library(ggplot2)
pd <- position_dodge(1) 
(p=ggplot(dfc, aes(x=mids, y=wait, shape=Sex, col=Sex, ymax=10)) + 
   geom_point(size=6,position=pd) ) # + ylim(0, 10) ) # scale_y_log10(limits=c(1e-5,10)) 
(p=p+labs(title="IR-to-CML Latency",x="Years since exposure",
          y=expression(paste("Cases per ",10^4," Person-Year-Sv") ) ) )    
(p=p+geom_errorbar(aes(ymin=waitL, ymax=waitU),width=.01,position=pd))
(p=p+theme(plot.title = element_text(size = rel(2.3)),
           axis.title = element_text(size = rel(2.3)),
           axis.text = element_text(size = rel(2.3)))  )
(p=p+theme(legend.position = c(0.8, .5), 
           legend.title = element_text(size = rel(2)) ,
           legend.text = element_text(size = rel(2))  ) )  

waitm=exp(coef(ss3)[6:11,1])
waitf=exp(coef(ss3)[12:17,1])
(MovF<-format(sum(waitm)/sum(waitf),digits=3)) # ratio of sums (like AUCs)

# now we still need the M/F CI, 
mns=coef(ss3)[6:17,1]
sds=coef(ss3)[6:17,2]
X=exp(matrix(rnorm(12*100000,mns,sds),byrow=T, ncol=12))
M=X[,1:6]; F=X[,7:12]
Ms=apply(M,1,sum)
Fs=apply(F,1,sum)
MovF=Ms/Fs
MF=round(quantile(MovF,c(0.5,0.025,0.975)),2)
(MF=sprintf("%s (%s, %s)",MF[1],MF[2],MF[3]))

pm=waitm/sum(waitm)
pf=waitf/sum(waitf)
(taum<-round(mids%*%pm,2))
(tauf<-round(mids%*%pf,2))

(p=p+annotate("text",x=15,y=10, hjust=0, label = paste("M/F =",MF),size=9) )
(lb1=paste0("tau[m] == ",taum,"*~Yrs"))
(p=p+annotate("text",x=15,y=9, hjust=0, label = lb1,size=9,parse=T) )
(lb1=paste0("tau[f] == ",tauf,"*~Yrs"))
(p=p+annotate("text",x=15,y=8, hjust=0, label = lb1,size=9,parse=T) )
# This next block calculates the 95% CI of the difference in waiting times
rdiscrete <- function(n, probs,values) {
  cumprobs <- cumsum(probs)
  singlenumber <- function() {
    x <- runif(1)
    N <- sum(x > cumprobs)
    N
  }
  values[replicate(n, singlenumber())+1]
}
x=rdiscrete(1e5,pf,mids)
summary(as.factor(x))
y=rdiscrete(1e5,pm,mids)
summary(as.factor(y))
(delT=quantile(x-y,c(0.025,0.975)))
(lb1=paste0("Delta*tau == ",tauf-taum,"(",delT[1],", ",delT[2],")"))
#(lb1=paste0("Delta*tau == ",tauf-taum,"~group(\"(\",",delT[1],",",delT[2],",\")\")")) # attempt with group() failed
# quartz(height=7,width=8)  # set back to square
(p=p+annotate("text",x=15,y=7, hjust=0, label = lb1,size=7,parse=T) ) #just show since can't add space before ( 
sprintf("%s (%s, %s)",tauf-taum,delT[1],delT[2])
# ggsave(p,file="~/IR2CML.eps")


### Figure 7: interpretations ##############
# graphics.off()
# quartz(height=6,width=6) 

# setEPS()
# postscript('~/concept.eps', height = 6, width = 6)

k=0.025
Tp=22.1
Rp=1.73
Tf=-15:23
fR=function(Tf) exp(-k*(Tf-Tp))
R=fR(Tf)


par(mar=c(4.5,4.5,0,.5))
plot(Tf,R,type="l",lwd=2.5,cex.lab=1.6,cex.axis=1.5,
     ylab="(male risk)/(female risk) M/F",
     xlab="extra female latency time T in years",axes=F,font=2)
mtext(side=3,line=-4,"Continuum of SEER CML\n Sex Difference Interpretations",cex=1.5,font=1)
# axis(1);axis(2)
points(x=c(0,Tp),y=c(Rp,1),pch=1,cex=3,lwd=3)
abline(h=1,v=0,lty=3)
fT=function(R) Tp-log(R)/k
# Tx=3.86
# Rx=1.26
# # points(x=c(fT(Rx),Tx),y=c(Rx,fR(Tx)),pch="+",cex=3)
# # plot(1:20,pch=1:20)
# x=seq(Tx,fT(Rx),0.1)
# x=seq(delT[1],delT[2],0.1)
# y=fR(x)
# points(x,y,type="l",lwd=6)

x=seq(tauDiff[2],tauDiff[3],0.1)
y=fR(x)
points(x,y,type="l",lwd=7)



rect(-1,1.13*Rp,23,1.26*Rp,lwd=2)
text(12,1.2*Rp,"interpretations by\n a single cause",cex=1.4,font=1,bty="o")
arrows(x0=0,y0=1.13*Rp,x1=0,y1=Rp+0.05,lwd=2,angle=20)
arrows(x0=Tp,y0=1.13*Rp,x1=Tp,y1=1.05,lwd=2,angle=20)
text(4,1.04*Rp,"higher\nmale\nrisk",cex=1.4,font=1)
text(10,0.96*Rp,"or",cex=1.4,font=2)
text(18,0.9*Rp,"shorter\nmale\nlatency",cex=1.4,font=1)
text(-9,1.38,
     "interpretations\nconsistent with\ntime-since-\nexposure data\n(heavy line)",
     cex=1.4,font=1)
arrows(x0=-2,y0=1.4,fT(1.4),y1=1.4,lwd=2,angle=20)
# dev.off() 


###############################################33


# Age at exposure: Figure 8
graphics.off()
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
windows(width=8,height=7)


head(d)
d$Dose<-cut(d$sv,c(-1,.02,1,100),labels=c("Low","Moderate","High"))
d$Dose=factor(d$Dose,levels=c("High","Moderate","Low"))


d$agexc<-cut(d$agex,c(0,20,40,180),labels=c("10","30","50"))
d$Sex<-factor(d$s,labels=c("Male","Female"))
head(d)
library(plyr) 
(d2<-ddply(subset(d,c==0), .(Dose,Sex,agexc), summarise,
           PY=sum(py),cases=sum(cml),agex=weighted.mean(agex,py) )) #
(d2=within(d2,{incid=1e5*cases/PY}))

library(ggplot2)
(p <- ggplot(d2,aes(x=agex,y=incid,shape=Dose,col=Dose,group=Dose))+geom_point(size=5) +geom_line()
 + labs(title="Hiroshima A-bomb Survivors",x="Age-at-exposure (PY-weighted)",
        y=expression(paste("CML Cases per ",10^5," Person-Years")))    
 + scale_y_log10(limits=c(.1,130)) +xlim(8,52) )
(p=p + facet_grid(. ~ Sex))
(p=p+theme(
#   legend.position = "none", 
   legend.position = c(0.67, .85), 
           legend.title = element_text(size = rel(2)) ,
           legend.text = element_text(size = rel(1.3))  ) )  

(p=p+theme(plot.title = element_text(size = rel(2)),
           strip.text = element_text(size = rel(2)),
           axis.title.y = element_text(size = rel(1.7)),
           axis.title.x = element_text(size = rel(1.7)),
           axis.text = element_text(size = rel(2)))  )

# ggsave(p,file="~/agex.eps")
# ggsave(p,file="/users/radivot/case/grants/sachs/HSCepi/figs/agex.png")

########### make a similar plot for age, not agex. 

#This plot shows just how crazy the Hiroshima Females really are, i.e. it shows
#that we should try to stay away from them.

# graphics.off()
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
windows(width=8,height=7)

head(d)
d$agec<-cut(d$age,c(0,30,60,180),labels=c("15","45","75"))
d$Dose<-cut(d$sv,c(-1,.02,1,100),labels=c("Low","Moderate","High"))
d$Sex<-factor(d$s,labels=c("Male","Female"))
head(d)
library(plyr) 
(d3<-ddply(subset(d,c==0), .(Dose,Sex,agec), summarise,
           PY=sum(py),cases=sum(cml),age=weighted.mean(age,py) )) #
(d3=within(d3,{incid=1e5*cases/PY}))

library(ggplot2)
(p <- ggplot(d3,aes(x=age,y=incid,shape=Dose,group=Dose))+geom_point(size=5) +geom_line()
 + labs(title="Hiroshima A-bomb Survivors",x="Attained-age (PY-weighted)",
        y=expression(paste("CML Cases per ",10^5," Person-Years")))    
 + scale_y_log10(limits=c(.1,130)) +xlim(8,90) )
(p=p + facet_grid(. ~ Sex))
(p=p+theme(legend.position = c(0.67, .85), 
           legend.title = element_text(size = rel(2)) ,
           legend.text = element_text(size = rel(1.7))  ) )  

(p=p+theme(plot.title = element_text(size = rel(2.5)),
           strip.text = element_text(size = rel(2)),
           axis.title.y = element_text(size = rel(2.5)),
           axis.title.x = element_text(size = rel(2.3)),
           axis.text = element_text(size = rel(2.3)))  )



# Skip below 

# ###############################################33
# # for b test bin up times since exposure in groups of two to make fewer parameters
# dHM=subset(d,Sex=="Male"&c==0)
# head(dHM)
# summary(hm0<-mle2(cml~dpois(lambda=py*(exp(c10 + k*age)+sv*exp(f)) ),
#                   parameters=list(f~-1 + tsxf),
#                   start=list(c10=-12.4,k=0.025,f=-10),data=dHM ) )
# 
# summary(hm1<-mle2(cml~dpois(lambda=py*(exp(c10 + k*age)+
#                                          exp(-b*abs(agex-30)/28.85)*sv*exp(f)) ),
#                   parameters=list(f~-1 + tsxf),
#                   start=list(c10=-12.4,k=0.025,f=-10,b=0.5),data=dHM ) )
# anova(hm0,hm1) # P=0.12  HM only => no longer can claim significance
# 


# #################### try full model
# summary(s3<-mle2(cml~dpois(lambda=py*(exp(c10 + c2c*c + c2s*s + k*age + ks*s*age)
#                                       +sv*exp(c2c*c  + f + c2sa*s*a55 )  ) ),
#                  parameters=list(f~-1 + tsxf:sex),
#                  start=list(c10=-12.4,k=0.025,ks=0,c2c=-1.50,
#                             c2s=-0.18,f=-5,c2sa=2),data=d) ) 
# 
# summary(s3x<-mle2(cml~dpois(lambda=py*(exp(c10 + c2c*c + c2s*s + k*age + ks*s*age)
#                     +sv*exp(c2c*c  + f + c2sa*s*a55 + c2x*(1-c)*(1-s)*abs(agex-30) )  ) ),
#                  parameters=list(f~-1 + tsxf:sex),
#                  start=list(c10=-12.4,k=0.025,ks=0,c2c=-1.50,
#                             c2s=-0.18,f=-5,c2sa=2,c2x=.05),data=d) ) 
# summary(a55HMb)
# AIC(s3,s3x)
# ICtab(s3,s3x)
# anova(s3,s3x)

rm(list=ls())
library(SEERaBomb);library(ggsci)
myt=theme(legend.position=c(.52,.85),legend.title=element_blank(),
    legend.direction="vertical",legend.margin=margin(0,0,0,0),
    legend.key.height=unit(.7,'lines'),strip.background=element_blank())
gy=ylab(quote(paste("Cases per ",10^5," Person-Years")))
ge=geom_errorbar(aes(ymin=LL,ymax=UL),width=0.1);jco=scale_color_jco()
cc=coord_cartesian(ylim=c(.2,200));tc=theme_classic(base_size=12)
gp=geom_point();gl=geom_line();f=facet_wrap(~cancer);sy=scale_y_log10()
load("~/data/abomb/abomb.RData")
(d=heme%>%select(ageG:DG,age,agex,t,D,py,AML=AMLtot,ALL,CML))

gx=xlab("Attained Age (Years)")
(dA=incidAbomb(d%>%group_by(ageG,DG)))
ggplot(dA,aes(x=age,y=I,shape=DG,col=DG))+gp+gl+gx+sy+gy+ge+f+cc+tc+myt+jco
ggsave("~/Results/tutorial/abombLeuAge.pdf",width=4,height=2.5)#Fig.6A

gx=xlab("Age at Time of Bombing (Years)")
(dB=incidAbomb(d%>%group_by(agexG,DG)))
ggplot(dB,aes(x=agex,y=I,shape=DG,col=DG))+gp+gl+gx+sy+gy+ge+f+cc+tc+myt+jco
ggsave("~/Results/tutorial/abombLeuAgex.pdf",width=4,height=2.5)#Fig.6B

gx=xlab("Years Since Bombing")
(dC=incidAbomb(d%>%group_by(tG,DG)))
ggplot(dC,aes(x=t,y=I,shape=DG,col=DG))+gp+gl+gx+sy+gy+ge+f+cc+tc+myt+jco
ggsave("~/Results/tutorial/abombLeuTsx.pdf",width=4,height=2.5)#Fig.6C

gx=xlab("Dose (Sv)")
d$DG<-cut(d$D,c(-1,.02,.25,.5,.75,1.5,100))
(dD=incidAbomb(d%>%group_by(DG)))
ggplot(dD,aes(x=D,y=I))+gp+gl+gx+sy+gy+ge+f+cc+tc+myt+jco+
  scale_x_continuous(breaks=0:2)
ggsave("~/Results/tutorial/abombLeuDoseResp.pdf",width=4,height=2.5)#Fig.6D

# tables.R 
library(SEERaBomb)
library(reshape2)
library(XLConnect) 
# rnD=function(d,n=1) { 
#   d[sapply(d,is.numeric)]=round(d[sapply(d,is.numeric)],n)
#   d
# }

unlink(f<-"~/Results/amlMDS/Tables.xlsx") 
wb <- loadWorkbook(f,create=T) 
tab1="table1_validation"
createSheet(wb, tab1)
# setSheetColor(wb, tab1, XLC$COLOR.GREEN)
# As code validation, we will reproduce results in Lancet Oncol 2011; 12: 353-60
# As a representative example, for Table 1, we will use prostate cancer treatment induced
# bladder cancer risk and breast cancer treatment induced lung cancer risk
# take canc and popsa from here to avoid redefining trt and AML (to include APL)
system.time(load("~/Results/amlMDS/pm20.RData")) # 2 secs to load. 
system.time(load("~/Results/amlMDS/pf20.RData")) # 3 secs to load. 
mkExcel(pm20,"b5",outDir="~/Results/amlMDS") # makes male excel file for all 1sts and 2nds.
mkExcel(pf20,"b5",outDir="~/Results/amlMDS") # makes female file (sheets are 1sts, rows 2nds). 
# read in the two excel files just made
wbM <- loadWorkbook("~/Results/amlMDS/pMs20e85b5.xlsx") # aka validationMales.xlsx
wbF <- loadWorkbook("~/Results/amlMDS/pFs20e85b5.xlsx") # aka validationFemales.xlsx
(dm=readWorksheet(wbM,"prostate")) # and pull off sheets of interest
(df=readWorksheet(wbF,"breast"))

mkrow=function (df) {cbind(
  df%>%filter(X2nd.cancer=="bladder")%>%select(noRad2bladder=X.5.100..after.noRad),
  df%>%filter(X2nd.cancer=="lung")%>%select(noRad2lung=X.5.100..after.noRad),
  df%>%filter(X2nd.cancer=="bladder")%>%select(rad2bladder=X.5.100..after.rad),
  df%>%filter(X2nd.cancer=="lung")%>%select(rad2lung=X.5.100..after.rad))}
D=rbind(mkrow(df),mkrow(dm))
writeWorksheet(wb,"Table 1. Software validation based on RR* of second bladder- and lung cancers in SEER-9",
               sheet = tab1,header=FALSE)
# writeWorksheet(wb,cbind(first=c("breast","prostate"),D), sheet = tab1,rownames=1, startRow=2)
writeWorksheet(wb,cbind(First.Cancer=c("breast","prostate"),D), sheet = tab1,startRow=2)
for (j in 1:(dim(D)[2]+1)) setColumnWidth(wb,sheet = tab1, column = j, width = 5300)
# save workbook of Tables, including Table 1, only after making all the sheets. 

##### setup for other Tables
system.time(load("~/Results/amlMDS/pm.RData")) # 4 secs to load. 
system.time(load("~/Results/amlMDS/pf.RData")) # 4 secs to load. 
names(pm)
(pm$secondS)
names(pm$L)
#the following heme malignancies (HM) first cancer are excluded from Tables 2 and 3. 
HM=c("AML","MDS","CMML","CML","MPN","ALL","CLL","SLL","HCL","OL","NHL","MM","hodgkin") 

# the following myeloid first cancers are excluded from Tables 4-8
ML=c("AML","MDS","CMML","CML","MPN") # remove MyeLoid firsts. Interest in age correlations with de novo AML

dm=mkDF(pm,"b0_0.25_1_12")
df=mkDF(pf,"b0_0.25_1_12")
d=rbind(cbind(df,Sex="Female"),cbind(dm,Sex="Male"))
d=d%>%filter(!cancer1%in%HM)%>%group_by(trt,cancer2,Sex,int)%>%summarize(O=sum(O),E=sum(E),t=weighted.mean(t,py,na.rm=T))
d=d%>%mutate(RR=O/E, L=qchisq(.025,2*O)/(2*E),U=qchisq(.975,2*O+2)/(2*E))
d=d%>%mutate(RR=paste0(sprintf("%.2f",RR)," (",sprintf("%.2f",L),", ",sprintf("%.2f",U),")"))%>%select(-L,-U,-t)
D1=d%>%filter(int=="(1,12]")%>%select(-int)
D2=d%>%filter(int=="(12,100]")%>%select(-int)
D1$interval="1-12"
D2$interval=">12"
D=rbind(D1,D2)
D=as.data.frame(D)

tab="table2"
createSheet(wb, name = tab)
writeWorksheet(wb, "Table 2. AML/MDS RR after any non-hematological 1st cancer", sheet = tab,header=FALSE)
writeWorksheet(wb, D, sheet = tab,startRow=2)
for (i in 1:5) setColumnWidth(wb,sheet = tab, column = i, width = 2500)
setColumnWidth(wb,sheet = tab, column = 6, width = 4000)
setColumnWidth(wb,sheet = tab, column = 7, width = 3000)

####################### TABLE 3 ##############
mkDCSA=function(df,dm,N=30,intv,trtv) { # cancer specific with ages  # intv= "(1,12]";N=30;trtv="rad
  d=rbind(cbind(df,Sex="Female"),cbind(dm,Sex="Male"))
  d=d%>%filter(!cancer1%in%ML,trt==trtv,O>=N,int==intv,(RR>1&rrL>1)|(RR<1&rrU<1))%>%arrange(cancer2,desc(RR))%>%
    select(cancer1,cancer2,Sex,Age=ageO,O,E,RR)
  d=d%>%mutate(RR=O/E, L=qchisq(.025,2*O)/(2*E),U=qchisq(.975,2*O+2)/(2*E))
  d%>%mutate(RR=paste0(sprintf("%.2f",RR)," (",sprintf("%.2f",L),", ",sprintf("%.2f",U),")"))%>%select(-L,-U)
}

tab="table3"
createSheet(wb, name = tab) 
(D1=mkDCSA(df,dm,30,"(1,12]","rad"))
(D2=mkDCSA(df,dm,50,"(1,12]","noRad"))
D1$radiation="Yes"
D2$radiation="No"
D=rbind(D1,D2)
ct=cor.test(D$Age,D$O/D$E,method="spearman")
(rho=paste0("rho=",round(ct$estimate,3),"; P = ",format.pval(ct$p.value,digits=2)))
writeWorksheet(wb,"Table 3. AML/MDS RR 1-12 years after non-myeloid first cancers",
               sheet = tab,header=FALSE)
writeWorksheet(wb, D, startRow=2,sheet = tab)
writeWorksheet(wb, rho, startCol=9,startRow=3,sheet = tab, header=FALSE)
setcols=function(wb,tab) {
  for (j in 1:6) setColumnWidth(wb,sheet = tab, column = j, width = 2500)
  setColumnWidth(wb,sheet = tab, column = 7, width = 4500)
  setColumnWidth(wb,sheet = tab, column = 8, width = 2000)
#   setColumnWidth(wb,sheet = tab, column = 8, width = 4500) # for rhos
}
setcols(wb,tab)

tab="table4"  # first and last time points
createSheet(wb, name = tab) 
(D2r=mkDCSA(df,dm,5,"(12,100]","rad"))
(D2nr=mkDCSA(df,dm,10,"(12,100]","noRad"))
(D1r=mkDCSA(df,dm,20*1.9/5,"(0,0.25]","rad"))
(D1nr=mkDCSA(df,dm,N=20,"(0,0.25]","noRad"))
D1r$radiation="Yes"
D1nr$radiation="No"
D2r$radiation="Yes"
D2nr$radiation="No"
D1=rbind(D1nr,D1r)
D2=rbind(D2nr,D2r)
D1$interval="<0.25"
D2$interval=">12"
D=rbind(D1,D2)%>%select(-Age)
writeWorksheet(wb,"Table 4. AML/MDS initial and Steady State RR after non-myeloid first cancers",
               sheet = tab,header=FALSE)
writeWorksheet(wb, D, sheet = tab,startRow=2)
setcols(wb,tab)
for (j in 1:5) setColumnWidth(wb,sheet = tab, column = j, width = 2500)
setColumnWidth(wb,sheet = tab, column = 6, width = 4500)
setColumnWidth(wb,sheet = tab, column = 7, width = 3000)
setColumnWidth(wb,sheet = tab, column = 8, width = 3000)
saveWorkbook(wb)


####### this makes an excel file with summary sheets/Tables of SEER cases by year and ICD-O3
if (1) {
  library(XLConnect) 
  library(dplyr) 
  library(scales)    
  cf=function (x) comma_format(width=17,justify="right")(x)
  
  load("~/data/SEER/mrgd/cancDef.RData")
  load("~/data/SEER/mrgd/popsae.RData")
  head(popsae)
  PY=(popsae%>%group_by(year)%>%summarize(PY=sum(py)))[[2]]
  unlink(f<-"~/Results/amlMDS/SEERdataOverView.xlsx") 
  wb <- loadWorkbook(f,create=T) 
  
  createSheet(wb, name = "yearXcancer") 
  yrca=table(canc$yrdx,canc$cancer)
  yrTot=apply(yrca,1,sum)
  Total=apply(yrca,2,sum)
  gtot=sum(Total)
  D=data.frame(year=c(1975:2016,NA),as.data.frame(rbind(yrca,Total)),total=c(yrTot,gtot),PY=cf(c(PY,sum(PY))))
  writeWorksheet(wb,D, sheet = "yearXcancer")
  setColumnWidth(wb,sheet = "yearXcancer", column = dim(D)[2], width = 3700)
  createFreezePane(wb,"yearXcancer",2,2) #sheet colSplit rowSplit
  
  createSheet(wb, name = "histo3Xcancer") 
  total=table(canc$cancer)
  h3ca=table(canc$histo3,canc$cancer)
  D=as.data.frame(cbind(hist03=c(as.numeric(row.names(h3ca)),NA),rbind(h3ca,total)))
  writeWorksheet(wb,D, sheet = "histo3Xcancer")
  createFreezePane(wb, "histo3Xcancer",2,2) 
  
  createSheet(wb, name = "yearXhisto3") 
  total=table(canc$histo3)
  yrh3=table(canc$yrdx,canc$histo3)
  D=as.data.frame(cbind(year=c(1975:2016,NA),rbind(yrh3,total)))
  writeWorksheet(wb,D, sheet = "yearXhisto3")
  createFreezePane(wb, "yearXhisto3",2,2) 
  
  saveWorkbook(wb)
}

# mkExcelDemo.R
rm(list=ls()) 
library(SEERaBomb) 
library(tidyverse)
library(magrittr)
if (1) {
  load("~/data/SEER/mrgd/cancDef.RData") 
  load("~/data/SEER/mrgd/popsae.RData") 
  canc=canc%>%select(-reg,-radiatn,-histo3,-ICD9)
  canc=canc%>%filter(cancer!="benign")
  canc%<>%separate(trt,c("trt","trtc"))
  canc$trt=factor(canc$trt)
  popsa=popsae%>%group_by(db,race,sex,age,year)%>%summarize(py=sum(py)) # sum on regs
  m=seerSet(canc,popsa,Sex="Male",ageStart=0,ageEnd=100) 
  f=seerSet(canc,popsa,Sex="Female",ageStart=0,ageEnd=100) 
  m=mk2D(m) 
  f=mk2D(f) 
  brks=c(0,0.5,1,2,3,10)
  m=tsd(m,brks=brks,trts=c("rad","noRad")) 
  f=tsd(f,brks=brks,trts=c("rad","noRad"))
  system.time(save(m,f,file="~/Results/amlMDS/mfExcel.RData")) #~10 seconds 
} else {
  load("~/Results/amlMDS/mfExcel.RData") 
}

mkExcelTsd(m,"b0_0.5_1_2_3_10",outDir="~/Results/amlMDS",outName="males") #out filenames are otherwise coded. 
mkExcelTsd(f,"b0_0.5_1_2_3_10",outDir="~/Results/amlMDS",outName="females")
mkExcelTsd(m,"b0_0.5_1_2_3_10",outDir="~/Results/amlMDS",outName="males",flip=T)
mkExcelTsd(f,"b0_0.5_1_2_3_10",outDir="~/Results/amlMDS",outName="females",flip=T)

# test using csd instead of tsd
if(1) {
  mc=csd(m,brkst=c(0,0.5,1,2,3,10),trts=c("rad","noRad")) 
  fc=csd(f,brkst=c(0,0.5,1,2,3,10),trts=c("rad","noRad")) 
  system.time(save(mc,fc,file="~/Results/amlMDS/mfExcelCSD.RData")) # 33 secs
} else {
  load("~/Results/amlMDS/mfExcelCSD.RData") 
}
mkExcelCsd(mc,"b0_0.5_1_2_3_10",biny="[1975,2017)",outDir="~/Results/amlMDS",outName="malesCsd") 
mkExcelCsd(fc,"b0_0.5_1_2_3_10",biny="[1975,2017)",outDir="~/Results/amlMDS",outName="femalesCsd") 
mkExcelCsd(mc,"b0_0.5_1_2_3_10",biny="[1975,2017)",outDir="~/Results/amlMDS",outName="malesCsd",flip=T) 
mkExcelCsd(fc,"b0_0.5_1_2_3_10",biny="[1975,2017)",outDir="~/Results/amlMDS",outName="femalesCsd",flip=T) 

# extends cmlMort.R to 3x2 AML-ALL-CML tables of plots
graphics.off();rm(list=ls())
library(SEERaBomb)
load("~/data/SEER/mrgd/cancDef.RData")
leus=c("AML","ALL","CML")
d=canc%>%filter(cancer%in%leus)%>%mutate(cancer=factor(cancer,leus))
d=d%>%mutate(status=as.numeric(COD>0),surv=(surv+0.5)/12)
(d=d%>%select(yrdx,agedx,sex,surv,status,cancer)%>%group_by(cancer))
load("~/data/usMort/mrt.RData")#loads mrt
(D=d%>%do(msd(.,mrt,brkst=c(0,0.5,1,2,3,4,5,6,8),brksy=c(1973,1990,2005,2015)))) 
(g=qplot(x=t,y=RR,data=D,col=Years,geom=c("line","point"),facets=sex~cancer,
        xlab="Years Since CML Diagnosis",ylab="Relative Risk of Mortality"))
(g=g+scale_x_continuous(breaks=seq(0,15,5))+scale_color_jco())
(g=g+theme(legend.position="top",legend.title=element_blank()))
(g=g+geom_abline(intercept=1,slope=0)+ylim(c(0,NA)))
g+geom_errorbar(aes(ymin=rrL,ymax=rrU),width=.2)
ggsave("~/Results/tutorial/mortRR.pdf",width=4.5,height=3)

labs=c("1973-1990","1991-2005","2006-2015")
d=d%>%mutate(yrg=cut(yrdx,c(1972,1990,2005,2015),labels=labs))%>%print(n=13)
library(survival);library(survminer)
levels(d$cancer)
fit=survfit(Surv(surv,status)~yrg+sex+cancer,data=d) 
levels(d$cancer)
ggsurvplot_facet(fit,d,facet.by=c("sex","cancer"),ylab="Survival Probability",
                 xlab="Years Since CML Diagnosis",legend.title="",
                 xlim=c(0,12),short.panel.labs=T)+
  scale_x_continuous(breaks=seq(0,15,5))+scale_color_jco()
ggsave("~/Results/tutorial/leuSurvTrends.pdf",width=4.5,height=3)

library(SEERaBomb)
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
windows(width=10,height=5)
par(mfrow=c(1,2),mar=c(4.3,2,.2,1.2),oma=c(0,0,2,0),cex=1.2,cex.lab=1.2,cex.axis=1.1)
d=Sigurdson[Sigurdson$age>20,]
d$lgTlcn=log(d$tlcn)
lm1=lm(lgTlcn~age,data=d)
lm2=lm(lgTlcn~age+I(age^2),data=d)
print(summary(lm1))
print(summary(lm2))
print(anova(lm1,lm2))
lm3=lm(lgTlcn~log(age),data=d)
plot(d$tlcn~d$age,log="y",ylab="",xlab="Age",xlim=c(20,84))
title("Translocations per 100 cell equivalents",outer=T)
y=exp(lm1$coeff[1]+lm1$coeff[2]*d$age)
lines(d$age,y)
plot(d$tlcn~d$age,log="xy",ylab="",xlab="Age",xlim=c(20,84))
y=exp(lm3$coeff[1]+lm3$coeff[2]*log(d$age))
lines(d$age,y)

#amlMDScomputing.R
rm(list=ls())  
library(SEERaBomb)
library(dplyr)  #the %>% operators below come from here
# the following was made earlier using SEERaBomb's mkSEER
load("~/data/SEER/mrgd/cancDef.RData") #loads in canc
canc=canc%>%filter(cancer!="benign")
load("~/data/SEER/mrgd/popsae.RData") # loads in popsae (extended to ages 85-99)
# trim down columns to bare neccesities needed for this paper. 
canc=canc%>%select(-reg,-COD,-histo3,-ICD9)
# canc=canc%>%select(-reg,-recno,-agerec,-numprims,-COD,-age19,-radiatn,-histo3,-ICD9)
popsa=popsae%>%group_by(db,race,sex,age,year)%>%summarize(py=sum(py)) # sum on regs
head(canc,1)
head(popsa,1)
levels(canc$cancer) # default is that AMLti and APL are separate from AML
#next chunk upgrades AML definition to include APL and AMLti (AML by translocation or inversion)
# mapCancs# shows ICD9/ICDO3 cancer definitions 
canc$cancer[canc$cancer=="APL"] ="AML" # overwrite back to AML
canc$cancer[canc$cancer=="AMLti"] ="AML" # overwrite back to AML
canc$cancer=factor(canc$cancer)#eliminate extra levels: this happens in seerSet() too so not critical
levels(canc$cancer)
head(canc,2)
levels(canc$trt)
library(tidyverse)
library(magrittr)
canc%<>%separate(trt,c("trt","trtc"))
head(canc,2)
canc$trt=factor(canc$trt)

pm=seerSet(canc,popsa,Sex="Male",ageStart=0,ageEnd=100) #pooled (races) male seerSet
pf=seerSet(canc,popsa,Sex="Female",ageStart=0,ageEnd=100) #pooled (races) female seerSet
pm=mk2D(pm,secondS=c("AML","MDS")) # 4 secs
pf=mk2D(pf,secondS=c("AML","MDS"))# list object pf goes in and also comes out, with more on it
# comparing objects, note that mk2D added the dataframe D (for 2D plotting) to the object 

##########  background incidence plots
# plot2D(pm)  # this uses rgl to interactively pick a nice angle for a picture in FIGURE 3
# plot2D(pf,col="gray") # note from its help page in SEERaBomb that the pngs go to "~/Results/plots".
# To just look at the surfaces, override the default of write, e.g. use plot2D(pm,write=F)
##########  END background incidence

########## first some calcs over all times for the consort diagram
brks=c(0) # we want all times t>=0, so we set the brks vector to brks = 0
pm0=tsd(pm,brks=brks,trts=c("rad","noRad"),PYLong=TRUE) 
pf0=tsd(pf,brks=brks,trts=c("rad","noRad"),PYLong=TRUE) # PYLong adds a lot of bulk
system.time(save(pm0,pf0,file="~/Results/amlMDS/consort.RData")) # so save to a separate file 
######### now get full time courses for Figure 2   # this takes some computing time
brks=c(0,0.25,0.5,0.75,1,1.5,2,2.5,3,4,5,6,8,10,12) # get 12 to line up with tables
pm=tsd(pm,brks=brks,trts=c("rad","noRad")) 
pf=tsd(pf,brks=brks,trts=c("rad","noRad"))# this adds the list L to the object pf
# The list L has only one element now, named according to brks, but this will grow out
# with each call to tsd (time since diagnosis: see SEERaBomb's tsd help page) below

################### END computing RR, O, E and PY for full time courses

########### now Fig 4 first cancers less prevalent than breast or prostate
brks=c(0,1,2,3,6,9,12)   # intermediate level resolution
pm=tsd(pm,brks=brks,trts=c("rad","noRad")) 
pf=tsd(pf,brks=brks,trts=c("rad","noRad")) 
########### End specific first cancer calcs

######### START get risks over 1 to 12 years for Tables ######## 
brks=c(0,0.25,1,12)
pm=tsd(pm,brks=brks,trts=c("rad","noRad")) 
pf=tsd(pf,brks=brks,trts=c("rad","noRad")) 
system.time(save(pm,file="~/Results/amlMDS/pm.RData")) #~10 seconds 
system.time(save(pf,file="~/Results/amlMDS/pf.RData")) 

# brks=c(0,0.25,1,12)
# pm=tsd(pm,brks=brks,trts=c("rad","noRad"),PYLong=T) # this TRUE bulks things up, slows reading in 
# pf=tsd(pf,brks=brks,trts=c("rad","noRad"),PYLong=T) 
# system.time(save(pm,file="~/Results/amlMDS/pmPYM.RData")) #so save in separate file 
# system.time(save(pf,file="~/Results/amlMDS/pfPYM.RData")) 
######## END Table calcs



######### START get SEER9 time courses for the left panel of Figure S5 
canc9=canc%>%filter(db=="73")  
popsa9=popsa%>%filter(db=="73")
(pm9=seerSet(canc9,popsa9,Sex="Male",ageStart=0,ageEnd=100)) #pooled (races) male seerSet
(pf9=seerSet(canc9,popsa9,Sex="Female",ageStart=0,ageEnd=100)) #pooled (races) female seerSet
pm9=mk2D(pm9,secondS=c("AML","MDS")) # 3 secs, was 170 secs with all cancerS
pf9=mk2D(pf9,secondS=c("AML","MDS"))
# plot2D(pm9,write=F)  
# plot2D(pf9,write=F)
brks=c(0,0.25,0.5,0.75,1,1.5,2,2.5,3) # this is to show the improvement in variance of MDS
pm9=tsd(pm9,brks=brks,trts=c("rad")) 
pf9=tsd(pf9,brks=brks,trts=c("rad"))  
system.time(save(pm9,file="~/Results/amlMDS/pm9.RData")) #~6 seconds 
system.time(save(pf9,file="~/Results/amlMDS/pf9.RData")) 
################### END computing RR, O, E and PY for SEER9 for right panel of Fig S5. 

# the next chunk is to validate the codes via Table 1
pm20=seerSet(canc9,popsa9,Sex="Male",ageStart=20,ageEnd=85) #pooled (races) male seerSet
pf20=seerSet(canc9,popsa9,Sex="Female",ageStart=20,ageEnd=85) #pooled (races) female seerSet
pm20=mk2D(pm20) # 55 secs (goes through all second cancers by default)
pf20=mk2D(pf20) #
pm20=tsd(pm20,brks=c(5)) 
pf20=tsd(pf20,brks=c(5)) 
system.time(save(pm20,file="~/Results/amlMDS/pm20.RData")) #~6 seconds 
system.time(save(pf20,file="~/Results/amlMDS/pf20.RData")) 

# APL
fisher.test(matrix(c(5,13,0,13),ncol=2))

###############  A-bomb data using dplyr
rm(list=ls())
library(SEERaBomb)
mkAbomb() # converts lsshempy.csv and lssinc07.csv in ~\data\abomb into tables heme and sol in ~\data\abomb\abomb.db
load("~/data/abomb/abomb.RData")
hemeDesc
solidDesc
heme
solid
# stuff below was a database idea that is now fading away
db <- src_sqlite("~/data/abomb/abomb.db") #dplyr interface replaces RSQLite interface functions
class(db)
src_tbls(db)
(hd=tbl(db, sql("SELECT * from hemeDesc"))) # nrows not known?
class(hd)
str(hd)  #S3: holds where to find and what to get, but not actual values. Some subcomponents are S4. 
options(dplyr.print_min=50L) # set this option to see more rows
hd # 37 rows are all of them.  ?? => still didn't fetch them. 
options(dplyr.print_min=7L)

(H=tbl(db, sql("SELECT * from heme")))  # trims off columns as well as rows
(h=select(H,city:calg,py,agex:year,D,ATL,ALL,AMLtot,CML,CLL,NHL,MM))   # : is a nice aspect of select()
(gh = group_by(h, city,sex)  ) # grouping is now in print out header.
(gh=summarise(gh,totATL=sum(ATL),totALL=sum(ALL),totAML=sum(AMLtot),totCML=sum(CML),totCLL=sum(CLL),totNHL=sum(NHL),totMM=sum(MM),totPY=sum(py)))
# note ATL and CML city differences, and that CLL is low in japan
summarise(gh,totAML=sum(totAML),totCML=sum(totCML),totPY=sum(totPY)) # sums over sexes and removes the final grouping by city
summarise(h,totATL=sum(ATL),totALL=sum(ALL),totAML=sum(AMLtot),totCML=sum(CML),totCLL=sum(CLL),totPY=sum(py)) # go straight to ungrouped for totals
# 4e6/50# = 80000 is about right, i.e. ~80k survivors followed for ~50 years
gh  # ??  => still didn't fetch them. 
class(gh)  # tbl_sql and tbl but not a data.frame
(h=collect(h) ) #Collect() to bring it into R. Now it knows the number of rows
class(h) # and its class becomes tbl_df instead of tbl_sql and includes data.frame as a default. 


(H=tbl(db, sql("SELECT * from heme")))  # trims off columns as well as rows
H %>% filter(agex<1,D>4)%>%select(agex:D) #infants hit with more than 4Gy
# 1 of 3 getting childhood ALL supports the idea that pregnant women should not be x-rayed

(d<-collect(H %>% select(age,D,un4gy,py,AMLtot,CML,ALL,ATL,NHL,MM) %>% filter(un4gy==1)))
d=d %>%   # need to have it in R to do cut()
  mutate(dose=cut(D,c(-2,.02,.4,10),labels=c("low","med","high"),include.lowest=TRUE)) %>%
  mutate(age=cut(age,c(seq(0,80,20),110),labels=seq(10,90,20))) 
d=d%>%
  group_by(dose,age) 
d=d%>%summarize(py=sum(py),AML=sum(AMLtot)/py,CML=sum(CML)/py,ALL=sum(ALL)/py,ATL=sum(ATL)/py,NHL=sum(NHL)/py,MM=sum(MM)/py)
d

library(reshape2)
md=melt(d,id.vars=1:2,measure.vars=4:9,value.name = "Incidence")
md$age=as.numeric(as.character(md$age)) # make ages numeric to help ggplot connect the dots
library(ggplot2)
graphics.off()
theme_set(theme_gray(base_size = 16)) 
qplot(data=md,y=Incidence,x=age,col=dose,log="y")+facet_wrap(~variable)+geom_line()

##### A-bomb solids
ts=tbl(db, sql("SELECT * from solid"))  # ts = table of solids
(d<-collect(ts %>% select(age,marD,un4gy,py,lung,breast,prost,thyroid) %>% filter(un4gy==1)))
d$marD
d=d %>%   
  mutate(dose=cut(marD,c(-200,.02,.4,10),include.lowest=TRUE,labels=c("low","med","high"))) %>%
  mutate(age=cut(age,c(seq(0,80,20),110),labels=c(seq(10,70,20),90))) %>%
  group_by(dose,age) %>%
  summarise(py=sum(py),lung=sum(lung)/py,thyroid=sum(thyroid)/py,prost=sum(prost)/py,breast=sum(breast)/py)

md=melt(d,id.vars=1:2,measure.vars=4:7,value.name = "Incidence")
md$age=as.numeric(as.character(md$age))
qplot(data=md,y=Incidence,x=age,col=dose,log="y")+facet_wrap(~variable)+geom_line()

mkPYMR <- function(PY,yearEnd) {
  py = PY[,1]
  age=PY[,2] 
  year=PY[,3]
  print(range(py))
  print(range(age))
  print(range(year))
  nr = length(py);
  yrs=1973:yearEnd
  nyears=length(yrs)
  ages=0.5:125.5
  #   ages=0.5:135.5
  nages=length(ages)
  PYM=matrix(0,ncol=nyears,nrow=nages)
  #    PYM=numeric(nyears*nages)
  if (nr>=1) for (i in 1:nr) {
    pystrip=py[i]
    rem = pystrip-floor(pystrip)
    quo = floor(pystrip)
    strtAgeIndx=round(age[i]+.5)
    strtYrIndx=round(year[i]-1972)
    for (j in 0:quo)   
      if ( (strtAgeIndx+j<=nages) & (strtYrIndx+j<=nyears))
        if (j==quo) 
          PYM[strtAgeIndx+j,strtYrIndx+j]=PYM[strtAgeIndx+j,strtYrIndx+j]+rem   else
            PYM[strtAgeIndx+j,strtYrIndx+j]=PYM[strtAgeIndx+j,strtYrIndx+j]+1
  }
#   print(nyears)
#   print(nages)
#   print(nages*nyears)
#   print(head(PYM))
#   print(tail(PYM))
#   print(dim(PYM))
  # length(PYM)<-nages*nyears
  #   dim(PYM)=c(nages,nyears)
  colnames(PYM)=yrs
  rownames(PYM)=ages
  PYM
}

.seerHome="~/data/SEER" # Assume here that the SEER data is in /data/SEER. Change this if not. 
rm(list=ls()) # note: dot variables defined above persist through such cleanings
library(RSQLite) # install.packages("RSQLite")
m=dbDriver("SQLite")
con=dbConnect(m,dbname=file.path(.seerHome,"00/all.db"))
da=dbGetQuery(con,"SELECT * from respir where ICD9>=1620 and ICD9<=1629 
and histo3=8140 and seqnum<2") # adenos
# da=transform(da,dwd=(COD>0),hist= "adenocarcinoma" ) # not alive; 0=alive
da=transform(da,dwd=((COD>=20010)&(COD<=37000)),hist= "adenocarcinoma" ) # dead with cancer, 0=alive
MFcnta=summary(as.factor(da$sex))
head(da)
ds=dbGetQuery(con,"SELECT * from respir where ICD9>=1620 and ICD9<=1629 
and histo3>=8070 and histo3<=8079 and seqnum<2") # squames
MFcnts=summary(as.factor(ds$sex))
# ds=transform(ds,dwd=(COD>0),hist= "squamous cell") # not alive; 0=alive
ds=transform(ds,dwd=((COD>=20010)&(COD<=37000)),hist= "squamous cell" ) # dead with cancer, 0=alive
d=rbind(da,ds)

sapply(d,class)
head(d)
library(survival)
# graphics.off()
if(length(grep("linux",R.Version()$os))) windows <- function( ... ) X11( ... )
if(length(grep("darwin",R.Version()$os))) windows <- function( ... ) quartz( ... )
windows(width=9,height=5)
par(mfrow=c(1,2),mar=c(4.5,4.1,1,1))
rb=c("blue","red") #males blue, femals red 
plot(S<-survfit(Surv(surv,dwd)~hist,data = subset(d,sex==1)), # main="SEER 2000-2010",
     xlab="Months",ylab="Survival", xlim=c(0,60) , #ylim=c(0.6,1),
     col=rb, main="Adeno Vs Squame")
print(S) 
legend("topleft",c("Males"),bty="n")

plot(S<-survfit(Surv(surv,dwd)~hist,data = subset(d,sex==2)), ,
     xlab="Months",ylab="Survival", xlim=c(0,60), #ylim=c(0.6,1),
     col=rb, main="Adeno Vs Squame")
print(S) 
legend("topleft",c("Females"),bty="n")

### common.R  common block sourced in by other scripts
graphics.off();rm(list=ls())#clear plots and environment
library(tidyverse);library(SEERaBomb);library(ggsci);library(bbmle)
load("~/data/SEER/mrgd/cancDef.RData")#load SEER cancer data
gp=geom_point();gl=geom_line()
geRR=geom_errorbar(aes(ymin=rrL,ymax=rrU),width=.1,alpha=0.4)
ge=geom_errorbar(aes(ymin=LL,ymax=UL),width=0.1,alpha=0.4)#for absolute risks
gh=geom_hline(yintercept=1)
svts=scale_x_continuous(breaks=c(0,5,10))#surv times
agts=scale_x_continuous(breaks=c(25,50,75))#age times
sbb=theme(strip.background=element_blank())
ltb=theme(legend.margin=margin(0,0,0,0),legend.title=element_blank())
ltp=theme(legend.position="top")
lh=theme(legend.direction="horizontal")
sy=scale_y_log10()
cc=coord_cartesian(ylim=c(0,10))#clips high errorbars
jco=scale_color_jco()
tc=function(sz) theme_classic(base_size=sz);
gxi=xlab("Age (Years)")
gyi=ylab(quote(paste("Cases per ",10^5," Person Years")))

# NOTE: This script assumes that the SEER data is in /data/SEER and that the 
# Abomb data file hema87.dat is in /data/abomb. Please change these two lines
# to match your data locations if they differ from these.
.aBombHome="/data/abomb"
.seerHome="/data/SEER" 
rm(list=ls()) # note: dot variables defined above persist through such cleanings
# install.packages("RSQLite")
# install.packages("bbmle")
# install.packages("ggplot2")
library(RSQLite)
m=dbDriver("SQLite")
library(plyr)
library(bbmle)
library(ggplot2)
graphics.off()
windows(height=7,width=8,xpos=-100,ypos=-100) #need to control the device size to
                                    # make things work across computers/screen sizes
# Note: Figure 1 was drawn using Adobe Illustrator so it is not reproduced here.
######################   
# Code 9863 versus 205.1 trends over the decades: Figure 2
con=dbConnect(m,dbname=file.path(.seerHome,"73/all.db"))
#######################################################################
dbListTables(con)
dbListFields(con,"pops")
dbListFields(con,"lymyleuk")
pop=dbGetQuery(con,"SELECT * from pops where popage>5 and popage<19")
head(pop)
(pop<-ddply(pop, .(popage,popsex,popyear), summarise,py=sum(population)))
pop$dec= cut(pop$popyear,breaks=c(1972,1984,1996,2010),labels=c("73to84","85to96","97to10"))
(pop<-ddply(pop, .(popage,popsex,dec), summarise,py=sum(py)))
head(pop,20)

d=dbGetQuery(con, 
    "SELECT * from lymyleuk where histo2=9863 and seqnum<2 and agerec>5 and agerec<19")
head(d)
(d<-ddply(d, .(agerec,sex,yrdx), summarise,cases=length(agerec))) 
d$decade= cut(d$yrdx,breaks=c(1972,1984,1996,2011),labels=c("73to84","85to96","97to10"))
head(d)
(d<-ddply(d, .(agerec,sex,decade), summarise,cases=sum(cases)))
head(cbind(d,pop)) # just to see that they match up
d=cbind(d,py=pop[,"py"]) # only take the non-redundant py column
head(d)

d9=dbGetQuery(con, 
        "SELECT * from lymyleuk where ICD9=2051 and seqnum<2 and agerec>5 and agerec<19")
d9<-ddply(d9, .(sex,agerec,yrdx), summarise,cases=length(agerec))
d9$decade= cut(d9$yrdx,breaks=c(1972,1984,1996,2010),labels=c("73to84","85to96","97to10"))
d9<-ddply(d9, .(agerec,sex,decade), summarise,cases=sum(cases))
d9=cbind(d9,py=pop[,"py"])
head(d9)
(d=cbind(rbind(d,d9),code=gl(2,dim(d9)[1],labels=c("9863","205.1"))) ) 
head(d)
d=transform(d,incid=1e6*cases/py)
d$sex=factor(d$sex,labels=c("Male","Female"))
age=c(0.5,3,seq(7.5,87.5,5))
d$age=age[d$agerec+1]
head(d,15)
names(d)[3]="Decade" # make legend start with capital
(p <- ggplot(d,aes(x=age,y=incid,shape=Decade))+geom_point(size=5)
 + labs(title="CML Incidence",x="Age (years)",
        y=expression(paste("Cases per ",10^6," Person-Years")))    
 + scale_y_log10(limits=c(3,200)) )
(p=p + facet_grid(code ~ sex))
mythem=theme( 
  plot.title = element_text(size = rel(3)),
  axis.title = element_text(size = rel(2.4)),
  axis.text = element_text(size = rel(2)),
  strip.text = element_text(size = rel(2.4))  )
p=p+mythem
(p=p+theme(legend.position = c(.60, .86),  #           legend.direction = 'vertical',
         legend.title = element_text(size = rel(1.4)) ,
  legend.text = element_text(size = rel(1.4))  ) )  

# ggsave(p,file="/users/radivot/igv/trends.wmf")
# ggsave(p,file="/users/radivot/case/grants/sachs/HSCepi/figs/trends.png")

#######################################################################
## CMML Incidence: Figure 3
#######################################################################
con=dbConnect(m,dbname=file.path(.seerHome,"00/all.db"))
d=dbGetQuery(con, 
  "SELECT * from lymyleuk where histo3==9945 and seqnum<2 and agerec>7 and agerec<19")
(d<-ddply(d, .(sex,agerec), summarise,cases=length(agerec))) 
pops=dbGetQuery(con, "SELECT * from pops where popyear>2000 and popage>7 and popage<19")
(pop<-ddply(pops, .(popage,popsex), summarise,py=sum(population)))
d=cbind(d,py=pop[order(pop$popsex),"py"])
d=transform(d,incid=1e6*cases/py) # make it cases per million person years
d$Sex=factor(d$sex,labels=c("Male","Female"))
d$age=age[d$agerec+1]
head(d,15)

summary(mm1<-mle2(cases~dpois(lambda=exp(c+k*age)*py),
                  parameters=list(c~Sex),
                  method="Nelder-Mead",
                  start=list(c=-12,k=0.04),data=d)) 
d$EI=1e6*predict(mm1)/d$py
head(d,15)
(CI2=round(cbind(coef(mm1),confint(mm1)),4)  )
exp(-CI2["c.SexFemale",c(1,3,2)])
mkCIk=function(v) sprintf("k = %4.3f (%4.3f, %4.3f)",v[1],v[2],v[3])
(lab=mkCIk(CI2["k",]))

library(ggplot2)
(p <- ggplot(d,aes(x=age,y=incid,shape=Sex))+geom_point(size=5)
 + labs(title="CMML Incidence: SEER 2000-2010",x="Age (years)",
        y=expression(paste("Cases per ",10^6," Person-Years")))  #  y=expression(frac(Cases,paste(10^6," Person-Years")))) 
 + scale_y_log10(limits=c(0.1,70)) )

(p=p+theme(plot.title = element_text(size = rel(2.4)),
           axis.title = element_text(size = rel(2.4)),
           axis.text = element_text(size = rel(2)))  )
(p=p+theme(legend.position = c(0.8, .2), 
           legend.title = element_text(size = rel(2)) ,
           legend.text = element_text(size = rel(2))  ) )  
(p=p+geom_line(aes(y=EI))) # update just y component of aes

(p=p+annotate("text",x=35,y=70, hjust=0, label = paste("y ~ exp(C+k*age)  C~sex"),size=8 )   )  
(p=p+annotate("text",x=35,y=40,hjust=0,label=lab, size=8))

# ggsave(p,file="/users/radivot/igv/CMML.wmf")
# ggsave(p,file="/users/radivot/case/grants/sachs/HSCepi/figs/CMML.png")



###########################################################################################
# SEER CML versus Race Figure 4
########################################
pops=dbGetQuery(con, "SELECT * from pops where popyear>2000 and popage>5 and popage<19")
head(pops,20)
summary(as.factor(pops$poprace))
pops$poprace[pops$poprace>2]=3
(pop<-ddply(pops, .(popage,popsex,poprace), summarise,py=sum(population)))
head(pop)
d=dbGetQuery(con, 
# ICDO3 CML codes 9875 = bcr-abl+ and 9876 =bcr-abl neg CML are not in full use yet, i.e.
# many ICD-O3 CML codes are still 9863 carried over from ICD-O2
# "SELECT * from lymyleuk where histo3=9876 and seqnum<2 and race<98 and agerec>5 and agerec<19")
"SELECT * from lymyleuk where histo2=9863 and seqnum<2 and race<98 and agerec>5 and agerec<19")
d$race[d$race>2]=3
head(d)
(ddply(d, .(agerec,sex,race), summarise,cases=length(agerec))) #only 5 of the 16s 
count(d, vars=c("agerec","sex","race"))  # same here, and no options to fix it
(d=ddply(d, .(agerec,sex,race), summarise,cases=length(agerec),.drop=F))# this gets them all
head(cbind(d,pop)) # see alignment
d=cbind(d,py=pop[,"py"])
d=transform(d,incid=1e6*cases/py)
head(d,15)
d$Sex=factor(d$sex,labels=c("Male","Female"))
d$race=factor(d$race,labels=c("White","Black","Asian"))
age=c(0.5,3,seq(7.5,87.5,5))
d$age=age[d$agerec+1]
head(d,15)
# ## playing around with stuff like this first
# (s1=summary(m1<-mle2(cases~dpois(lambda=exp(c+k*age)*py),
#                      parameters=list(c~-1+sex:race,k~-1+race),   
#                      method="L-BFGS-B",
#                      lower=c(rep(-15,6),rep(0.01,3)),
#                      upper=c(rep(-10,6),rep(0.05,3)),
#                      start=list(c=-13,k=0.02),
#                      data=d,
#                      control=list(maxit=500,trace=1,parscale=c(rep(13,6),rep(0.03,3)) )
# ) )  )
# I finally found good initial parameter estimates
(s1=summary(m1<-mle2(cases~dpois(lambda=exp(c+k*age)*py),
                     parameters=list(c~-1+Sex:race,k~-1+race),   
                     start=list(c=-13,k=0.02),
                     data=d
) )  )


# This is fine if all we want is k estimates and absolute amplitude params
# But for M/F ratios we need deltaC difference parameters, obtainable as
(sA=summary(mA<-mle2(cases~dpois(lambda=exp(c+k*age)*py),
                     parameters=list(c~-1+race+Sex:race,k~-1+race), # = work to figure out  
                     start=list(c=-4,k=0.02),
                     data=d
) )  )

(cA=confint(mA)) #good  
d$EI=1e6*predict(mA)/d$py
head(d,20) #incidence predictions look reasonable
# d$EI=1e6*as.numeric(predict(mA))/d$py 
# here as.numeric clears .Dimnames in the matrix output of predict()  
# If ggplot gives warnings about rownames being the same, this may help


# And for Tf shifts we need 
(sT=summary(mT<-mle2(cases~dpois(lambda=exp(c+k*(age-Tf))*py),
                     parameters=list(c~-1+race,k~-1+race,Tf~-1+Sex:race),   
                    fixed=list("Tf.SexMale:raceWhite"=0,
                               "Tf.SexMale:raceBlack"=0,
                               "Tf.SexMale:raceAsian"=0),
                     start=list(c=-12,k=0.02,Tf=10),
               control=list(maxit=100,trace=0,parscale=c(rep(-12,3),rep(0.03,3),rep(10,3))),
                     data=d
) )  )
(cT=confint(mT))#but unfortunately, we cannot get Tf CI for Asians or Blacks
d$EIT=1e6*as.numeric(predict(mT))/d$py
head(d,20) #predictions of T model are close to the A model 

# # the next block attempts to reparameterize the T model to get Tf CI 
# # This can be collapsed for now, since I'm not sure if anything will come of it
# #######################
# # try moving it all into Tf
# (sT=summary(mT<-mle2(cases~dpois(lambda=exp(k*(age-Tf))*py),
#                      parameters=list(k~-1+race,Tf~-1+race+sex:race),   
#                     start=list(k=0.02,Tf=100),
#              control=list(maxit=100,trace=0,parscale=c(rep(.03,3),rep(300,3),rep(10,3))),
#                      data=d
# ) )  ) # bad fit, want around 470
# 
# # try controlling IC
# (IC=c("k.raceWhite"=0.04,"k.raceBlack"=0.03,"k.raceAsian"=0.02,
# "Tf.raceWhite"=13/0.04,"Tf.raceBlack"=13/0.04,"Tf.raceAsian"=13/0.02,
# "Tf.raceWhite:sexF"=10,"Tf.raceBlack:sexF"=10,"Tf.raceAsian:sexF"=20) )
# 
# (sT=summary(mT<-mle2(cases~dpois(lambda=exp(k*(age-Tf))*py),
#                      parameters=list(k~-1+race,Tf~-1+race+sex:race),   
#                      start=as.list(IC),
# #                      control=list(maxit=100,trace=0,parscale=IC),
#                      data=d
# ) )  )   
# 
# # => An error messsage that I cannot understand. Time is up, I surrender
# ##################

# Back to the basics: reduce the dimensionality by doing the races separately.

dw=subset(d,race=="White")

# first show no significant difference in k values
summary(mle2(cases~dpois(lambda=exp(c+k*age)*py),method="Nelder-Mead",
                       parameters=list(c~Sex,k~sex),
                       start=list(c=-12,k=0.04),data=dw))

(sw2=summary(mw2<-mle2(cases~dpois(lambda=exp(c+k*(age-Tf))*py),
                       method="Nelder-Mead",
                       parameters=list(Tf~Sex),
                       fixed=list("Tf.(Intercept)"=0),
                       start=list(c=-12,k=0.04,Tf=10),data=dw))     )

(cwT=confint(mw2))
cT    # good to see same answer for white Tf CI



db=subset(d,race=="Black")
summary(mle2(cases~dpois(lambda=exp(c+k*age)*py),method="Nelder-Mead",
             parameters=list(c~Sex,k~sex),
             start=list(c=-12,k=0.04),data=db))


(sb2=summary(mb2<-mle2(cases~dpois(lambda=exp(c+k*(age-Tf))*py),
                       method="Nelder-Mead",
                       parameters=list(Tf~Sex),
                       fixed=list("Tf.(Intercept)"=0),
                       start=list(c=-12,k=0.04,Tf=10),data=db))     )
(cbT=confint(mb2))
cT    # adding all those whites didn't tighten black k and c estimates.
# This is because in Poisson regression, the mean = the variance, so no error 
# estimate improvements result from pooling across races or sexes. Joint fits 
# here thus do more harm than good, as they increase the dimensionality of the
# optimization. The only advantage is that it compacts your codes. 
da=subset(d,race=="Asian")
summary(mle2(cases~dpois(lambda=exp(c+k*age)*py),method="Nelder-Mead",
             parameters=list(c~Sex,k~sex),
             start=list(c=-12,k=0.04),data=da))
# => removal of k dependence on sex throughout was OK

(sa2=summary(ma2<-mle2(cases~dpois(lambda=exp(c+k*(age-Tf))*py),
                       method="Nelder-Mead",
                       parameters=list(Tf~Sex),
                       fixed=list("Tf.(Intercept)"=0),
                       start=list(c=-12,k=0.04,Tf=10),data=da))     )
(caT=confint(ma2))
cT # same finding
# Conclusion: try going to lower dimensions when confint() fails on you

mkCIA=function(v) {v=exp(-v); sprintf("M/F = %4.2f (%4.2f, %4.2f)",v[1],v[3],v[2])}
mkCIT=function(v) sprintf("Tf = %3.1f (%3.1f, %3.1f)",v[1],v[2],v[3])
mkCIk=function(v) sprintf("k = %4.3f (%4.3f, %4.3f)",v[1],v[2],v[3])
(CIA=round(cbind(coef(mA),cA),3))
(AS=apply(CIA[4:6,],1,mkCIA))
(kS=apply(CIA[7:9,],1,mkCIk))
(CIT=cbind(c(coef(mw2)[4],coef(mb2)[4],coef(ma2)[4]),rbind(cwT,cbT,caT)[c(3,6,9),]) )
(TS=apply(CIT,1,mkCIT))

(cnts=ddply(d, .(race), summarise,cases=sum(cases)))
mkCases=function(n) sprintf("%d cases",n)
(cS=sapply(cnts[,2],mkCases))
(labS=c(kS,AS,TS,cS))
# note that capital S at the end of variable name => strings in my codes
(tdf=data.frame(race=rep(c("White","Black","Asian"),4),  #panel
           Sex=rep("Male",12),  # dummy, it wants to know sex of the "points"
           age=c(rep(30,9),rep(40,3)),      #x-coordinate of label
           incid=rep(c(2.5,1.67,1.1,90),each=3),     #y-coordinate of label
           Text=labS,stringsAsFactors = F) )           #label text


graphics.off()
windows(height=6,width=12,xpos=-100,ypos=-100) #need to control the device size to
library(ggplot2)
require(grid) # to avoid "cannot find unit()"
(p <- ggplot(d,aes(x=age,y=incid,shape=Sex)) + geom_point(size=5) 
 + labs(title="CML Incidence by Race, Sex and Age",x="Age",
        y=expression(paste("Cases per ",10^6," Person-Years")))    
 + scale_y_log10(limits=c(1,100)) +xlim(20,90) )
(p=p + facet_grid(. ~ race))
# (p=p+scale_shape_discrete(name = "") )

(p=p+theme(plot.title = element_text(size = rel(2)),
           strip.text = element_text(size = rel(2)),
           axis.title = element_text(size = rel(2)),
           axis.text = element_text(size = rel(2)))  )
(p=p+theme(legend.position = c(0.07, .75),    
            legend.direction = 'vertical',
#            legend.background = element_rect(size=4,color="red"),
#            legend.margin = unit(0, "cm"),
           legend.title = element_text(size = rel(1.5)) ,
           legend.text = element_text(size = rel(1.5))  ) )  
(p=p+geom_line(aes(y=EI))) 
(p=p + geom_text(aes(label=Text), size=6,data=tdf, hjust=0))

# ggsave(p,file="/users/radivot/igv/race.wmf")
# ggsave(p,file="/users/radivot/case/grants/sachs/HSCepi/figs/race.png") 
#####################   END Figure 4

######################   
# 9863 k trends sampled every 5 years: Figure 5
con=dbConnect(m,dbname=file.path(.seerHome,"73/all.db"))
#######################################################################
dbListTables(con)
dbListFields(con,"pops")
dbListFields(con,"lymyleuk")
pop=dbGetQuery(con,"SELECT * from pops where popage>5 and popage<19 and poprace=1")
head(pop)
(pop<-ddply(pop, .(popage,popsex,popyear), summarise,py=sum(population)))
yearS=c("73to77","78to82","83to87","88to92","93to99","00to04","05to10")
pop$Years=cut(pop$popyear,breaks=c(1972,1977,1982,1987,1992,1999,2004,2011),labels=yearS)
(pop<-ddply(pop,.(popage,popsex,Years),summarise,py=sum(py)))
head(pop,20)

d=dbGetQuery(con, 
"SELECT * from lymyleuk where race=1 and histo2=9863 and seqnum<2 and agerec>5 and agerec<19")
# "SELECT * from lymyleuk where race=1 and ICD9=2051 and seqnum<2 and agerec>5 and agerec<19")
head(d)
d<-ddply(d, .(agerec,sex,yrdx), summarise,cases=length(agerec))
d$Years=cut(d$yrdx,breaks=c(1972,1977,1982,1987,1992,1999,2004,2011),labels=yearS)
head(d)
d<-ddply(d, .(agerec,sex,Years), summarise,cases=sum(cases))
head(cbind(d,pop)) # just to see that they match up
d=cbind(d,py=pop[,"py"]) # only take the non-redundant py column
head(d)
d$sex=factor(d$sex,labels=c("Male","Female"))
age=c(0.5,3,seq(7.5,87.5,5))
d$age=age[d$agerec+1]
head(d,15)

# summary(mk<-mle2(cases~dpois(lambda=exp(c+k*age)*py),
#                   parameters=list(c~sex,k~-1+Years),
#                   method="Nelder-Mead",
#                   start=list(c=-12,k=rep(0.05,7)),data=d)) 

years=c(1975,1980,1985,1990,1996,2002,2007)
kic=0.05
k=NULL
kL=NULL
kU=NULL

for (Y in yearS) {
  summary(mk<-mle2(cases~dpois(lambda=exp(c+k*age)*py),
                   parameters=list(c~sex),
                   method="Nelder-Mead",
                   start=list(c=-12,k=kic),data=subset(d,Years==Y))) 
  k=c(k,coef(mk)[3])
  (CIk=round(confint(mk)[3,],4))
  kL=c(kL,CIk[1])
  kU=c(kU,CIk[2])
}
dfk9=data.frame(years,k,kL,kU,Registries="SEER9")

con=dbConnect(m,dbname=file.path(.seerHome,"00/all.db"))
pop=dbGetQuery(con, 
"SELECT * from pops where poprace=1 and popyear>1999 and popage>5 and popage<19")
pop<-ddply(pop, .(popage,popsex,popyear), summarise,py=sum(population))
head(pop,20)
yearS=c("00to01","02to03","04to05","06to07","08to10")
pop$Years=cut(pop$popyear,breaks=c(1999,2001,2003,2005,2007,2011),labels=yearS)
pop<-ddply(pop,.(popage,popsex,Years),summarise,py=sum(py))
head(pop,20)

d=dbGetQuery(con, 
"SELECT * from lymyleuk where race=1 and histo2=9863 and seqnum<2 and agerec>5 and agerec<19")
# "SELECT * from lymyleuk where race=1 and ICD9=2051 and seqnum<2 and agerec>5 and agerec<19")
d<-ddply(d, .(agerec,sex,yrdx), summarise,cases=length(agerec))
d$Years=cut(d$yrdx,breaks=c(1999,2001,2003,2005,2007,2011),labels=yearS)
d<-ddply(d, .(agerec,sex,Years), summarise,cases=sum(cases))
head(cbind(d,pop)) # just to see that they match up
d=cbind(d,py=pop[,"py"])
head(d,15)
d$Sex=factor(d$sex,labels=c("Male","Female"))
age=c(0.5,3,seq(7.5,87.5,5))
d$age=age[d$agerec+1]
head(d,15)

years=c(2001,2003,2005,2007,2009)
kic=0.05
k=NULL
kL=NULL
kU=NULL

for (Y in yearS) {
  summary(mk<-mle2(cases~dpois(lambda=exp(c+k*age)*py),
                   parameters=list(c~sex),
                   method="Nelder-Mead",
                   start=list(c=-12,k=kic),data=subset(d,Years==Y))) 
  k=c(k,coef(mk)[3])
  (CIk=round(confint(mk)[3,],4))
  kL=c(kL,CIk[1])
  kU=c(kU,CIk[2])
}

dfk18=data.frame(years,k,kL,kU,Registries="SEER18")
dfk=rbind(dfk9,dfk18)

windows(height=7,width=8,xpos=-100,ypos=-100)  # set back to square
library(ggplot2)
pd <- position_dodge(1) 
(p=ggplot(dfk, aes(x=years, y=k,shape=Registries)) + 
   geom_point(size=6,position=pd))
(p=p+labs(title="SEER9 1973-2010 and SEER18 2000-2010",x="Year", y="k") )     
(p=p+geom_errorbar(aes(ymin=kL, ymax=kU),width=.01,position=pd))
(p=p+theme(plot.title = element_text(size = rel(2)),
           axis.title = element_text(size = rel(2)),
           axis.text = element_text(size = rel(2)))  )
(p=p+theme(legend.position = c(0.2, .2), 
           legend.title = element_text(size = rel(1.5)) ,
           legend.text = element_text(size = rel(1.5))  ) )  
# ggsave(p,file="/users/radivot/igv/ktrends.wmf")
# ggsave(p,file="/users/radivot/case/grants/sachs/HSCepi/figs/ktrends.png")

###################### End Fig 5 on k trends




# IR-to-CML Wait Figure 6
#####################
cols=c("city","sex","doseg","agexg","calg","kerma","PY","adjPY","num.entering",
       "age","agex","tsx","cal","sv","gam","neut",
       "lymphoma","NHL","leukemia","AML","ALL","CML","ATL","MM")      
d<-read.table(file.path(.aBombHome,"hema87.dat"), header=F,col.names=cols);
d=d[d$adjPY>0,] #remove two recs with zero py
d=d[d$kerma==1,] # take only kerma < 4 Gy
# these two lines can also be done using SQL as follows
# require(sqldf)  # install.packages("sqldf") 
# d=sqldf("select * from d where adjPY>0 and kerma=1") 
d$py=10^4*d$adjPY # add a colum py = person years
wanted=c("city","sex","doseg","agexg","calg","age","agex","tsx","cal","sv","py","CML")      
d=d[,wanted]
names(d)[dim(d)[2]]="cases"
d$Sex=factor(d$sex,labels=c("Male","Female"))
d$city=factor(d$city,labels=c("Hiroshima","Nagasaki"))
(years=c(1951,1953,1956,1959,1963,1968,1973,1978,1983,1987)-1945) 
d$calg=factor(d$calg,labels=years)
head(d)
# sapply(d,class)
log(0.04) #  roughly -3 used to start k, exponentiated below to keep it positive
library(bbmle)
(s1=summary(m1<-mle2(cases~dpois(lambda=(exp(c+exp(k)*age)+sv*exp(f))*py),
                     parameters=list(c~Sex,f~-1+calg:Sex),
                     method="L-BFGS-B",
                     start=list(c=-13,k=-3,f=-15),data=d)
) )

wait=exp(coef(s1)[4:23,1])*1e4
waitL=exp(coef(s1)[4:23,1]-1.96*coef(s1)[4:23,2])*1e4
waitU=exp(coef(s1)[4:23,1]+1.96*coef(s1)[4:23,2])*1e4
dfc=data.frame(years,wait,waitL,waitU,Sex=gl(2,10,labels=c("Male","Female") ) ) 

library(ggplot2)
pd <- position_dodge(1) 
(p=ggplot(dfc, aes(x=years, y=wait, shape=Sex)) + 
   geom_point(size=6,position=pd)+ ylim(0, 10))
(p=p+labs(title="IR-to-CML Latency",x="Years since exposure",
          y=expression(paste("Cases per ",10^4," Person-Year-Sv") ) ) )    
(p=p+geom_errorbar(aes(ymin=waitL, ymax=waitU),width=.01,position=pd))
(p=p+theme(plot.title = element_text(size = rel(2.3)),
           axis.title = element_text(size = rel(2.3)),
           axis.text = element_text(size = rel(2.3)))  )
(p=p+theme(legend.position = c(0.8, .5), 
           legend.title = element_text(size = rel(2)) ,
           legend.text = element_text(size = rel(2))  ) )  

waitm=exp(coef(s1)[4:13,1])
waitf=exp(coef(s1)[14:23,1])
(MovF<-format(sum(waitm)/sum(waitf),digits=2))
pm=waitm/sum(waitm)
pf=waitf/sum(waitf)
(taum<-round(years%*%pm,2))
(tauf<-round(years%*%pf,2))
(p=p+annotate("text",x=25,y=10, hjust=0, label = paste("M/F =",MovF),size=9) )
(lb1=paste0("tau[m] == ",taum,"*~Yrs"))
(p=p+annotate("text",x=25,y=9, hjust=0, label = lb1,size=9,parse=T) )
(lb1=paste0("tau[f] == ",tauf,"*~Yrs"))
(p=p+annotate("text",x=25,y=8, hjust=0, label = lb1,size=9,parse=T) )
# ggsave(p,file="/users/radivot/igv/IR2CML.wmf")
# ggsave(p,file="/users/radivot/case/grants/sachs/HSCepi/figs/IR2CML.png")

# This next block calculates the 95% CI of the difference in waiting times
rdiscrete <- function(n, probs,values) {
  cumprobs <- cumsum(probs)
  singlenumber <- function() {
    x <- runif(1)
    N <- sum(x > cumprobs)
    N
  }
  values[replicate(n, singlenumber())+1]
}
x=rdiscrete(1e5,pf,years)
summary(as.factor(x))
y=rdiscrete(1e5,pm,years)
summary(as.factor(y))
(delT=quantile(x-y,c(0.025,0.975)))
(lb1=paste0("Delta*tau == ",tauf-taum,"(",delT[1],", ",delT[2],")"))
#(lb1=paste0("Delta*tau == ",tauf-taum,"~group(\"(\",",delT[1],",",delT[2],",\")\")")) # attempt with group() failed
(p+annotate("text",x=25,y=7, hjust=0, label = lb1,size=7,parse=T) ) #just show since can't add space before ( 


### Figure 7: interpretations ##############
graphics.off()
windows(height=6,width=6,xpos=-100,ypos=-100) 
k=0.025
Tp=22.1
Rp=1.73
Tf=-15:23
fR=function(Tf) exp(-k*(Tf-Tp))
R=fR(Tf)


par(mar=c(4.5,4.3,0,.5))
plot(Tf,R,type="l",lwd=2.5,cex.lab=1.5,cex.axis=1.5,
     ylab="(male risk)/(female risk) M/F",
     xlab="Extra female latency time T in years",axes=F)
mtext(side=3,line=-4,"Continuum of SEER CML\n Sex Difference Interpretations",cex=1.5,font=2)
axis(1);axis(2)
points(x=c(0,Tp),y=c(Rp,1),pch=1,cex=3,lwd=3)
abline(h=1,v=0,lty=3)
fT=function(R) Tp-log(R)/k
Tx=7
Rx=2.5
points(x=c(fT(Rx),Tx),y=c(Rx,fR(Tx)),pch="+",cex=3)
# plot(1:20,pch=1:20)
x=seq(fT(Rx),Tx,0.1)
y=fR(x)
points(x,y,type="l",lwd=6)
rect(-1,1.13*Rp,23,1.26*Rp,lwd=2)
text(12,1.2*Rp,"interpretations by\n a single cause",cex=1.4,font=2,bty="o")
arrows(x0=0,y0=1.13*Rp,x1=0,y1=Rp+0.05,lwd=2,angle=20)
arrows(x0=Tp,y0=1.13*Rp,x1=Tp,y1=1.05,lwd=2,angle=20)
text(4,1.04*Rp,"higher\nmale\nrisk",cex=1.4,font=2)
text(10,0.96*Rp,"or",cex=1.4,font=2)
text(18,0.9*Rp,"shorter\nmale\nlatency",cex=1.4,font=2)
text(-9,1.53,
     "interpretations\nconsistent with\ntime-since-\nexposure data\n(heavy line)",
     cex=1.4,font=2)
arrows(x0=-8,y0=1.8,x1=-8,y1=fR(-8),lwd=2,angle=20)
text(0.5,1.14,
     "preferred\ninterpretations",
     cex=1.4,font=2,adj=0)
arrows(x0=3,y0=1.23,x1=3,y1=fR(3),lwd=3,angle=20)



########################################################
# Age at exposure: Figure 8
windows(height=7,width=8,xpos=-100,ypos=-100)  

head(d)
d$Dose<-cut(d$sv,c(-1,.02,1,100),labels=c("Low","Moderate","High"))
d$agexc<-cut(d$agex,c(0,20,40,180),labels=c("10","30","50"))
head(d)
library(plyr) 
(d2<-ddply(subset(d,city=="Hiroshima"), .(Dose,Sex,agexc), summarise,
           PY=sum(py),cases=sum(cases),agex=weighted.mean(agex,py) )) #
(d2=within(d2,{incid=1e5*cases/PY}))

library(ggplot2)
(p <- ggplot(d2,aes(x=agex,y=incid,shape=Dose,group=Dose))+geom_point(size=5) +geom_line()
 + labs(title="Hiroshima A-bomb Survivors",x="Age-at-exposure (PY-weighted)",
        y=expression(paste("CML Cases per ",10^5," Person-Years")))    
 + scale_y_log10(limits=c(.5,130)) +xlim(8,52) )
(p=p + facet_grid(. ~ Sex))
(p=p+theme(legend.position = c(0.8, .85), 
           legend.title = element_text(size = rel(2)) ,
           legend.text = element_text(size = rel(1.7))  ) )  

(p=p+theme(plot.title = element_text(size = rel(2.5)),
           strip.text = element_text(size = rel(2)),
           axis.title.y = element_text(size = rel(2.5)),
           axis.title.x = element_text(size = rel(2.3)),
           axis.text = element_text(size = rel(2.3)))  )

# ggsave(p,file="/users/radivot/igv/agex.wmf")
# ggsave(p,file="/users/radivot/case/grants/sachs/HSCepi/figs/agex.png")

# for b test bin up times since exposure in groups of two to make fewer parameters
d$caln=cut(as.integer(d$calg),c(0,2,4,6,8,10),labels=c(7,12,20,30,40))
head(d,10)

(dHM<-ddply(subset(d,Sex=="Male"&city=="Hiroshima"), .(caln,age,agex,sv,py,cases), summarise,
            PY=sum(py),cases=sum(cases),agex=weighted.mean(agex,py) )) #
(s0=summary(m0<-mle2(cases~dpois(lambda=(exp(c+exp(k)*(age-55))+sv*exp(f))*py),
                     parameters=list(f~caln),
                     method="L-BFGS-B",
                     start=list(c=-13,k=-3,f=-15),
                     data=dHM)
) )

(s1=summary(m1<-mle2(cases~dpois(lambda=(exp(c+exp(k)*(age-55))
                                         +exp(-b*abs(agex-30)/28.85)*sv*exp(f))*py),
                     parameters=list(f~caln),
                     method="L-BFGS-B",
                     start=list(c=-13,k=-3,f=-15,b=0.5),
                     data=dHM)
) )

anova(m0,m1) # P=0.03  HM only


# HM and HF together
(dH<-ddply(subset(d,city=="Hiroshima"), .(caln,Sex,age,agex,sv,py,cases), summarise,
           PY=sum(py),cases=sum(cases),agex=weighted.mean(agex,py) )) #

(s0=summary(m0<-mle2(cases~dpois(lambda=(exp(c+exp(k)*(age-55))+sv*exp(f))*py),
                     parameters=list(c~Sex,f~-1+caln:Sex),
                     method="L-BFGS-B",
                     start=list(c=-13,k=-3,f=-15),
                      data=dH)
) )


(s1=summary(m1<-mle2(cases~dpois(lambda=(exp(c+exp(k)*(age-55))
                                         +exp(-b*abs(agex-30)/28.85)*sv*exp(f))*py),
                     parameters=list(c~Sex,f~-1+caln:Sex),
                     method="L-BFGS-B",
                     start=list(c=-13,k=-3,f=-15,b=0.5),
                      data=dH)
) )

# (Hiroshima M and F combined) # mistake in Ver2 of paper: I thought it was cities combined
anova(m0,m1) # P=0.06  


# try cities combined
(dM<-ddply(subset(d,Sex=="Male"), .(caln,age,agex,sv,py,cases), summarise,
            PY=sum(py),cases=sum(cases),agex=weighted.mean(agex,py) )) #
(s0=summary(m0<-mle2(cases~dpois(lambda=(exp(c+exp(k)*(age-55))+sv*exp(f))*py),
                     parameters=list(f~caln),
                     method="L-BFGS-B",
                     start=list(f=-15,c=-15,k=-3),
                     data=dM)
) )

(s1=summary(m1<-mle2(cases~dpois(lambda=(exp(c+exp(k)*(age-55))
                                         +exp(-b*abs(agex-30)/28.85)*sv*exp(f))*py),
                     parameters=list(f~caln),
                     method="L-BFGS-B",
                     start=list(f=-15,c=-13,k=-3,b=0.5),
                     data=dM)
) )

anova(m0,m1) # P=0.279  M across both cities

################### END Figure 7 related calculations

#### Figures 9 and 10 did not involve R 

#######################################################################
## AML Incidence: Figure 11
#######################################################################
con=dbConnect(m,dbname=file.path(.seerHome,"00/all.db"))
d=dbGetQuery(con, 
       "SELECT * from lymyleuk where icd9==2050 and seqnum<2 and agerec>3 and agerec<19")
(d<-ddply(d, .(sex,agerec), summarise,cases=length(agerec))) 
pops=dbGetQuery(con, "SELECT * from pops where popyear>2000 and popage>3 and popage<19")
(pop<-ddply(pops, .(popage,popsex), summarise,py=sum(population)))
d=cbind(d,py=pop[order(pop$popsex),"py"])
d=transform(d,incid=1e5*cases/py) # make it cases per million person years
d$Sex=factor(d$sex,labels=c("Male","Female"))
d$age=age[d$agerec+1]
head(d,15)

library(ggplot2)
(p <- ggplot(d,aes(x=age,y=incid,shape=Sex))+geom_point(size=5)
 + labs(title="AML Incidence: SEER 2000-2010",x="Age (years)",
        y=expression(paste("Cases per ",10^5," Person-Years")))  #  y=expression(frac(Cases,paste(10^6," Person-Years")))) 
 + scale_y_log10(limits=c(0.7,30)) )

(p=p+theme(plot.title = element_text(size = rel(2.4)),
           axis.title = element_text(size = rel(2.4)),
           axis.text = element_text(size = rel(2)))  )
(p=p+theme(legend.position = c(0.8, .2), 
           legend.title = element_text(size = rel(2)) ,
           legend.text = element_text(size = rel(2))  ) )  

# ggsave(p,file="/users/radivot/igv/AML.wmf")
# ggsave(p,file="/users/radivot/case/grants/sachs/HSCepi/figs/AML.png")



####################################### End paper
# The following figure was taken out because it was redundant with the race figure
#############################
# CML Incidence in SEER 2000-2009 (parallel lines) 
##############################
con=dbConnect(m,dbname=file.path(.seerHome,"00/all.db"))
d=dbGetQuery(con, 
"SELECT * from lymyleuk where histo2=9863 and seqnum<2 and agerec>5 and agerec<19")
"SELECT * from lymyleuk where histo3=9876 and seqnum<2 and agerec>5 and agerec<19")
(d<-ddply(d, .(agerec,sex), summarise,cases=length(agerec))) 
pops=dbGetQuery(con, "SELECT * from pops where popyear>2000 and popage>5 and popage<19")
(pop<-ddply(pops, .(popage,popsex), summarise,py=sum(population)))
d=cbind(d,py=pop[,"py"])
d=transform(d,incid=1e6*cases/py)
head(d,15)
d$sex=factor(d$sex,labels=c("M","F"))
age=c(0.5,3,seq(7.5,87.5,5))
d$age=age[d$agerec+1]
head(d,15)

summary(m0<-mle2(cases~dpois(lambda=exp(c+k*age)*py),
                 parameters=list(c~sex,k~sex),   # see that slopes do not depend on sex
                 method="Nelder-Mead",
                 start=list(c=-12,k=0.04),data=d))

summary(m1<-mle2(cases~dpois(lambda=exp(c+k*age)*py),
                 parameters=list(c~sex),
                 method="Nelder-Mead",
                 start=list(c=-12,k=0.04),data=d)) 
anova(m0,m1)  # => reject null that extra param carries more than noise
d$EI=1e6*predict(m1)/d$py
head(d,15)
(CIA=round(cbind(coef(m1),confint(m1)),4)  )

# reparameterizing the model to get the delay time Tf for females
(s2=summary(m2<-mle2(cases~dpois(lambda=exp(c+k*(age-Tf))*py),
                     method="Nelder-Mead",
                     parameters=list(Tf~sex),
                     fixed=list("Tf.(Intercept)"=0),
                     start=list(c=-12,k=0.04,Tf=10),data=d))     )
coef(s2)
coef(m2)


AICtab(m0,m1,m2)  # should be no difference with m1, it's just a reparameterization
(CIT=round(cbind(coef(s2)[,1],confint(m2)),4)  )

mkCIA=function(v) {v=exp(-v); sprintf("M/F = %4.2f (%4.2f, %4.2f)",v[1],v[3],v[2])}
mkCIT=function(v) sprintf("Tf = %3.1f (%3.1f, %3.1f)",v[1],v[2],v[3])

(p <- ggplot(d,aes(x=age,y=incid,shape=sex))+geom_point(size=5)
 + labs(title="CML Incidence: SEER 2000-2010",x="Age (years)",
        y=expression(frac(Cases,paste(10^6," Person-Years")))) 
 + scale_y_log10(limits=c(3,100)) )
(p=p+theme(title = element_text(size = rel(2)),axis.text = element_text(size = rel(2)))  )
(p=p+geom_line(aes(y=EI))) # update just y component of aes
(p=p+annotate("text",x=30,y=100, hjust=0, label = paste("y ~ exp(c+k*age)  c~sex"),size=7 )   )  
(p=p+annotate("text",x=30,y=80,hjust=0,label=mkCIk(CIA["k",]), size=6))
(p=p+annotate("text",x=30,y=65,hjust=0,label=mkCIA(CIA["c.sexF",]), size=6 )   )  
(p=p+annotate("text",x=30,y=47, hjust=0, label = paste("y ~ exp(c+k*(age-Tf))"),size=7)   )  
(p=p+annotate("text",x=30,y=37,hjust=0, label=mkCIT(CIT["Tf.sexF",]), size=6))
# ggsave(p,file="/users/radivot/case/grants/sachs/HSCepi/figs/CML.wmf")

###########################################################
# This section explores CML ICD-O3 codes in whites as 9863, 9875 (ba+) and 9876 (ba-)
con=dbConnect(m,dbname=file.path(.seerHome,"00/all.db"))
pop=dbGetQuery(con, 
     "SELECT * from pops where poprace=1 and popyear>1999 and popage>9 and popage<19")
pop<-ddply(pop, .(popage,popsex,popyear), summarise,py=sum(population),.drop=F)
head(pop,20)
yearS=c("01to03","04to05","06to07","08to10")
pop$Years=cut(pop$popyear,breaks=c(1999,2003,2005,2007,2011),labels=yearS)
pop<-ddply(pop,.(popage,popsex,Years),summarise,py=sum(py),.drop=F)
head(pop,20)
dim(pop)

d=dbGetQuery(con, 
# "SELECT * from lymyleuk where race=1 and ICD9=2051 and
#              seqnum<2 and agerec>9 and agerec<19")
# "SELECT * from lymyleuk where race=1 and histo2=9863 and
#               seqnum<2 and agerec>9 and agerec<19")
# "SELECT * from lymyleuk where race=1 and 
#              ((histo3=9863) or (histo3=9876) or (histo3=9875)) and
#              seqnum<2 and agerec>9 and agerec<19")
# "SELECT * from lymyleuk where race=1 and 
#              (histo3=9863 or histo3=9875) and
#              seqnum<2 and agerec>9 and agerec<19")
# "SELECT * from lymyleuk where race=1 and histo3=9875 and
# seqnum<2 and agerec>9 and agerec<19")
# "SELECT * from lymyleuk where race=1 and histo3=9945 and
# seqnum<2 and agerec>9 and agerec<19")
d<-ddply(d, .(agerec,sex,yrdx), summarise,cases=length(agerec),.drop=F)
sum(d$cases)  #2970 icdo2 9863 cases is same as icdO3 9863+9875+9876
# of the latter, 2425 are 9863, 507 are 9875 and only 38 are 9876  
d$Years=cut(d$yrdx,breaks=c(1999,2003,2005,2007,2011),labels=yearS)
d<-ddply(d, .(agerec,sex,Years), summarise,cases=sum(cases),.drop=F)
head(cbind(d,pop)) # just to see that they match up
d=cbind(d,py=pop[,"py"])
head(d,15)
d$Sex=factor(d$sex,labels=c("Male","Female"))
age=c(0.5,3,seq(7.5,87.5,5))
d$age=age[d$agerec+1]
head(d,15)
years=c(2002,2005,2007,2009)
kic=0.05
c=k=NULL
cL=kL=NULL
cU=kU=NULL
for (Y in yearS) {
  summary(mk<-mle2(cases~dpois(lambda=exp(c+k*(age-65))*py),
                   parameters=list(c~sex),
                   method="Nelder-Mead",
                   start=list(c=-12,k=kic),data=subset(d,Years==Y))) 
  k=c(k,coef(mk)[3])
  c=c(c,coef(mk)[1])
  CI=confint(mk)
  (CIk=round(CI[3,],4))
  (CIc=round(CI[1,],4))
  kL=c(kL,CIk[1])
  kU=c(kU,CIk[2])
  cL=c(cL,CIc[1])
  cU=c(cU,CIc[2])
}
data.frame(years,c,cL,cU)
data.frame(years,k,kL,kU)

# 9876 = ba neg
# > data.frame(years,k,kL,kU)
# years          k      kL     kU
# 1  2002 0.04739624  0.0042 0.0918
# 2  2005 0.11644800  0.0455 0.2098
# 3  2007 0.06525722  0.0131 0.1207
# 4  2009 0.04218057 -0.0077 0.0926

# 9875 = ba + 
# years           k      kL     kU
# 1  2002 0.012260690 -0.0035 0.0276
# 2  2005 0.009064363 -0.0086 0.0234
# 3  2007 0.007569936 -0.0078 0.0245
# 4  2009 0.004961402 -0.0077 0.0165

# so bcr-abl negative CML's do have a larger k/aging rate constant, 
# but since we used icdo2 9863, this cannot explain the ongoing drops in k
